/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __APPLICATION_HANDLER_H
#define __APPLICATION_HANDLER_H

#include "object.h"
#include "container.chain.h"

namespace magnum { namespace application {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Chainable;

class Message;
class Messenger;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Handler : public Object, private Chainable<Handler> {
DeclareClass(Handler, Object);
friend class Messenger;
private:
	Messenger*			m_Messenger;

public:
	inline Handler();
	inline ~Handler();
	
	inline Messenger*	getMessenger() const;
	
	inline bool			handleMessage(const Message& msg);

protected:
	virtual bool		onHandleMessage(const Message& msg);
};

}; };

#endif
