/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __APPLICATION_LISTENER_INL
#define __APPLICATION_LISTENER_INL

namespace magnum { namespace application {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ListenerList::~ListenerList() {
	clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	ListenerList::insert(Listener *listener) {
	m_Listeners.insert(listener);
	listener->m_Lists.insert(this);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	ListenerList::remove(Listener *listener) {
	m_Listeners.remove(listener);
	listener->m_Lists.remove(this);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int	ListenerList::getSize() const {
	return m_Listeners.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool ListenerList::isEmpty() const {
	return m_Listeners.isEmpty();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ListenerList::Iterator ListenerList::begin() const {
	return m_Listeners.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ListenerList::Iterator ListenerList::end() const {
	return m_Listeners.end();
}

}; };

#endif
