/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __AUDIO3D_CONTEXT_H
#define __AUDIO3D_CONTEXT_H

#include "object.pointer.h"
#include "audio3d.device.h"

namespace magnum { namespace audio3d {
using magnum::object::Object;
using magnum::object::Pointer;
using magnum::types::String;

class Listener;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Context : public Object {
DeclareClass(Context, Object);
friend class Device;
friend class Listener;
private:
	static Context*			g_Current;

	Pointer<Device>			m_Device;
	Pointer<Listener>		m_Listener;
	ALCcontext*				m_Context;

private:
	Context();

public:
	~Context();

	inline static Context*	getCurrent();
	inline bool				makeCurrent();

	inline Device*			getDevice() const;
	inline Listener*		getListener() const;

	inline void				process();
	inline void				suspend();

private:
	static Context*			searchCurrent();
	static Context*			createCurrent();
};

}; };

#endif
