/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __AUDIO3D_LISTENER_INL
#define __AUDIO3D_LISTENER_INL

namespace magnum { namespace audio3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Listener::select() {
	m_Context = Context::getCurrent();
	m_Context->m_Listener = this;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Listener::setPosition(const Vector3<float>& v) {
	m_Position = v;
	if ((m_Context != NULL) && (m_Context->m_Listener == this))
		alListenerfv(AL_POSITION, (float*)m_Position);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Listener::setPosition(float x,float y,float z) {
	m_Position.x = x;
	m_Position.y = y;
	m_Position.z = z;
	if ((m_Context != NULL) && (m_Context->m_Listener == this))
		alListenerfv(AL_POSITION, (float*)m_Position);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& Listener::getPosition() const {
	return m_Position;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Listener::setVelocity(const Vector3<float>& v) {
	m_Velocity = v;
	if ((m_Context != NULL) && (m_Context->m_Listener == this))
		alListenerfv(AL_VELOCITY, (float*)m_Velocity);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Listener::setVelocity(float x,float y,float z) {
	m_Velocity.x = x;
	m_Velocity.y = y;
	m_Velocity.z = z;
	if ((m_Context != NULL) && (m_Context->m_Listener == this))
		alListenerfv(AL_VELOCITY, (float*)m_Velocity);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& Listener::getVelocity() const {
	return m_Velocity;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Listener::setOrientation(const Vector3<float>& ) {

}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Listener::setOrientation(float ,float ,float ) {

}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& Listener::getOrientation() const {
	m_Orientation;
}


}; };

#endif
