/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __AUDIO3D_SOURCE_H
#define __AUDIO3D_SOURCE_H

#include "math.vector3.h"
#include "audio3d.buffer.h"

namespace magnum { namespace audio3d {
using magnum::object::Object;
using magnum::types::String;
using magnum::math::Vector3;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Source : public Object {
DeclareClass(Source, Object);
private:
	unsigned int		m_Source;

public:
	Source();
	~Source();

	inline void			setPosition(const Vector3<float>& );
	inline void			setPosition(float ,float ,float );
	inline Vector3<float> getPosition() const;

	inline void			setVelocity(const Vector3<float>& );
	inline void			setVelocity(float ,float ,float );
	inline Vector3<float> getVelocity() const;

	inline void			pause();
	inline void			play();
	inline void			stop();
	inline void			rewind();
			
	inline void			queue(Buffer* );
	inline void			unqueue(Buffer* );
						
	inline void			queue(const BufferList& );
	inline void			unqueue(const BufferList& );
};

}; };

#endif
