/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __CONTAINER_PAIR_H
#define __CONTAINER_PAIR_H

#include "base.h"

namespace magnum { namespace container {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T1, class T2> class Pair {
public:
	T1			first;
	T2			second;

public:
	inline Pair();
	inline Pair(const T1& , const T2& );

	inline bool operator==(const Pair& ) const;
	inline bool operator!=(const Pair& ) const;
	inline bool operator<=(const Pair& ) const;
	inline bool operator<(const Pair& ) const;
	inline bool operator>=(const Pair& ) const;
	inline bool operator>(const Pair& ) const;
};

}; };

#endif
