/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __FREETYPE_GLYPH_INL
#define __FREETYPE_GLYPH_INL

namespace magnum { namespace freetype {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Glyph::setLocation(const Rectangle<int>& r) {
	m_Location = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Glyph::setLocation(int x, int y, int w, int h) {
	m_Location.setX(x);
	m_Location.setY(y);
	m_Location.setWidth(w);
	m_Location.setHeight(h);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Glyph::setSize(const Dimension<float>& s) {
	m_Size = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Glyph::setSize(float w, float h) {
	m_Size.setWidth(w);
	m_Size.setHeight(h);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Glyph::setBearing(const Point<float>& s) {
	m_Bearing = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Glyph::setBearing(float x, float y) {
	m_Bearing.setX(x);
	m_Bearing.setY(y);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Dimension<float>& Glyph::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Glyph::getWidth() const {
	return m_Size.getWidth();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Glyph::getHeight() const {
	return m_Size.getWidth();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Rectangle<int>& Glyph::getLocation() const {
	return m_Location;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Point<float>& Glyph::getBearing() const {
	return m_Bearing;
}


}; };

#endif
