/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __FREETYPE_LIBRARY_H
#define __FREETYPE_LIBRARY_H

#include "ft2build.h"
#include FT_FREETYPE_H

#include "system.mutex.h"

namespace magnum { namespace freetype {
using magnum::object::Object;
using magnum::types::String;
using magnum::system::Mutex;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Library : public Object {
DeclareClass(Library, Object);
private:
	class Startup {
	public:
		Startup();
		~Startup();
	};

	friend class Startup;

	static Startup			g_Startup;
	static FT_Library		m_Library;
	static Mutex			m_Mutex;

public:
	static inline FT_Library	lock();
	static inline void			unlock();
};

}; };

#endif
