/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __FREETYPE_RENDERER_H
#define __FREETYPE_RENDERER_H

#include "object.h"
#include "graphics.point.h"

namespace magnum { namespace freetype {
using magnum::object::Object;
using magnum::object::Pointer;
using magnum::types::String;
using magnum::graphics::Point;

class Font;
class Glyph;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> Renderer : public Object {
DeclareClass(Renderer, Object);
public:
	enum ColourCode {
		Gray			= 0,
		Red				= 1,
		Green			= 2,
		Yellow			= 3,
		Blue			= 4,
		Magenta			= 5,
		Cyan			= 6,
		White			= 7,
		Reset			= 255,
	};
	
private:
	Pointer<Font>			m_Font;
	Dimension<float>		m_Size;
	float					m_Tabsize;
	
public:
	void					selectFont(Font* );
	inline void				deselectFont();
	inline Font*			getFont() const;

	Dimension<float>		getSize(char );
	Dimension<float>		getSize(const char* );
	
	void					renderString(const Point<float>& ,const char* );

protected:
	void					onLocation(const Point<float>& );
	void					onMove(const Point<float>& );
	void					onRender(const Point<float>& ,const Glyph& );
	void					onColour(ColourCode );
};

}; };

#endif
