/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GEOMETRY_CYLINDER_INL
#define __GEOMETRY_CYLINDER_INL

namespace magnum { namespace geometry {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline Cylinder3<T>::Cylinder3() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline Cylinder3<T>::Cylinder3(const Vector3<T>& o, const Vector3<T>& d, const T& r) {
	m_Origin = o;
	m_Direction = d;
	m_Radius = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Cylinder3<T>::setOrigin(const Vector3<T>& v) {
	m_Origin = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline const Vector3<T>& Cylinder3<T>::getOrigin() const {
	return m_Origin;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Cylinder3<T>::setDirection(const Vector3<T>& v) {
	m_Direction = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline const Vector3<T>& Cylinder3<T>::getDirection() const {
	return m_Direction;
}

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Cylinder3<T>::setRadius(const T& r) {
	m_Radius = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline T Cylinder3<T>::getRadius() const {
	return m_Radius;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Cylinder3<T>::setLength(const T& l) {
	m_Direction *= l / m_Direction.length();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline T Cylinder3<T>::getLength() const {
	return m_Direction.length();
}


}; };

#endif
