/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS_COLOUR_H
#define __GRAPHICS_COLOUR_H

#include "base.h"

namespace magnum { namespace graphics {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Colour {
public:
	T		R,G,B,A;

public:
	inline Colour();
	inline Colour(T r,T g,T b, T alpha=0);

	inline Colour 		operator+ (const Colour &c) const;
	inline Colour 		operator- (const Colour &c) const;
	inline const Colour& operator+=(const Colour &c);
	inline const Colour& operator-=(const Colour &c);
	inline bool			operator==(const Colour &c) const;
	inline bool			operator!=(const Colour &c) const;

	inline				operator const T*() const;
};


#if defined(__FORX11__)
inline unsigned int colourToX11(const Colour<byte>& );
#endif


}; };
#endif
