/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS_DIMENSION_H
#define __GRAPHICS_DIMENSION_H

#include "base.h"

namespace magnum { namespace graphics {

template<class T> class Rectangle;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Dimension  {
friend class Rectangle<T>;
public:
	T					width;
	T					height;

public:
	inline Dimension();
	inline Dimension(const T& ,const T& );

	inline void			setWidth(const T& );
	inline void			setHeight(const T& );
	inline T			getWidth() const;
	inline T			getHeight() const;

	inline const Dimension& operator=(const Dimension& );

	inline bool 		operator==(const Dimension& ) const;
	inline bool 		operator!=(const Dimension& ) const;
	inline bool 		operator>=(const Dimension& ) const;
	inline bool 		operator<=(const Dimension& ) const;
	inline bool 		operator>(const Dimension& ) const;
	inline bool 		operator<(const Dimension& ) const;

	inline Dimension 	operator+(const Dimension& ) const;
	inline Dimension 	operator-(const Dimension& ) const;

	inline const Dimension& operator+=(const Dimension& );
	inline const Dimension& operator-=(const Dimension& );

	template<class S>
	inline operator Dimension<S>() const;
};


}; };
#endif
