/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS_POLYGON_INL
#define __GRAPHICS_POLYGON_INL


namespace magnum { namespace graphics {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Polygon<T>::addVertex(const Point<T>& v) {
	m_Vertices.insert(v);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Polygon<T>::removeVertex(const Point<T>& v) {
	int i;
	for (i = 0; i < m_Vertices.getSize(); i++)
		if (m_Vertices[i] == v)
			removeVertex(i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Polygon<T>::removeVertex(int m) {
	m_Vertices.remove(m);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline Point<T> Polygon<T>::getVertex(int m) const {
	return m_Vertices[m];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline int Polygon<T>::getSize() const {
	return m_Vertices.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline Point<T>& Polygon<T>::operator[](int n) {
	return m_Vertices[n];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline Point<T> Polygon<T>::operator[](int n) const {
	return m_Vertices[n];
}


}; };


#endif
