/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS_TRANSLATOR_H
#define __GRAPHICS_TRANSLATOR_H

#include "graphics.translator.bmp.h"
#include "graphics.translator.dds.h"
#include "graphics.translator.gif.h"
#include "graphics.translator.jpg.h"
#include "graphics.translator.pcx.h"
#include "graphics.translator.png.h"
#include "graphics.translator.tga.h"
#include "graphics.translator.tiff.h"


namespace magnum { namespace graphics {
using magnum::object::Object;
using magnum::types::String;
using magnum::io::File;
using magnum::io::InputStream;
using magnum::io::OutputStream;
using magnum::io::Translator;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class TranslatorRoster : public magnum::io::TranslatorRoster<Image> {
private:
	TranslatorBMP		m_TranslatorBMP;
	TranslatorDDS		m_TranslatorDDS;
	TranslatorGIF		m_TranslatorGIF;
	TranslatorJPG		m_TranslatorJPG;
	TranslatorPCX		m_TranslatorPCX;
	TranslatorPNG		m_TranslatorPNG;
	TranslatorTGA		m_TranslatorTGA;
	TranslatorTIFF		m_TranslatorTIFF;

public:
	TranslatorRoster();
	~TranslatorRoster();
};


}; };

#endif
