/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_APPEARANCE_H
#define __GRAPHICS3D_APPEARANCE_H

#include "object.pointer.h"
#include "graphics3d.texture.h"

namespace magnum { namespace graphics3d {
using magnum::object::Pointer;

class Shader;
class Material;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Appearance : public Resource {
DeclareClass(Appearance, Resource);
private:
	Pointer<Material>		m_Material;
	Pointer<Texture>		m_Texture[Texture::MaxTextures];
	Pointer<Shader>			m_Shader;

public:
	void				select() const;
	void				deselect() const;
	void				forceSelect() const;
	static inline void	selectNone();

	inline void			attachTexture(Texture*, unsigned int stage=0);
	inline void			detachTexture(unsigned int stage=0);
	inline Texture*		getTexture(unsigned int stage=0) const;
	
	inline Material*	getMaterial() const;
	inline void			attachMaterial(Material* );
	inline void			detachMaterial();

	inline Shader*		getShader() const;
	inline void			attachShader(Shader* );
	inline void			detachShader();

};


}; };

#endif
