#ifndef __GRAPHICS3D_CONSTANT_INL
#define __GRAPHICS3D_CONSTANT_INL


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ConstantList::ConstantList() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ConstantList::clear() {
	m_Constants.clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int ConstantList::getSize() const {
	return m_Constants.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const ConstantList& ConstantList::operator=(const ConstantList& fmt) {
	m_Constants = fmt.m_Constants;
	return *this;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ConstantList::Iterator ConstantList::begin() const {
	return m_Constants.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ConstantList::Iterator ConstantList::end() const {
	return m_Constants.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ConstantList::shrink() {
	m_Constants.shrink();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ConstantList::append(const ConstantList& fmt) {
	m_Constants.append(fmt.m_Constants);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ConstantList::add(Constant* c) {
	m_Constants.insert(c);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool ConstantList::contains(Constant* c) const {
	return m_Constants.contains(c);
}


}; };

#endif
