/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_DIRLIGHT_INL
#define __GRAPHICS3D_DIRLIGHT_INL


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline DirectionalLight::DirectionalLight() {
	m_Direction = Vector3<float>(0.0f,0.0f,0.0f);
	m_Ambient = Colour<float>(0.1f,0.1f,0.1f);
	m_Diffuse = Colour<float>(1.0f,1.0f,1.0f);
	m_Specular = Colour<float>(1.0f,1.0f,1.0f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& DirectionalLight::getAmbient() const {
	return m_Ambient;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void DirectionalLight::setAmbient(const Colour<float>& c) {
	m_Ambient = c;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& DirectionalLight:: getDiffuse() const {
	return m_Diffuse;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void DirectionalLight::setDiffuse(const Colour<float>& d) {
	m_Diffuse = d;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& DirectionalLight::getSpecular() const {
	return m_Specular;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void DirectionalLight::setSpecular(const Colour<float>& c) {
	m_Specular = c;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& DirectionalLight::getDirection() const {	
	return m_Direction;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void DirectionalLight::setDirection(const Vector3<float>& p) {
	m_Direction = p;
}


}; };

#endif
