/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_EXTENSIONS_H
#define __GRAPHICS3D_EXTENSIONS_H

#include "object.h"
#include "graphics3d.opengl.h"

namespace magnum { namespace graphics3d {
using magnum::object::Object;
using magnum::types::String;

class Context;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Extensions : public Object {
DeclareClass(Extensions, Object);
friend Context;
private:
	static bool		g_GlobalInit;
	const char*		m_Extensions;

private:
	Extensions();
	void			getExtensions();

public:
	void			select();
	bool			isSupported(const char* );

	#ifdef GL_ARB_multitexture
	PFNGLACTIVETEXTUREARBPROC			glActiveTextureARB;
	PFNGLCLIENTACTIVETEXTUREARBPROC		glClientActiveTextureARB;
										
	PFNGLMULTITEXCOORD1DARBPROC			glMultiTexCoord1dARB;
	PFNGLMULTITEXCOORD1DVARBPROC		glMultiTexCoord1dvARB;
	PFNGLMULTITEXCOORD1FARBPROC			glMultiTexCoord1fARB;
	PFNGLMULTITEXCOORD1FVARBPROC		glMultiTexCoord1fvARB;
	PFNGLMULTITEXCOORD1IARBPROC			glMultiTexCoord1iARB;
	PFNGLMULTITEXCOORD1IVARBPROC		glMultiTexCoord1ivARB;
	PFNGLMULTITEXCOORD1SARBPROC			glMultiTexCoord1sARB;
	PFNGLMULTITEXCOORD1SVARBPROC		glMultiTexCoord1svARB;
										
	PFNGLMULTITEXCOORD2DARBPROC			glMultiTexCoord2dARB;
	PFNGLMULTITEXCOORD2DVARBPROC		glMultiTexCoord2dvARB;
	PFNGLMULTITEXCOORD2FARBPROC			glMultiTexCoord2fARB;
	PFNGLMULTITEXCOORD2FVARBPROC		glMultiTexCoord2fvARB;
	PFNGLMULTITEXCOORD2IARBPROC			glMultiTexCoord2iARB;
	PFNGLMULTITEXCOORD2IVARBPROC		glMultiTexCoord2ivARB;
	PFNGLMULTITEXCOORD2SARBPROC			glMultiTexCoord2sARB;
	PFNGLMULTITEXCOORD2SVARBPROC		glMultiTexCoord2svARB;
										
	PFNGLMULTITEXCOORD3DARBPROC			glMultiTexCoord3dARB;
	PFNGLMULTITEXCOORD3DVARBPROC		glMultiTexCoord3dvARB;
	PFNGLMULTITEXCOORD3FARBPROC			glMultiTexCoord3fARB;
	PFNGLMULTITEXCOORD3FVARBPROC		glMultiTexCoord3fvARB;
	PFNGLMULTITEXCOORD3IARBPROC			glMultiTexCoord3iARB;
	PFNGLMULTITEXCOORD3IVARBPROC		glMultiTexCoord3ivARB;
	PFNGLMULTITEXCOORD3SARBPROC			glMultiTexCoord3sARB;
	PFNGLMULTITEXCOORD3SVARBPROC		glMultiTexCoord3svARB;
										
	PFNGLMULTITEXCOORD4DARBPROC			glMultiTexCoord4dARB;
	PFNGLMULTITEXCOORD4DVARBPROC		glMultiTexCoord4dvARB;
	PFNGLMULTITEXCOORD4FARBPROC			glMultiTexCoord4fARB;
	PFNGLMULTITEXCOORD4FVARBPROC		glMultiTexCoord4fvARB;
	PFNGLMULTITEXCOORD4IARBPROC			glMultiTexCoord4iARB;
	PFNGLMULTITEXCOORD4IVARBPROC		glMultiTexCoord4ivARB;
	PFNGLMULTITEXCOORD4SARBPROC			glMultiTexCoord4sARB;
	PFNGLMULTITEXCOORD4SVARBPROC		glMultiTexCoord4svARB;
	#endif								
										
										
	#ifdef GL_ARB_occlusion_query		
	PFNGLGENQUERIESARBPROC				glGenQueriesARB;
	PFNGLDELETEQUERIESARBPROC			glDeleteQueriesARB;
	PFNGLISQUERYARBPROC					glIsQueryARB;
	PFNGLBEGINQUERYARBPROC				glBeginQueryARB;
	PFNGLENDQUERYARBPROC				glEndQueryARB;
	PFNGLGETQUERYIVARBPROC				glGetQueryivARB;
	PFNGLGETQUERYOBJECTIVARBPROC		glGetQueryObjectivARB;
	PFNGLGETQUERYOBJECTUIVARBPROC		glGetQueryObjectuivARB;
	#endif


	#ifdef GL_ARB_shader_objects
	PFNGLDELETEOBJECTARBPROC			glDeleteObjectARB;
	PFNGLGETHANDLEARBPROC				glGetHandleARB;
	PFNGLDETACHOBJECTARBPROC			glDetachObjectARB;
	PFNGLCREATESHADEROBJECTARBPROC		glCreateShaderObjectARB;
	PFNGLSHADERSOURCEARBPROC			glShaderSourceARB;
	PFNGLCOMPILESHADERARBPROC			glCompileShaderARB;
	PFNGLCREATEPROGRAMOBJECTARBPROC		glCreateProgramObjectARB;
	PFNGLATTACHOBJECTARBPROC			glAttachObjectARB;
	PFNGLLINKPROGRAMARBPROC				glLinkProgramARB;
	PFNGLUSEPROGRAMOBJECTARBPROC		glUseProgramObjectARB;
	PFNGLVALIDATEPROGRAMARBPROC			glValidateProgramARB;
										
	PFNGLUNIFORM1FARBPROC				glUniform1fARB;
	PFNGLUNIFORM2FARBPROC				glUniform2fARB;
	PFNGLUNIFORM3FARBPROC				glUniform3fARB;
	PFNGLUNIFORM4FARBPROC				glUniform4fARB;
										
	PFNGLUNIFORM1IARBPROC				glUniform1iARB;
	PFNGLUNIFORM2IARBPROC				glUniform2iARB;
	PFNGLUNIFORM3IARBPROC				glUniform3iARB;
	PFNGLUNIFORM4IARBPROC				glUniform4iARB;
										
	PFNGLUNIFORM1FVARBPROC				glUniform1fvARB;
	PFNGLUNIFORM2FVARBPROC				glUniform2fvARB;
	PFNGLUNIFORM3FVARBPROC				glUniform3fvARB;
	PFNGLUNIFORM4FVARBPROC				glUniform4fvARB;
										
	PFNGLUNIFORM1IVARBPROC				glUniform1ivARB;
	PFNGLUNIFORM2IVARBPROC				glUniform2ivARB;
	PFNGLUNIFORM3IVARBPROC				glUniform3ivARB;
	PFNGLUNIFORM4IVARBPROC				glUniform4ivARB;
										
	PFNGLUNIFORMMATRIX2FVARBPROC		glUniformMatrix2fvARB;
	PFNGLUNIFORMMATRIX3FVARBPROC		glUniformMatrix3fvARB;
	PFNGLUNIFORMMATRIX4FVARBPROC		glUniformMatrix4fvARB;

	PFNGLGETOBJECTPARAMETERFVARBPROC	glGetObjectParameterfvARB;
	PFNGLGETOBJECTPARAMETERIVARBPROC	glGetObjectParameterivARB;
	PFNGLGETINFOLOGARBPROC				glGetInfoLogARB;
	PFNGLGETATTACHEDOBJECTSARBPROC		glGetAttachedObjectsARB;
	PFNGLGETUNIFORMLOCATIONARBPROC		glGetUniformLocationARB;
	PFNGLGETACTIVEUNIFORMARBPROC		glGetActiveUniformARB;
	PFNGLGETUNIFORMFVARBPROC			glGetUniformfvARB;
	PFNGLGETUNIFORMIVARBPROC			glGetUniformivARB;
	PFNGLGETSHADERSOURCEARBPROC			glGetShaderSourceARB;
	#endif


	#ifdef GL_ARB_texture_compression
	PFNGLCOMPRESSEDTEXIMAGE1DARBPROC    glCompressedTexImage1DARB;
	PFNGLCOMPRESSEDTEXIMAGE2DARBPROC    glCompressedTexImage2DARB;
	PFNGLCOMPRESSEDTEXIMAGE3DARBPROC    glCompressedTexImage3DARB;
	PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC glCompressedTexSubImage1DARB;
	PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC glCompressedTexSubImage2DARB;
	PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC glCompressedTexSubImage3DARB;
	PFNGLGETCOMPRESSEDTEXIMAGEARBPROC   glGetCompressedTexImageARB;
	#endif


	#ifdef GL_ARB_transpose_matrix
	PFNGLLOADTRANSPOSEMATRIXFARBPROC	glLoadTransposeMatrixfARB;
	PFNGLLOADTRANSPOSEMATRIXDARBPROC	glLoadTransposeMatrixdARB;
	PFNGLMULTTRANSPOSEMATRIXFARBPROC	glMultTransposeMatrixfARB;
	PFNGLMULTTRANSPOSEMATRIXDARBPROC	glMultTransposeMatrixdARB;
	#endif


	#ifdef GL_ARB_vertex_blend
	PFNGLWEIGHTBVARBPROC				glWeightbvARB;
	PFNGLWEIGHTSVARBPROC				glWeightsvARB;
	PFNGLWEIGHTIVARBPROC				glWeightivARB;
	PFNGLWEIGHTFVARBPROC				glWeightfvARB;
	PFNGLWEIGHTDVARBPROC				glWeightdvARB;
	PFNGLWEIGHTUBVARBPROC				glWeightubvARB;
	PFNGLWEIGHTUSVARBPROC				glWeightusvARB;
	PFNGLWEIGHTUIVARBPROC				glWeightuivARB;
										
	PFNGLWEIGHTPOINTERARBPROC			glWeightPointerARB;
	PFNGLVERTEXBLENDARBPROC				glVertexBlendARB;
	#endif


	#ifdef GL_ARB_vertex_buffer_object
	PFNGLBINDBUFFERARBPROC				glBindBufferARB;
	PFNGLDELETEBUFFERSARBPROC			glDeleteBuffersARB;
	PFNGLGENBUFFERSARBPROC				glGenBuffersARB;
	PFNGLISBUFFERARBPROC				glIsBufferARB;
										
	PFNGLBUFFERDATAARBPROC				glBufferDataARB;
	PFNGLBUFFERSUBDATAARBPROC			glBufferSubDataARB;
	PFNGLGETBUFFERSUBDATAARBPROC		glGetBufferSubDataARB;
										
	PFNGLMAPBUFFERARBPROC				glMapBufferARB;
	PFNGLUNMAPBUFFERARBPROC				glUnmapBufferARB;

	PFNGLGETBUFFERPARAMETERIVARBPROC	glGetBufferParameterivARB;
	PFNGLGETBUFFERPOINTERVARBPROC		glGetBufferPointervARB;
	#endif


	#ifdef GL_ARB_vertex_program
	PFNGLVERTEXATTRIB1SARBPROC			glVertexAttrib1sARB;
	PFNGLVERTEXATTRIB1FARBPROC			glVertexAttrib1fARB;
	PFNGLVERTEXATTRIB1DARBPROC			glVertexAttrib1dARB;
	PFNGLVERTEXATTRIB2SARBPROC			glVertexAttrib2sARB;
	PFNGLVERTEXATTRIB2FARBPROC			glVertexAttrib2fARB;
	PFNGLVERTEXATTRIB2DARBPROC			glVertexAttrib2dARB;
	PFNGLVERTEXATTRIB3SARBPROC			glVertexAttrib3sARB;
	PFNGLVERTEXATTRIB3FARBPROC			glVertexAttrib3fARB;
	PFNGLVERTEXATTRIB3DARBPROC			glVertexAttrib3dARB;
	PFNGLVERTEXATTRIB4SARBPROC			glVertexAttrib4sARB;
	PFNGLVERTEXATTRIB4FARBPROC			glVertexAttrib4fARB;
	PFNGLVERTEXATTRIB4DARBPROC			glVertexAttrib4dARB;
	PFNGLVERTEXATTRIB4NUBARBPROC		glVertexAttrib4NubARB;
	PFNGLVERTEXATTRIB1SVARBPROC			glVertexAttrib1svARB;
	PFNGLVERTEXATTRIB1FVARBPROC			glVertexAttrib1fvARB;
	PFNGLVERTEXATTRIB1DVARBPROC			glVertexAttrib1dvARB;
	PFNGLVERTEXATTRIB2SVARBPROC			glVertexAttrib2svARB;
	PFNGLVERTEXATTRIB2FVARBPROC			glVertexAttrib2fvARB;
	PFNGLVERTEXATTRIB2DVARBPROC			glVertexAttrib2dvARB;
	PFNGLVERTEXATTRIB3SVARBPROC			glVertexAttrib3svARB;
	PFNGLVERTEXATTRIB3FVARBPROC			glVertexAttrib3fvARB;
	PFNGLVERTEXATTRIB3DVARBPROC			glVertexAttrib3dvARB;
	PFNGLVERTEXATTRIB4BVARBPROC			glVertexAttrib4bvARB;
	PFNGLVERTEXATTRIB4SVARBPROC			glVertexAttrib4svARB;
	PFNGLVERTEXATTRIB4IVARBPROC			glVertexAttrib4ivARB;
	PFNGLVERTEXATTRIB4UBVARBPROC		glVertexAttrib4ubvARB;
	PFNGLVERTEXATTRIB4USVARBPROC		glVertexAttrib4usvARB;
	PFNGLVERTEXATTRIB4UIVARBPROC		glVertexAttrib4uivARB;
	PFNGLVERTEXATTRIB4FVARBPROC			glVertexAttrib4fvARB;
	PFNGLVERTEXATTRIB4DVARBPROC			glVertexAttrib4dvARB;
	PFNGLVERTEXATTRIB4NBVARBPROC		glVertexAttrib4NbvARB;
	PFNGLVERTEXATTRIB4NSVARBPROC		glVertexAttrib4NsvARB;
	PFNGLVERTEXATTRIB4NIVARBPROC		glVertexAttrib4NivARB;
	PFNGLVERTEXATTRIB4NUBVARBPROC		glVertexAttrib4NubvARB;
	PFNGLVERTEXATTRIB4NUSVARBPROC		glVertexAttrib4NusvARB;
	PFNGLVERTEXATTRIB4NUIVARBPROC		glVertexAttrib4NuivARB;
	PFNGLVERTEXATTRIBPOINTERARBPROC		glVertexAttribPointerARB;
	PFNGLENABLEVERTEXATTRIBARRAYARBPROC glEnableVertexAttribArrayARB;
	PFNGLDISABLEVERTEXATTRIBARRAYARBPROC glDisableVertexAttribArrayARB;
	PFNGLPROGRAMSTRINGARBPROC			glProgramStringARB;
	PFNGLBINDPROGRAMARBPROC				glBindProgramARB;
	PFNGLDELETEPROGRAMSARBPROC			glDeleteProgramsARB;
	PFNGLGENPROGRAMSARBPROC				glGenProgramsARB;
	PFNGLPROGRAMENVPARAMETER4DARBPROC	glProgramEnvParameter4dARB;
	PFNGLPROGRAMENVPARAMETER4DVARBPROC	glProgramEnvParameter4dvARB;
	PFNGLPROGRAMENVPARAMETER4FARBPROC	glProgramEnvParameter4fARB;
	PFNGLPROGRAMENVPARAMETER4FVARBPROC	glProgramEnvParameter4fvARB;
	PFNGLPROGRAMLOCALPARAMETER4DARBPROC glProgramLocalParameter4dARB;
	PFNGLPROGRAMLOCALPARAMETER4DVARBPROC glProgramLocalParameter4dvARB;
	PFNGLPROGRAMLOCALPARAMETER4FARBPROC	glProgramLocalParameter4fARB;
	PFNGLPROGRAMLOCALPARAMETER4FVARBPROC glProgramLocalParameter4fvARB;
	PFNGLGETPROGRAMENVPARAMETERDVARBPROC glGetProgramEnvParameterdvARB;
	PFNGLGETPROGRAMENVPARAMETERFVARBPROC glGetProgramEnvParameterfvARB;
	PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC glGetProgramLocalParameterdvARB;
	PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC glGetProgramLocalParameterfvARB;
	PFNGLGETPROGRAMIVARBPROC			glGetProgramivARB;
	PFNGLGETPROGRAMSTRINGARBPROC		glGetProgramStringARB;
	PFNGLGETVERTEXATTRIBDVARBPROC		glGetVertexAttribdvARB;
	PFNGLGETVERTEXATTRIBFVARBPROC		glGetVertexAttribfvARB;
	PFNGLGETVERTEXATTRIBIVARBPROC		glGetVertexAttribivARB;
	PFNGLGETVERTEXATTRIBPOINTERVARBPROC glGetVertexAttribPointervARB;
	PFNGLISPROGRAMARBPROC				glIsProgramARB;
	#endif


	#ifdef GL_ARB_vertex_shader
	PFNGLBINDATTRIBLOCATIONARBPROC		glBindAttribLocationARB;
	PFNGLGETACTIVEATTRIBARBPROC			glGetActiveAttribARB;
	PFNGLGETATTRIBLOCATIONARBPROC		glGetAttribLocationARB;
	#endif


	#ifdef GL_ATI_element_array
	PFNGLELEMENTPOINTERATIPROC			glElementPointerATI;
	PFNGLDRAWELEMENTARRAYATIPROC		glDrawElementArrayATI;
	PFNGLDRAWRANGEELEMENTARRAYATIPROC	glDrawRangeElementArrayATI;
	#endif


	#ifdef GL_ATI_envmap_bumpmap
	PFNGLTEXBUMPPARAMETERIVATIPROC		glTexBumpParameterivATI;
	PFNGLTEXBUMPPARAMETERFVATIPROC		glTexBumpParameterfvATI;
	PFNGLGETTEXBUMPPARAMETERIVATIPROC	glGetTexBumpParameterivATI;
	PFNGLGETTEXBUMPPARAMETERFVATIPROC	glGetTexBumpParameterfvATI;
	#endif


	#ifdef GL_ATI_fragment_shader
	PFNGLGENFRAGMENTSHADERSATIPROC		glGenFragmentShadersATI;
	PFNGLBINDFRAGMENTSHADERATIPROC		glBindFragmentShaderATI;
	PFNGLDELETEFRAGMENTSHADERATIPROC	glDeleteFragmentShaderATI;
	PFNGLBEGINFRAGMENTSHADERATIPROC		glBeginFragmentShaderATI;
	PFNGLENDFRAGMENTSHADERATIPROC		glEndFragmentShaderATI;
	PFNGLPASSTEXCOORDATIPROC			glPassTexCoordATI;
	PFNGLSAMPLEMAPATIPROC				glSampleMapATI;

	PFNGLCOLORFRAGMENTOP1ATIPROC		glColorFragmentOp1ATI;
	PFNGLCOLORFRAGMENTOP2ATIPROC		glColorFragmentOp2ATI;
	PFNGLCOLORFRAGMENTOP3ATIPROC		glColorFragmentOp3ATI;
										
	PFNGLALPHAFRAGMENTOP1ATIPROC		glAlphaFragmentOp1ATI;
	PFNGLALPHAFRAGMENTOP2ATIPROC		glAlphaFragmentOp2ATI;
	PFNGLALPHAFRAGMENTOP3ATIPROC		glAlphaFragmentOp3ATI;

	PFNGLSETFRAGMENTSHADERCONSTANTATIPROC glSetFragmentShaderConstantATI;
	#endif


	#ifdef GL_ATI_map_object_buffer
	PFNGLMAPOBJECTBUFFERATIPROC			glMapObjectBufferATI;
	PFNGLUNMAPOBJECTBUFFERATIPROC		glUnmapObjectBufferATI;
	#endif


	#ifdef GL_ATI_pn_triangles
	PFNGLPNTRIANGLESIATIPROC			glPNTrianglesiATI;
	PFNGLPNTRIANGLESFATIPROC			glPNTrianglesfATI;
	#endif



	#ifdef GL_ATI_vertex_array_object
	PFNGLNEWOBJECTBUFFERATIPROC			glNewObjectBufferATI;
	PFNGLISOBJECTBUFFERATIPROC			glIsObjectBufferATI;
	PFNGLUPDATEOBJECTBUFFERATIPROC		glUpdateObjectBufferATI;
	PFNGLGETOBJECTBUFFERFVATIPROC		glGetObjectBufferfvATI;
	PFNGLGETOBJECTBUFFERIVATIPROC		glGetObjectBufferivATI;
	PFNGLFREEOBJECTBUFFERATIPROC		glFreeObjectBufferATI;
										
	PFNGLARRAYOBJECTATIPROC				glArrayObjectATI;
	PFNGLGETARRAYOBJECTFVATIPROC		glGetArrayObjectfvATI;
	PFNGLGETARRAYOBJECTIVATIPROC		glGetArrayObjectivATI;
	PFNGLVARIANTARRAYOBJECTATIPROC		glVariantArrayObjectATI;

	PFNGLGETVARIANTARRAYOBJECTFVATIPROC glGetVariantArrayObjectfvATI;
	PFNGLGETVARIANTARRAYOBJECTIVATIPROC glGetVariantArrayObjectivATI;
	#endif


	#ifdef GL_ATI_vertex_attrib_array_object
	PFNGLVERTEXATTRIBARRAYOBJECTATIPROC glVertexAttribArrayObjectATI;
	#endif


	#ifdef GL_ATI_vertex_streams
	PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC glClientActiveVertexStreamATI;
	PFNGLVERTEXBLENDENVIATIPROC			glVertexBlendEnviATI;
	PFNGLVERTEXBLENDENVFATIPROC			glVertexBlendEnvfATI;
										
	PFNGLVERTEXSTREAM2SATIPROC			glVertexStream2sATI;
	PFNGLVERTEXSTREAM2SVATIPROC			glVertexStream2svATI;
	PFNGLVERTEXSTREAM2IATIPROC			glVertexStream2iATI;
	PFNGLVERTEXSTREAM2IVATIPROC			glVertexStream2ivATI;
	PFNGLVERTEXSTREAM2FATIPROC			glVertexStream2fATI;
	PFNGLVERTEXSTREAM2FVATIPROC			glVertexStream2fvATI;
	PFNGLVERTEXSTREAM2DATIPROC			glVertexStream2dATI;
	PFNGLVERTEXSTREAM2DVATIPROC			glVertexStream2dvATI;
										
	PFNGLVERTEXSTREAM3SATIPROC			glVertexStream3sATI;
	PFNGLVERTEXSTREAM3SVATIPROC			glVertexStream3svATI;
	PFNGLVERTEXSTREAM3IATIPROC			glVertexStream3iATI;
	PFNGLVERTEXSTREAM3IVATIPROC			glVertexStream3ivATI;
	PFNGLVERTEXSTREAM3FATIPROC			glVertexStream3fATI;
	PFNGLVERTEXSTREAM3FVATIPROC			glVertexStream3fvATI;
	PFNGLVERTEXSTREAM3DATIPROC			glVertexStream3dATI;
	PFNGLVERTEXSTREAM3DVATIPROC			glVertexStream3dvATI;
										
	PFNGLVERTEXSTREAM4SATIPROC			glVertexStream4sATI;
	PFNGLVERTEXSTREAM4SVATIPROC			glVertexStream4svATI;
	PFNGLVERTEXSTREAM4IATIPROC			glVertexStream4iATI;
	PFNGLVERTEXSTREAM4IVATIPROC			glVertexStream4ivATI;
	PFNGLVERTEXSTREAM4FATIPROC			glVertexStream4fATI;
	PFNGLVERTEXSTREAM4FVATIPROC			glVertexStream4fvATI;
	PFNGLVERTEXSTREAM4DATIPROC			glVertexStream4dATI;
	PFNGLVERTEXSTREAM4DVATIPROC			glVertexStream4dvATI;
										
	PFNGLNORMALSTREAM3BATIPROC			glNormalStream3bATI;
	PFNGLNORMALSTREAM3BVATIPROC			glNormalStream3bvATI;
	PFNGLNORMALSTREAM3SATIPROC			glNormalStream3sATI;
	PFNGLNORMALSTREAM3SVATIPROC			glNormalStream3svATI;
	PFNGLNORMALSTREAM3IATIPROC			glNormalStream3iATI;
	PFNGLNORMALSTREAM3IVATIPROC			glNormalStream3ivATI;
	PFNGLNORMALSTREAM3FATIPROC			glNormalStream3fATI;
	PFNGLNORMALSTREAM3FVATIPROC			glNormalStream3fvATI;
	PFNGLNORMALSTREAM3DATIPROC			glNormalStream3dATI;
	PFNGLNORMALSTREAM3DVATIPROC			glNormalStream3dvATI;
	#endif


	#ifdef GL_EXT_blend_color
	PFNGLBLENDCOLOREXTPROC				glBlendColorEXT;
	#endif


	#ifdef GL_EXT_blend_func_separate
	PFNGLBLENDFUNCSEPARATEEXTPROC		glBlendFuncSeparateEXT;
	#endif


	#ifdef GL_EXT_blend_minmax
	PFNGLBLENDEQUATIONEXTPROC			glBlendEquationEXT;
	#endif


	#ifdef GL_EXT_draw_range_elements
	PFNGLDRAWRANGEELEMENTSEXTPROC		glDrawRangeElementsEXT;
	#endif


	#ifdef GL_EXT_fog_coord
	PFNGLFOGCOORDFEXTPROC				glFogCoordfEXT;
	PFNGLFOGCOORDDEXTPROC				glFogCoorddEXT;
	PFNGLFOGCOORDFVEXTPROC				glFogCoordfvEXT;
	PFNGLFOGCOORDDVEXTPROC				glFogCoorddvEXT;
	PFNGLFOGCOORDPOINTEREXTPROC			glFogCoordPointerEXT;
	#endif


	#ifdef GL_EXT_polygon_offset
	PFNGLPOLYGONOFFSETEXTPROC			glPolygonOffsetEXT;
	#endif


	#ifdef GL_EXT_texture3D
	PFNGLTEXIMAGE3DEXTPROC				glTexImage3DEXT;
	#endif


	#ifdef GL_NV_occlusion_query
	PFNGLGENOCCLUSIONQUERIESNVPROC		glGenOcclusionQueriesNV;
	PFNGLDELETEOCCLUSIONQUERIESNVPROC	glDeleteOcclusionQueriesNV;
	PFNGLISOCCLUSIONQUERYNVPROC			glIsOcclusionQueryNV;
	PFNGLBEGINOCCLUSIONQUERYNVPROC		glBeginOcclusionQueryNV;
	PFNGLENDOCCLUSIONQUERYNVPROC		glEndOcclusionQueryNV;
	PFNGLGETOCCLUSIONQUERYIVNVPROC		glGetOcclusionQueryivNV;
	PFNGLGETOCCLUSIONQUERYUIVNVPROC		glGetOcclusionQueryuivNV;
	#endif


	#ifdef GL_NV_register_combiners
	PFNGLCOMBINERPARAMETERFVNVPROC		glCombinerParameterfvNV;
	PFNGLCOMBINERPARAMETERFNVPROC		glCombinerParameterfNV;
	PFNGLCOMBINERPARAMETERIVNVPROC		glCombinerParameterivNV;
	PFNGLCOMBINERPARAMETERINVPROC		glCombinerParameteriNV;
										
	PFNGLCOMBINERINPUTNVPROC			glCombinerInputNV;
	PFNGLCOMBINEROUTPUTNVPROC			glCombinerOutputNV;
	PFNGLFINALCOMBINERINPUTNVPROC		glFinalCombinerInputNV;

	PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC  glGetCombinerInputParameterfvNV;
	PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC  glGetCombinerInputParameterivNV;
	PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC glGetCombinerOutputParameterfvNV;
	PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC glGetCombinerOutputParameterivNV;

	PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC glGetFinalCombinerInputParameterfvNV;
	PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC glGetFinalCombinerInputParameterivNV;
	#endif


	#ifdef WGL_ARB_pbuffer
	PFNWGLCREATEPBUFFERARBPROC			wglCreatePbufferARB;
	PFNWGLGETPBUFFERDCARBPROC			wglGetPbufferDCARB;
	PFNWGLRELEASEPBUFFERDCARBPROC		wglReleasePbufferDCARB;
	PFNWGLDESTROYPBUFFERARBPROC			wglDestroyPbufferARB;
	PFNWGLQUERYPBUFFERARBPROC			wglQueryPbufferARB;
	#endif


	#ifdef WGL_ARB_render_texture
	PFNWGLBINDTEXIMAGEARBPROC			wglBindTexImageARB;
	PFNWGLRELEASETEXIMAGEARBPROC		wglReleaseTexImageARB;
	PFNWGLSETPBUFFERATTRIBARBPROC		wglSetPbufferAttribARB;
	#endif
};

}; };

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
#ifdef GL_ARB_multitexture
extern PFNGLACTIVETEXTUREARBPROC			glActiveTextureARB;
extern PFNGLCLIENTACTIVETEXTUREARBPROC		glClientActiveTextureARB;
									
extern PFNGLMULTITEXCOORD1DARBPROC			glMultiTexCoord1dARB;
extern PFNGLMULTITEXCOORD1DVARBPROC			glMultiTexCoord1dvARB;
extern PFNGLMULTITEXCOORD1FARBPROC			glMultiTexCoord1fARB;
extern PFNGLMULTITEXCOORD1FVARBPROC			glMultiTexCoord1fvARB;
extern PFNGLMULTITEXCOORD1IARBPROC			glMultiTexCoord1iARB;
extern PFNGLMULTITEXCOORD1IVARBPROC			glMultiTexCoord1ivARB;
extern PFNGLMULTITEXCOORD1SARBPROC			glMultiTexCoord1sARB;
extern PFNGLMULTITEXCOORD1SVARBPROC			glMultiTexCoord1svARB;
									
extern PFNGLMULTITEXCOORD2DARBPROC			glMultiTexCoord2dARB;
extern PFNGLMULTITEXCOORD2DVARBPROC			glMultiTexCoord2dvARB;
extern PFNGLMULTITEXCOORD2FARBPROC			glMultiTexCoord2fARB;
extern PFNGLMULTITEXCOORD2FVARBPROC			glMultiTexCoord2fvARB;
extern PFNGLMULTITEXCOORD2IARBPROC			glMultiTexCoord2iARB;
extern PFNGLMULTITEXCOORD2IVARBPROC			glMultiTexCoord2ivARB;
extern PFNGLMULTITEXCOORD2SARBPROC			glMultiTexCoord2sARB;
extern PFNGLMULTITEXCOORD2SVARBPROC			glMultiTexCoord2svARB;
									
extern PFNGLMULTITEXCOORD3DARBPROC			glMultiTexCoord3dARB;
extern PFNGLMULTITEXCOORD3DVARBPROC			glMultiTexCoord3dvARB;
extern PFNGLMULTITEXCOORD3FARBPROC			glMultiTexCoord3fARB;
extern PFNGLMULTITEXCOORD3FVARBPROC			glMultiTexCoord3fvARB;
extern PFNGLMULTITEXCOORD3IARBPROC			glMultiTexCoord3iARB;
extern PFNGLMULTITEXCOORD3IVARBPROC			glMultiTexCoord3ivARB;
extern PFNGLMULTITEXCOORD3SARBPROC			glMultiTexCoord3sARB;
extern PFNGLMULTITEXCOORD3SVARBPROC			glMultiTexCoord3svARB;
									
extern PFNGLMULTITEXCOORD4DARBPROC			glMultiTexCoord4dARB;
extern PFNGLMULTITEXCOORD4DVARBPROC			glMultiTexCoord4dvARB;
extern PFNGLMULTITEXCOORD4FARBPROC			glMultiTexCoord4fARB;
extern PFNGLMULTITEXCOORD4FVARBPROC			glMultiTexCoord4fvARB;
extern PFNGLMULTITEXCOORD4IARBPROC			glMultiTexCoord4iARB;
extern PFNGLMULTITEXCOORD4IVARBPROC			glMultiTexCoord4ivARB;
extern PFNGLMULTITEXCOORD4SARBPROC			glMultiTexCoord4sARB;
extern PFNGLMULTITEXCOORD4SVARBPROC			glMultiTexCoord4svARB;
#endif								
									
									
#ifdef GL_ARB_occlusion_query		
extern PFNGLGENQUERIESARBPROC				glGenQueriesARB;
extern PFNGLDELETEQUERIESARBPROC			glDeleteQueriesARB;
extern PFNGLISQUERYARBPROC					glIsQueryARB;
extern PFNGLBEGINQUERYARBPROC				glBeginQueryARB;
extern PFNGLENDQUERYARBPROC					glEndQueryARB;
extern PFNGLGETQUERYIVARBPROC				glGetQueryivARB;
extern PFNGLGETQUERYOBJECTIVARBPROC			glGetQueryObjectivARB;
extern PFNGLGETQUERYOBJECTUIVARBPROC		glGetQueryObjectuivARB;
#endif


#ifdef GL_ARB_shader_objects
extern PFNGLDELETEOBJECTARBPROC				glDeleteObjectARB;
extern PFNGLGETHANDLEARBPROC				glGetHandleARB;
extern PFNGLDETACHOBJECTARBPROC				glDetachObjectARB;
extern PFNGLCREATESHADEROBJECTARBPROC		glCreateShaderObjectARB;
extern PFNGLSHADERSOURCEARBPROC				glShaderSourceARB;
extern PFNGLCOMPILESHADERARBPROC			glCompileShaderARB;
extern PFNGLCREATEPROGRAMOBJECTARBPROC		glCreateProgramObjectARB;
extern PFNGLATTACHOBJECTARBPROC				glAttachObjectARB;
extern PFNGLLINKPROGRAMARBPROC				glLinkProgramARB;
extern PFNGLUSEPROGRAMOBJECTARBPROC			glUseProgramObjectARB;
extern PFNGLVALIDATEPROGRAMARBPROC			glValidateProgramARB;
									
extern PFNGLUNIFORM1FARBPROC				glUniform1fARB;
extern PFNGLUNIFORM2FARBPROC				glUniform2fARB;
extern PFNGLUNIFORM3FARBPROC				glUniform3fARB;
extern PFNGLUNIFORM4FARBPROC				glUniform4fARB;
									
extern PFNGLUNIFORM1IARBPROC				glUniform1iARB;
extern PFNGLUNIFORM2IARBPROC				glUniform2iARB;
extern PFNGLUNIFORM3IARBPROC				glUniform3iARB;
extern PFNGLUNIFORM4IARBPROC				glUniform4iARB;
									
extern PFNGLUNIFORM1FVARBPROC				glUniform1fvARB;
extern PFNGLUNIFORM2FVARBPROC				glUniform2fvARB;
extern PFNGLUNIFORM3FVARBPROC				glUniform3fvARB;
extern PFNGLUNIFORM4FVARBPROC				glUniform4fvARB;
									
extern PFNGLUNIFORM1IVARBPROC				glUniform1ivARB;
extern PFNGLUNIFORM2IVARBPROC				glUniform2ivARB;
extern PFNGLUNIFORM3IVARBPROC				glUniform3ivARB;
extern PFNGLUNIFORM4IVARBPROC				glUniform4ivARB;
									
extern PFNGLUNIFORMMATRIX2FVARBPROC			glUniformMatrix2fvARB;
extern PFNGLUNIFORMMATRIX3FVARBPROC			glUniformMatrix3fvARB;
extern PFNGLUNIFORMMATRIX4FVARBPROC			glUniformMatrix4fvARB;

extern PFNGLGETOBJECTPARAMETERFVARBPROC		glGetObjectParameterfvARB;
extern PFNGLGETOBJECTPARAMETERIVARBPROC		glGetObjectParameterivARB;
extern PFNGLGETINFOLOGARBPROC				glGetInfoLogARB;
extern PFNGLGETATTACHEDOBJECTSARBPROC		glGetAttachedObjectsARB;
extern PFNGLGETUNIFORMLOCATIONARBPROC		glGetUniformLocationARB;
extern PFNGLGETACTIVEUNIFORMARBPROC			glGetActiveUniformARB;
extern PFNGLGETUNIFORMFVARBPROC				glGetUniformfvARB;
extern PFNGLGETUNIFORMIVARBPROC				glGetUniformivARB;
extern PFNGLGETSHADERSOURCEARBPROC			glGetShaderSourceARB;
#endif


#ifdef GL_ARB_texture_compression
extern PFNGLCOMPRESSEDTEXIMAGE1DARBPROC		glCompressedTexImage1DARB;
extern PFNGLCOMPRESSEDTEXIMAGE2DARBPROC		glCompressedTexImage2DARB;
extern PFNGLCOMPRESSEDTEXIMAGE3DARBPROC		glCompressedTexImage3DARB;
extern PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC	glCompressedTexSubImage1DARB;
extern PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC	glCompressedTexSubImage2DARB;
extern PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC	glCompressedTexSubImage3DARB;
extern PFNGLGETCOMPRESSEDTEXIMAGEARBPROC	glGetCompressedTexImageARB;
#endif


#ifdef GL_ARB_transpose_matrix
extern PFNGLLOADTRANSPOSEMATRIXFARBPROC		glLoadTransposeMatrixfARB;
extern PFNGLLOADTRANSPOSEMATRIXDARBPROC		glLoadTransposeMatrixdARB;
extern PFNGLMULTTRANSPOSEMATRIXFARBPROC		glMultTransposeMatrixfARB;
extern PFNGLMULTTRANSPOSEMATRIXDARBPROC		glMultTransposeMatrixdARB;
#endif


#ifdef GL_ARB_vertex_blend
extern PFNGLWEIGHTBVARBPROC					glWeightbvARB;
extern PFNGLWEIGHTSVARBPROC					glWeightsvARB;
extern PFNGLWEIGHTIVARBPROC					glWeightivARB;
extern PFNGLWEIGHTFVARBPROC					glWeightfvARB;
extern PFNGLWEIGHTDVARBPROC					glWeightdvARB;
extern PFNGLWEIGHTUBVARBPROC				glWeightubvARB;
extern PFNGLWEIGHTUSVARBPROC				glWeightusvARB;
extern PFNGLWEIGHTUIVARBPROC				glWeightuivARB;
									
extern PFNGLWEIGHTPOINTERARBPROC			glWeightPointerARB;
extern PFNGLVERTEXBLENDARBPROC				glVertexBlendARB;
#endif


#ifdef GL_ARB_vertex_buffer_object
extern PFNGLBINDBUFFERARBPROC				glBindBufferARB;
extern PFNGLDELETEBUFFERSARBPROC			glDeleteBuffersARB;
extern PFNGLGENBUFFERSARBPROC				glGenBuffersARB;
extern PFNGLISBUFFERARBPROC					glIsBufferARB;
									
extern PFNGLBUFFERDATAARBPROC				glBufferDataARB;
extern PFNGLBUFFERSUBDATAARBPROC			glBufferSubDataARB;
extern PFNGLGETBUFFERSUBDATAARBPROC			glGetBufferSubDataARB;
									
extern PFNGLMAPBUFFERARBPROC				glMapBufferARB;
extern PFNGLUNMAPBUFFERARBPROC				glUnmapBufferARB;

extern PFNGLGETBUFFERPARAMETERIVARBPROC		glGetBufferParameterivARB;
extern PFNGLGETBUFFERPOINTERVARBPROC		glGetBufferPointervARB;
#endif


#ifdef GL_ARB_vertex_program
extern PFNGLVERTEXATTRIB1SARBPROC			glVertexAttrib1sARB;
extern PFNGLVERTEXATTRIB1FARBPROC			glVertexAttrib1fARB;
extern PFNGLVERTEXATTRIB1DARBPROC			glVertexAttrib1dARB;
extern PFNGLVERTEXATTRIB2SARBPROC			glVertexAttrib2sARB;
extern PFNGLVERTEXATTRIB2FARBPROC			glVertexAttrib2fARB;
extern PFNGLVERTEXATTRIB2DARBPROC			glVertexAttrib2dARB;
extern PFNGLVERTEXATTRIB3SARBPROC			glVertexAttrib3sARB;
extern PFNGLVERTEXATTRIB3FARBPROC			glVertexAttrib3fARB;
extern PFNGLVERTEXATTRIB3DARBPROC			glVertexAttrib3dARB;
extern PFNGLVERTEXATTRIB4SARBPROC			glVertexAttrib4sARB;
extern PFNGLVERTEXATTRIB4FARBPROC			glVertexAttrib4fARB;
extern PFNGLVERTEXATTRIB4DARBPROC			glVertexAttrib4dARB;
extern PFNGLVERTEXATTRIB4NUBARBPROC			glVertexAttrib4NubARB;
extern PFNGLVERTEXATTRIB1SVARBPROC			glVertexAttrib1svARB;
extern PFNGLVERTEXATTRIB1FVARBPROC			glVertexAttrib1fvARB;
extern PFNGLVERTEXATTRIB1DVARBPROC			glVertexAttrib1dvARB;
extern PFNGLVERTEXATTRIB2SVARBPROC			glVertexAttrib2svARB;
extern PFNGLVERTEXATTRIB2FVARBPROC			glVertexAttrib2fvARB;
extern PFNGLVERTEXATTRIB2DVARBPROC			glVertexAttrib2dvARB;
extern PFNGLVERTEXATTRIB3SVARBPROC			glVertexAttrib3svARB;
extern PFNGLVERTEXATTRIB3FVARBPROC			glVertexAttrib3fvARB;
extern PFNGLVERTEXATTRIB3DVARBPROC			glVertexAttrib3dvARB;
extern PFNGLVERTEXATTRIB4BVARBPROC			glVertexAttrib4bvARB;
extern PFNGLVERTEXATTRIB4SVARBPROC			glVertexAttrib4svARB;
extern PFNGLVERTEXATTRIB4IVARBPROC			glVertexAttrib4ivARB;
extern PFNGLVERTEXATTRIB4UBVARBPROC			glVertexAttrib4ubvARB;
extern PFNGLVERTEXATTRIB4USVARBPROC			glVertexAttrib4usvARB;
extern PFNGLVERTEXATTRIB4UIVARBPROC			glVertexAttrib4uivARB;
extern PFNGLVERTEXATTRIB4FVARBPROC			glVertexAttrib4fvARB;
extern PFNGLVERTEXATTRIB4DVARBPROC			glVertexAttrib4dvARB;
extern PFNGLVERTEXATTRIB4NBVARBPROC			glVertexAttrib4NbvARB;
extern PFNGLVERTEXATTRIB4NSVARBPROC			glVertexAttrib4NsvARB;
extern PFNGLVERTEXATTRIB4NIVARBPROC			glVertexAttrib4NivARB;
extern PFNGLVERTEXATTRIB4NUBVARBPROC		glVertexAttrib4NubvARB;
extern PFNGLVERTEXATTRIB4NUSVARBPROC		glVertexAttrib4NusvARB;
extern PFNGLVERTEXATTRIB4NUIVARBPROC		glVertexAttrib4NuivARB;
extern PFNGLVERTEXATTRIBPOINTERARBPROC		glVertexAttribPointerARB;
extern PFNGLENABLEVERTEXATTRIBARRAYARBPROC	glEnableVertexAttribArrayARB;
extern PFNGLDISABLEVERTEXATTRIBARRAYARBPROC glDisableVertexAttribArrayARB;
extern PFNGLPROGRAMSTRINGARBPROC			glProgramStringARB;
extern PFNGLBINDPROGRAMARBPROC				glBindProgramARB;
extern PFNGLDELETEPROGRAMSARBPROC			glDeleteProgramsARB;
extern PFNGLGENPROGRAMSARBPROC				glGenProgramsARB;
extern PFNGLPROGRAMENVPARAMETER4DARBPROC	glProgramEnvParameter4dARB;
extern PFNGLPROGRAMENVPARAMETER4DVARBPROC	glProgramEnvParameter4dvARB;
extern PFNGLPROGRAMENVPARAMETER4FARBPROC	glProgramEnvParameter4fARB;
extern PFNGLPROGRAMENVPARAMETER4FVARBPROC	glProgramEnvParameter4fvARB;
extern PFNGLPROGRAMLOCALPARAMETER4DARBPROC	glProgramLocalParameter4dARB;
extern PFNGLPROGRAMLOCALPARAMETER4DVARBPROC glProgramLocalParameter4dvARB;
extern PFNGLPROGRAMLOCALPARAMETER4FARBPROC	glProgramLocalParameter4fARB;
extern PFNGLPROGRAMLOCALPARAMETER4FVARBPROC glProgramLocalParameter4fvARB;
extern PFNGLGETPROGRAMENVPARAMETERDVARBPROC glGetProgramEnvParameterdvARB;
extern PFNGLGETPROGRAMENVPARAMETERFVARBPROC glGetProgramEnvParameterfvARB;
extern PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC glGetProgramLocalParameterdvARB;
extern PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC glGetProgramLocalParameterfvARB;
extern PFNGLGETPROGRAMIVARBPROC				glGetProgramivARB;
extern PFNGLGETPROGRAMSTRINGARBPROC			glGetProgramStringARB;
extern PFNGLGETVERTEXATTRIBDVARBPROC		glGetVertexAttribdvARB;
extern PFNGLGETVERTEXATTRIBFVARBPROC		glGetVertexAttribfvARB;
extern PFNGLGETVERTEXATTRIBIVARBPROC		glGetVertexAttribivARB;
extern PFNGLGETVERTEXATTRIBPOINTERVARBPROC	glGetVertexAttribPointervARB;
extern PFNGLISPROGRAMARBPROC				glIsProgramARB;
#endif


#ifdef GL_ARB_vertex_shader
extern PFNGLBINDATTRIBLOCATIONARBPROC		glBindAttribLocationARB;
extern PFNGLGETACTIVEATTRIBARBPROC			glGetActiveAttribARB;
extern PFNGLGETATTRIBLOCATIONARBPROC		glGetAttribLocationARB;
#endif


#ifdef GL_ATI_element_array
extern PFNGLELEMENTPOINTERATIPROC			glElementPointerATI;
extern PFNGLDRAWELEMENTARRAYATIPROC			glDrawElementArrayATI;
extern PFNGLDRAWRANGEELEMENTARRAYATIPROC	glDrawRangeElementArrayATI;
#endif


#ifdef GL_ATI_envmap_bumpmap
extern PFNGLTEXBUMPPARAMETERIVATIPROC		glTexBumpParameterivATI;
extern PFNGLTEXBUMPPARAMETERFVATIPROC		glTexBumpParameterfvATI;
extern PFNGLGETTEXBUMPPARAMETERIVATIPROC	glGetTexBumpParameterivATI;
extern PFNGLGETTEXBUMPPARAMETERFVATIPROC	glGetTexBumpParameterfvATI;
#endif


#ifdef GL_ATI_fragment_shader
extern PFNGLGENFRAGMENTSHADERSATIPROC		glGenFragmentShadersATI;
extern PFNGLBINDFRAGMENTSHADERATIPROC		glBindFragmentShaderATI;
extern PFNGLDELETEFRAGMENTSHADERATIPROC		glDeleteFragmentShaderATI;
extern PFNGLBEGINFRAGMENTSHADERATIPROC		glBeginFragmentShaderATI;
extern PFNGLENDFRAGMENTSHADERATIPROC		glEndFragmentShaderATI;
extern PFNGLPASSTEXCOORDATIPROC				glPassTexCoordATI;
extern PFNGLSAMPLEMAPATIPROC				glSampleMapATI;

extern PFNGLCOLORFRAGMENTOP1ATIPROC			glColorFragmentOp1ATI;
extern PFNGLCOLORFRAGMENTOP2ATIPROC			glColorFragmentOp2ATI;
extern PFNGLCOLORFRAGMENTOP3ATIPROC			glColorFragmentOp3ATI;
											
extern PFNGLALPHAFRAGMENTOP1ATIPROC			glAlphaFragmentOp1ATI;
extern PFNGLALPHAFRAGMENTOP2ATIPROC			glAlphaFragmentOp2ATI;
extern PFNGLALPHAFRAGMENTOP3ATIPROC			glAlphaFragmentOp3ATI;

extern PFNGLSETFRAGMENTSHADERCONSTANTATIPROC glSetFragmentShaderConstantATI;
#endif


#ifdef GL_ATI_map_object_buffer
extern PFNGLMAPOBJECTBUFFERATIPROC			glMapObjectBufferATI;
extern PFNGLUNMAPOBJECTBUFFERATIPROC		glUnmapObjectBufferATI;
#endif


#ifdef GL_ATI_pn_triangles
extern PFNGLPNTRIANGLESIATIPROC				glPNTrianglesiATI;
extern PFNGLPNTRIANGLESFATIPROC				glPNTrianglesfATI;
#endif



#ifdef GL_ATI_vertex_array_object
extern PFNGLNEWOBJECTBUFFERATIPROC			glNewObjectBufferATI;
extern PFNGLISOBJECTBUFFERATIPROC			glIsObjectBufferATI;
extern PFNGLUPDATEOBJECTBUFFERATIPROC		glUpdateObjectBufferATI;
extern PFNGLGETOBJECTBUFFERFVATIPROC		glGetObjectBufferfvATI;
extern PFNGLGETOBJECTBUFFERIVATIPROC		glGetObjectBufferivATI;
extern PFNGLFREEOBJECTBUFFERATIPROC			glFreeObjectBufferATI;
									
extern PFNGLARRAYOBJECTATIPROC				glArrayObjectATI;
extern PFNGLGETARRAYOBJECTFVATIPROC			glGetArrayObjectfvATI;
extern PFNGLGETARRAYOBJECTIVATIPROC			glGetArrayObjectivATI;
extern PFNGLVARIANTARRAYOBJECTATIPROC		glVariantArrayObjectATI;

extern PFNGLGETVARIANTARRAYOBJECTFVATIPROC	glGetVariantArrayObjectfvATI;
extern PFNGLGETVARIANTARRAYOBJECTIVATIPROC	glGetVariantArrayObjectivATI;
#endif


#ifdef GL_ATI_vertex_attrib_array_object
extern PFNGLVERTEXATTRIBARRAYOBJECTATIPROC	glVertexAttribArrayObjectATI;
#endif


#ifdef GL_ATI_vertex_streams
extern PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC glClientActiveVertexStreamATI;
extern PFNGLVERTEXBLENDENVIATIPROC			glVertexBlendEnviATI;
extern PFNGLVERTEXBLENDENVFATIPROC			glVertexBlendEnvfATI;
									
extern PFNGLVERTEXSTREAM2SATIPROC			glVertexStream2sATI;
extern PFNGLVERTEXSTREAM2SVATIPROC			glVertexStream2svATI;
extern PFNGLVERTEXSTREAM2IATIPROC			glVertexStream2iATI;
extern PFNGLVERTEXSTREAM2IVATIPROC			glVertexStream2ivATI;
extern PFNGLVERTEXSTREAM2FATIPROC			glVertexStream2fATI;
extern PFNGLVERTEXSTREAM2FVATIPROC			glVertexStream2fvATI;
extern PFNGLVERTEXSTREAM2DATIPROC			glVertexStream2dATI;
extern PFNGLVERTEXSTREAM2DVATIPROC			glVertexStream2dvATI;
									
extern PFNGLVERTEXSTREAM3SATIPROC			glVertexStream3sATI;
extern PFNGLVERTEXSTREAM3SVATIPROC			glVertexStream3svATI;
extern PFNGLVERTEXSTREAM3IATIPROC			glVertexStream3iATI;
extern PFNGLVERTEXSTREAM3IVATIPROC			glVertexStream3ivATI;
extern PFNGLVERTEXSTREAM3FATIPROC			glVertexStream3fATI;
extern PFNGLVERTEXSTREAM3FVATIPROC			glVertexStream3fvATI;
extern PFNGLVERTEXSTREAM3DATIPROC			glVertexStream3dATI;
extern PFNGLVERTEXSTREAM3DVATIPROC			glVertexStream3dvATI;
									
extern PFNGLVERTEXSTREAM4SATIPROC			glVertexStream4sATI;
extern PFNGLVERTEXSTREAM4SVATIPROC			glVertexStream4svATI;
extern PFNGLVERTEXSTREAM4IATIPROC			glVertexStream4iATI;
extern PFNGLVERTEXSTREAM4IVATIPROC			glVertexStream4ivATI;
extern PFNGLVERTEXSTREAM4FATIPROC			glVertexStream4fATI;
extern PFNGLVERTEXSTREAM4FVATIPROC			glVertexStream4fvATI;
extern PFNGLVERTEXSTREAM4DATIPROC			glVertexStream4dATI;
extern PFNGLVERTEXSTREAM4DVATIPROC			glVertexStream4dvATI;
									
extern PFNGLNORMALSTREAM3BATIPROC			glNormalStream3bATI;
extern PFNGLNORMALSTREAM3BVATIPROC			glNormalStream3bvATI;
extern PFNGLNORMALSTREAM3SATIPROC			glNormalStream3sATI;
extern PFNGLNORMALSTREAM3SVATIPROC			glNormalStream3svATI;
extern PFNGLNORMALSTREAM3IATIPROC			glNormalStream3iATI;
extern PFNGLNORMALSTREAM3IVATIPROC			glNormalStream3ivATI;
extern PFNGLNORMALSTREAM3FATIPROC			glNormalStream3fATI;
extern PFNGLNORMALSTREAM3FVATIPROC			glNormalStream3fvATI;
extern PFNGLNORMALSTREAM3DATIPROC			glNormalStream3dATI;
extern PFNGLNORMALSTREAM3DVATIPROC			glNormalStream3dvATI;
#endif


#ifdef GL_EXT_blend_color
extern PFNGLBLENDCOLOREXTPROC				glBlendColorEXT;
#endif


#ifdef GL_EXT_blend_func_separate
extern PFNGLBLENDFUNCSEPARATEEXTPROC		glBlendFuncSeparateEXT;
#endif


#ifdef GL_EXT_blend_minmax
extern PFNGLBLENDEQUATIONEXTPROC			glBlendEquationEXT;
#endif


#ifdef GL_EXT_draw_range_elements
extern PFNGLDRAWRANGEELEMENTSEXTPROC		glDrawRangeElementsEXT;
#endif


#ifdef GL_EXT_fog_coord
extern PFNGLFOGCOORDFEXTPROC				glFogCoordfEXT;
extern PFNGLFOGCOORDDEXTPROC				glFogCoorddEXT;
extern PFNGLFOGCOORDFVEXTPROC				glFogCoordfvEXT;
extern PFNGLFOGCOORDDVEXTPROC				glFogCoorddvEXT;
extern PFNGLFOGCOORDPOINTEREXTPROC			glFogCoordPointerEXT;
#endif


#ifdef GL_EXT_polygon_offset
extern PFNGLPOLYGONOFFSETEXTPROC			glPolygonOffsetEXT;
#endif


#ifdef GL_EXT_texture3D
extern PFNGLTEXIMAGE3DEXTPROC				glTexImage3DEXT;
#endif


#ifdef GL_NV_occlusion_query
extern PFNGLGENOCCLUSIONQUERIESNVPROC		glGenOcclusionQueriesNV;
extern PFNGLDELETEOCCLUSIONQUERIESNVPROC	glDeleteOcclusionQueriesNV;
extern PFNGLISOCCLUSIONQUERYNVPROC			glIsOcclusionQueryNV;
extern PFNGLBEGINOCCLUSIONQUERYNVPROC		glBeginOcclusionQueryNV;
extern PFNGLENDOCCLUSIONQUERYNVPROC			glEndOcclusionQueryNV;
extern PFNGLGETOCCLUSIONQUERYIVNVPROC		glGetOcclusionQueryivNV;
extern PFNGLGETOCCLUSIONQUERYUIVNVPROC		glGetOcclusionQueryuivNV;
#endif


#ifdef GL_NV_register_combiners
extern PFNGLCOMBINERPARAMETERFVNVPROC		glCombinerParameterfvNV;
extern PFNGLCOMBINERPARAMETERFNVPROC		glCombinerParameterfNV;
extern PFNGLCOMBINERPARAMETERIVNVPROC		glCombinerParameterivNV;
extern PFNGLCOMBINERPARAMETERINVPROC		glCombinerParameteriNV;
									
extern PFNGLCOMBINERINPUTNVPROC				glCombinerInputNV;
extern PFNGLCOMBINEROUTPUTNVPROC			glCombinerOutputNV;
extern PFNGLFINALCOMBINERINPUTNVPROC		glFinalCombinerInputNV;

extern PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC  glGetCombinerInputParameterfvNV;
extern PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC  glGetCombinerInputParameterivNV;
extern PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC glGetCombinerOutputParameterfvNV;
extern PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC glGetCombinerOutputParameterivNV;

extern PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC glGetFinalCombinerInputParameterfvNV;
extern PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC glGetFinalCombinerInputParameterivNV;
#endif


#ifdef WGL_ARB_pbuffer
extern PFNWGLCREATEPBUFFERARBPROC			wglCreatePbufferARB;
extern PFNWGLGETPBUFFERDCARBPROC			wglGetPbufferDCARB;
extern PFNWGLRELEASEPBUFFERDCARBPROC		wglReleasePbufferDCARB;
extern PFNWGLDESTROYPBUFFERARBPROC			wglDestroyPbufferARB;
extern PFNWGLQUERYPBUFFERARBPROC			wglQueryPbufferARB;
#endif


#ifdef WGL_ARB_render_texture
extern PFNWGLBINDTEXIMAGEARBPROC			wglBindTexImageARB;
extern PFNWGLRELEASETEXIMAGEARBPROC			wglReleaseTexImageARB;
extern PFNWGLSETPBUFFERATTRIBARBPROC		wglSetPbufferAttribARB;
#endif

#endif
