/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_FRAMEMODEL_H
#define __GRAPHICS3D_FRAMEMODEL_H

#include "graphics3d.model.h"
#include "container.array.h"
#include "object.pointer.h"


namespace magnum { namespace graphics3d {
using magnum::container::Array;
using magnum::object::Pointer;

class Mesh;
class MeshGroup;
class RenderStream;
class VertexBuffer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FrameModel : public Model {
DeclareClass(FrameModel, Model);
private:
	typedef Pointer<VertexBuffer>	VertexBufferP;

	struct Group {
		Array<VertexBufferP>	m_Frames;
		Pointer<MeshGroup>		m_MeshGroup;
		Pointer<RenderStream>	m_Stream;
	};

	Array<Group>			m_Groups;

public:
	inline					FrameModel();

	unsigned int			insertGroup(MeshGroup* );
	bool					removeGroup(MeshGroup* );				

	void					insertFrame(MeshGroup* ,VertexBuffer* ,unsigned int frame );
	void					removeFrame(MeshGroup* ,unsigned int );
	void					removeFrame(MeshGroup* ,VertexBuffer* );

	inline void				clear();
	void					finish();

	void					getGroups(Array<MeshGroup*>* ) const;
	void					getMeshes(Array<Mesh*>* ) const;
	void					getFrames(const MeshGroup* ,Array<VertexBuffer*>* ) const;

protected:
	virtual void			onRender(const ParameterBuffer* ) const;
	virtual bool			onOptimize();
};

}; };

#endif
