/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_INDEXMESH_H
#define __GRAPHICS3D_INDEXMESH_H

#include "object.pointer.h"
#include "graphics3d.vertexmesh.h"


namespace magnum { namespace graphics3d {
using magnum::object::Pointer;

class IndexBuffer;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class IndexMesh : public VertexMesh {
DeclareClass(IndexMesh, VertexMesh);
private:
	Pointer<IndexBuffer>	m_IndexBuffer;

public:
	inline IndexBuffer*		getIndexBuffer() const;
	inline void				attachIndexBuffer(IndexBuffer* );
	inline void				detachIndexBuffer();

protected:
	inline void				selectIndexBuffer() const;

	virtual void			onRender() const;
	virtual TriangleMesh3<float>* onTriangulate() const;
	virtual bool			onBound(Bounds3<float>* ) const;
};

}; };

#endif
