/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_LIGHTSTACK_H
#define __GRAPHICS3D_LIGHTSTACK_H

#include "object.h"
#include "graphics3d.light.h"


namespace magnum {namespace graphics3d {

class Context;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class LightStack : public Object {
DeclareClass(LightStack, Object);
friend Light;
friend Context;
private:
	const Light*	m_Light[Light::MaxLights];
	int				m_MaxLights;

public:
	enum LightMode {
		TwoSided = 2,
		LocalViewer = 4
	};

private:
	inline LightStack();

public:
	inline const Light*	getLight(int = 0) const;

	inline int			getMaxLights() const;

	inline void			enableLighting(unsigned int flags = 0);
	inline void			disableLighting();
	inline bool			isLighting() const;

};

}; };

#endif
