/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_MESHFACTORY_H
#define __GRAPHICS3D_MESHFACTORY_H

#include "graphics3d.meshbuilder.h"
#include "geometry.sphere.h"
#include "geometry.cube.h"
#include "geometry.box.h"
#include "geometry.alignedbox.h"

namespace magnum { namespace graphics3d {
using magnum::geometry::Sphere;
using magnum::geometry::Cube;
using magnum::geometry::Box;
using magnum::geometry::AlignedBox;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MeshFactory : public Object {
DeclareClass(MeshFactory, Object);
private:
	MeshBuilder			m_Builder;
	
public:
	Mesh*				createSphere(Vector3<float>& ,float ,unsigned int n = 20);
	Mesh*				createSphere(const Sphere<float,3>&, unsigned int n = 20);
	
	Mesh*				createCube(Vector3<float>& ,float );
	Mesh*				createCube(const Cube<float,3>& );
	
	Mesh*				createBox(const Cube<float,3>& );
	Mesh*				createBox(const AlignedBox<float,3>& );
	Mesh*				createBox(const Box<float,3>& );
};

}; };

#endif
