/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_MESHGROUP_H
#define __GRAPHICS3D_MESHGROUP_H

#include "graphics3d.resource.h"
#include "container.array.h"
#include "object.pointer.h"


namespace magnum { namespace graphics3d {
using magnum::container::Array;
using magnum::object::Pointer;

class Mesh;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MeshGroup : public Resource {
DeclareClass(MeshGroup, Resource);
private:
	typedef Pointer<Mesh>	MeshP;
	Array<MeshP>		m_Meshes;

public:
	typedef magnum::container::Array<MeshP>::Iterator	Iterator;

public:	
	inline void			insert(Mesh* );
	bool				remove(Mesh* );
	inline void			remove(unsigned int );
	inline void			clear();
	inline bool			contains(Mesh* ) const;
	
	inline Iterator		begin() const;
	inline Iterator		end() const;
	inline Iterator		at(unsigned int ) const;
	Iterator			at(const char* ) const;

	inline Mesh*		operator[](unsigned int ) const;
};

}; };

#endif
