/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_MESHGROUP_INL
#define __GRAPHICS3D_MESHGROUP_INL

namespace magnum {namespace graphics3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void MeshGroup::insert(Mesh* mesh) {
	ASSERT(mesh != NULL);
	m_Meshes.insert(mesh);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	MeshGroup::remove(unsigned int i) {
	m_Meshes.remove(i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	MeshGroup::clear() {
	m_Meshes.clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	MeshGroup::contains(Mesh* mesh) const {
	return m_Meshes.contains(mesh);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline MeshGroup::Iterator MeshGroup::begin() const {
	return m_Meshes.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline MeshGroup::Iterator MeshGroup::end() const {
	return m_Meshes.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline MeshGroup::Iterator MeshGroup::at(unsigned int i) const {
	return m_Meshes.at(i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Mesh* MeshGroup::operator[](unsigned int i) const {
	return m_Meshes[i];
}

}; };

#endif
