/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_POINTLIGHT_INL
#define __GRAPHICS3D_POINTLIGHT_INL


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline PointLight::PointLight() {
	m_Position = Vector3<float>(0.0f,0.0f,0.0f);
	m_Attenuation = Vector3<float>(1.0f,0.0f,0.0f);
	m_Ambient = Colour<float>(0.1f,0.1f,0.1f);
	m_Diffuse = Colour<float>(1.0f,1.0f,1.0f);
	m_Specular = Colour<float>(1.0f,1.0f,1.0f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& PointLight::getAmbient() const {
	return m_Ambient;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void PointLight::setAmbient(const Colour<float>& c) {
	m_Ambient = c;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& PointLight:: getDiffuse() const {
	return m_Diffuse;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void PointLight::setDiffuse(const Colour<float>& d) {
	m_Diffuse = d;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& PointLight::getSpecular() const {
	return m_Specular;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void PointLight::setSpecular(const Colour<float>& c) {
	m_Specular = c;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& PointLight::getPosition() const {	
	return m_Position;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void PointLight::setPosition(const Vector3<float>& p) {
	m_Position = p;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& PointLight::getAttenuation() const {
	return m_Attenuation;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void PointLight::setAttenuation(const Vector3<float>& a) {
	m_Attenuation = a;
}


}; };

#endif
