/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_SPRINGMODEL_INL
#define __GRAPHICS3D_SPRINGMODEL_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SpringModel::relax(float dt) {
	if (m_Springs == NULL)
		return;
	m_Springs->relax(dt);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SpringModel::attachSprings(Relaxator<float,3>* r) {
	ASSERT(r != NULL);
	m_Springs = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SpringModel::detachSprings() {
	m_Vertices.clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Relaxator<float,3>* SpringModel::getSprings() const {
	return m_Springs;
}

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SpringModel::attachAppearance(Appearance* a) {
	m_Mesh.attachAppearance(a);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SpringModel::detachAppearance() {
	m_Mesh.detachAppearance();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Appearance* SpringModel::getAppearance() const {
	return m_Mesh.getAppearance();
}

}; };

#endif
