/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_TRANSLATOR_INL
#define __GRAPHICS3D_TRANSLATOR_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ModelTranslator::attachTextureManager(TextureManager* m) {
	ASSERT(m != NULL);
	m_TextureManager = m;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ModelTranslator::detachTextureManager() {
	m_TextureManager = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline TextureManager* ModelTranslator::getTextureManager() const {
	return m_TextureManager;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ModelTranslator::attachShaderManager(ShaderManager* m) {
	ASSERT(m != NULL);
	m_ShaderManager = m;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ModelTranslator::detachShaderManager() {
	m_ShaderManager = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ShaderManager* ModelTranslator::getShaderManager() const {
	return m_ShaderManager;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline TextureManager* ModelTranslatorRoster::getTextureManager() const {
	return m_TextureManager;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ShaderManager* ModelTranslatorRoster::getShaderManager() const {
	return m_ShaderManager;
}



}; };

#endif
