/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GUI_BITMAP_H
#define __GUI_BITMAP_H

#include "graphics.image.h"


namespace magnum { namespace gui {
using magnum::graphics::Image;
using magnum::graphics::Dimension;
using magnum::graphics::Palette;
using magnum::types::String;

class Context;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Bitmap : public Image {
DeclareClass(Bitmap, Image);
friend Context;
private:
#if defined(__FORWINDOWS__)
	HDC       	m_Device;
	HBITMAP  	m_Bitmap;
	void*		m_Pixels;
#endif

protected:
	inline		Bitmap(Image::Type type, int w, int h);

public:
	static Bitmap* create(Type type, const Dimension<int>& size);
	static Bitmap* create(Type type, int w, int h);
	static Bitmap* create(Image* img);
	inline		~Bitmap();

protected:
	void*		onLock();
	bool		onGetPalette(Palette<byte>* pal) const;
	bool		onSetPalette(const Palette<byte>& pal);

private:
	bool		createBitmap();
	bool		releaseBitmap();
	bool		adjustBitmap();
};

}; };

#endif
