/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GUI_IMAGEVIEW_H
#define __GUI_IMAGEVIEW_H

#include "object.pointer.h"
#include "gui.view.h"
#include "gui.bitmap.h"

namespace magnum { namespace gui {
using magnum::graphics::Image;
using magnum::object::Pointer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class ImageView : public View {
DeclareClass(ImageView, View);
private:
	Pointer<Bitmap>		m_Image;

public:
	inline ImageView(const Rectangle<float>& frame, Bitmap* bmp);
	inline ~ImageView();

	inline Bitmap*		getImage() const;
	inline void			setImage(Bitmap* img);

protected:
	virtual bool onPaint(Context* , const Rectangle<float>& );
};

}; };

#endif
