/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GUI3D_BUTTON_INL
#define __GUI3D_BUTTON_INL

namespace magnum { namespace gui3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Button::setText(const char* t) {
	ASSERT(t != NULL);
	m_Text = t;
	m_FontMap = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const String& Button::getText() const {
	return m_Text;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Button::setFont(const Font* font) {
	ASSERT(font != NULL);
	m_Font = font;
	m_FontMap = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Font* Button::getFont() {
	return m_Font;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Button::isPressed() const {
	return (m_State == PressedState);
}

}; };

#endif
