/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_BUFFER_H
#define __IO_BUFFER_H

#include "io.inputstream.h"
#include "io.outputstream.h"


namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class InputBuffer : public InputStream {
DeclareClass(InputBuffer, InputStream);
private:
	InputStream*	m_Stream;
	byte*			m_Buffer;
	byte*			m_BufferCurrent;
	int				m_BufferSize;
	int				m_BufferLeft;

public:
	inline ~InputBuffer();
	inline InputBuffer(int bufsize = 16384);
	inline InputBuffer(InputStream* ,int bufsize = 16384);
	inline InputBuffer(InputStream& ,int bufsize = 16384);

	inline InputStream*		getStream() const;
	inline void				setStream(InputStream* );
	inline void				setStream(InputStream& );

	virtual unsigned long read(void *buffer, unsigned long size);
	virtual unsigned long skip(unsigned long size);
	virtual unsigned long available();
	virtual bool	close();
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class OutputBuffer : public OutputStream {
DeclareClass(OutputBuffer, OutputStream);

};

}; };

#endif
