/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_FILTER_INL
#define __IO_FILTER_INL

namespace magnum {namespace io {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline FilterChain<T> Filter<T>::operator<<(Filter<T>& f) {
	return FilterChain(f, *this);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline T* Filter<T>::operator<<(const T* in) {
	return process(in);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline FilterChain<T>::FilterChain() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline FilterChain<T>::FilterChain(Filter<T>& flt) {
	m_Filters.insert(&flt);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline FilterChain<T>::FilterChain(Filter<T>& f1, Filter<T>& f2) {
	m_Filters.insert(&f1);
	m_Filters.insert(&f2);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline FilterChain<T>& FilterChain<T>::operator<<(Filter<T>& f) {
	m_Filters.insertFirst(&f);
	return *this;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline const FilterChain<T>& FilterChain<T>::operator=(FilterChain<T>& fc) {
	m_Filters = fc.m_Filters;
	return *this;	
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void FilterChain<T>::append(Filter<T>& f) {
	m_Filters.insert(&f);
}

}; };


#endif
