/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_INPUTSTREAM_INL
#define __IO_INPUTSTREAM_INL

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputStream& operator>>(InputStream& stream, String& str) {
	unsigned int size = stream.available();
	if (size > 0) {
		char *buffer = new char[size+1];
		stream.read(buffer, size);
		buffer[size] = 0;
		str = buffer;
		delete[] buffer;
	}
	return stream;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputStream* operator>>(InputStream* stream, String& str) {
	unsigned int size = stream->available();
	if (size > 0) {
		char *buffer = (char *)new char[size+1];
		stream->read(buffer, size);
		buffer[size] = 0;
		str = buffer;
		delete[] buffer;
	}
	return stream;
}

}; };

#endif
