/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MATH_EIGENSYSTEM_H
#define __MATH_EIGENSYSTEM_H

#include "object.h"
#include "math.matrix.h"

namespace magnum { namespace math {
using magnum::types::String;
using magnum::object::Object;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class EigenSystem : public Object {
DeclareClass(EigenSystem, Object);
private:
	T*						m_System;
	unsigned int			m_Size;

public:
	EigenSystem(unsigned int size = 0);
	EigenSystem(const EigenSystem& );
	~EigenSystem();
	
	inline void				setSize(unsigned int );
	inline unsigned int		getSize() const;

	template<int dim> 
	inline					EigenSystem(const Matrix<T,dim>& );
	template<int dim> 
	inline EigenSystem&	operator=(const Matrix<T,dim>& );
	template<int dim> 
	
	inline const T&			operator()(unsigned int, unsigned int) const;
	inline T&				operator()(unsigned int, unsigned int);
	
	inline const T*			operator[](unsigned int) const;
	inline T*				operator[](unsigned int);

	EigenSystem&			operator=(const EigenSystem& );
};


}; };

#endif
