/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MATH_FACORIAL_INL
#define __MATH_FACORIAL_INL

namespace magnum { namespace math {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline T factorial(const T& n) {
	ASSERT(n >= T(0));
	T result = n;
	while(n > T(1)) {
		n--;
		result *= n;
	}
	return result;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> T binomial(const T& n, const T& k) {
	ASSERT(n >= T(0));
	ASSERT((k >= T(0)) && (k <= n));
	T result;
	result = factorial(n);
	result /= factorial(k);
	result /= factorial(n-k);
	return result;
}


}; };

#endif
