/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MATH_TREE_H
#define __MATH_TREE_H

namespace magnum { namespace math {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Tree : public Object {
public:
	class Node {
	private:
		T			m_Item;
		
	public:
		T*			operator->();
		const T* 	operator->() const;
		T&			operator*();
		const T& 	operator*() const;
	};
	
private:
	
	
public:
	Node*			insertRoot(const T& item);
	Node*			insertNode(const T& item);
	
	Node*			getRoot() const;
	
	void			clear();
	
	bool			isEmpty() const;
};

}; };

#endif
