/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MEDIA_HANDLER_INL
#define __MEDIA_HANDLER_INL

namespace magnum { namespace media {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message() {
	m_Node = NULL;
	m_Command = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message(const Message& msg) {
	m_Node = msg.m_Node;
	m_Command = msg.m_Command;
	m_Parameter = msg.m_Parameter;
	m_Pointer = msg.m_Pointer;
	m_Pin = msg.m_Pin;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message(int command) {
	m_Node = NULL;
	m_Command = command;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message(int command, int parameter) {
	m_Node = NULL;
	m_Command = command;
	m_Parameter = parameter;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message(int command, int parameter, void *pointer) {
	m_Node = NULL;
	m_Command = command;
	m_Parameter = parameter;
	m_Pointer = pointer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message(int command, void *pointer) {
	m_Node = NULL;
	m_Command = command;
	m_Pointer = pointer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int	Message::getCommand() const {
	return m_Command;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Message::setCommand(int cmd) {
	m_Command = cmd;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void* Message::getPointer() const {
	return m_Pointer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Message::setPointer(void* ptr) {
	m_Pointer = ptr;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int	Message::getParameter() const {
	return m_Parameter;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Message::setParameter(int param) {
	m_Parameter = param;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Node* Message::getNode() const {
	return m_Node;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Pin* Message::getPin() const {
	return m_Pin;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Message::setPin(Pin* pin) {
	m_Pin = pin;
}


}; };

#endif
