/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MEDIA_VIDEO_H
#define __MEDIA_VIDEO_H

#include "object.h"

namespace magnum { namespace media {

class VideoDevice;
class VideoProducer;
class VideoConsumer;
class VideoFilter;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class VideoDevice : public Device {
DeclareClass(VideoDevice, Device);
public:
	static VideoDevice*	create(const char* dev = Device::DefaultVideo, bool exclusive = false);

	inline VideoProducer*	createInput();
	inline VideoConsumer*	createOutput();
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class VideoProducer : public Node {
DeclareClass(VideoProducer, Node);
public:
	inline VideoProducer(Device* dev, const char*name);

};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class VideoConsumer : public Node {
DeclareClass(VideoConsumer, Node);
public:
	inline VideoConsumer(Device* dev, const char*name);

};


}; };

#endif
