/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MEDIA_WAVEDEVICE_WIN_H
#define __MEDIA_WAVEDEVICE_WIN_H

#include "media.audio.h"
#include "system.thread.h"

#ifndef __FORWINDOWS__
#	error "This file is only for Windows"
#endif


namespace magnum { namespace media { namespace _windows {
using namespace magnum::media;
using magnum::system::Thread;

class WaveProducer;
class WaveConsumer;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class WaveBuffer : public Buffer {
DeclareClass(WaveBuffer, Buffer);
friend class WaveProducer;
friend class WaveConsumer;
private:
	WAVEHDR			m_WaveHeader;

public:
	inline WaveBuffer(Node* node, int data = 0);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class WaveDevice : public AudioDevice {
DeclareClass(WaveDevice, AudioDevice);
public:
	WaveDevice();
	~WaveDevice();

private:
	static Node*	createInput(Device* dev, const char* name);
	static Node*	createOutput(Device* dev, const char* name);
};


}; }; };

#endif
