/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MEDIA_WAVEPRODUCER_WIN_H
#define __MEDIA_WAVEPRODUCER_WIN_H

#include "media.audio.h"
#include "system.thread.h"

#ifndef __FORWINDOWS__
#	error "This file is only for Windows"
#endif


namespace magnum { namespace media { namespace _windows {
using namespace magnum::media;
using magnum::object::Object;
using magnum::types::String;
using magnum::system::Thread;

class WaveDevice;
class WaveBuffer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class WaveProducer : public AudioProducer {
DeclareClass(WaveProducer, AudioProducer);
friend class WaveDevice;
private:
	class WaveThread : public Thread {
	DeclareClass(WaveThread, Thread);
	private:
		WaveProducer*	m_Node;

	public:
		WaveThread(WaveProducer* p);
		~WaveThread();

	protected:
		bool			run();
	};

	friend class WaveThread;


	Thread*				m_Thread;
	OutputPin			m_OutputPin;
	int					m_BufferSize;
	HWAVEIN				m_WaveHandle;
	WAVEFORMATEX		m_WaveFormat;

public:
	WaveProducer(WaveDevice* device);
	~WaveProducer();

protected:
	// Format methods
	virtual bool		onAdjustFormat(Pin* ,Format* );
	virtual bool		onSetFormat(Pin* ,const Format* );

	// Start/Stop/Pause - this is system and device specific
	virtual bool		onStart();
	virtual bool		onStop();
	virtual bool		onPause();
	virtual bool		onUnpause();

private:
	bool				addBuffer(WaveBuffer* buf);
};


}; }; };

#endif
