/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __NET_STREAMSOCKET_H
#define __NET_STREAMSOCKET_H

#include "net.socket.h"

namespace magnum { namespace net {
using magnum::object::Object;
using magnum::types::String;

class ServerSocket;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class StreamSocket : public Socket {
DeclareClass(StreamSocket, Socket);
friend class ServerSocket;
public:
	inline StreamSocket();
	inline StreamSocket(unsigned int port);
	inline StreamSocket(const Address& localAdr, unsigned int port);
	inline StreamSocket(const String& localAdr, unsigned int port);

	inline bool				getKeepAlive() const;
	inline void				setKeepAlive(bool val);

	inline bool				getNoDelay() const;
	inline void				setNoDelay(bool val);
};

typedef StreamSocket GTCPSocket;

/*
 int getSoLinger() 
          Returns setting for SO_LINGER. 
 int getSoTimeout() 
          Returns setting for SO_TIMEOUT. 
 void setSoLinger(boolean on, int linger) 
          Enable/disable SO_LINGER with the specified linger time in seconds. 
 void setSoTimeout(int timeout) 
          Enable/disable SO_TIMEOUT with the specified timeout, in milliseconds. 
*/


}; };
#endif
