#ifndef __NET_STREAMSOCKET_INL
#define __NET_STREAMSOCKET_INL

namespace magnum { namespace net {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline StreamSocket::StreamSocket() : Socket(IPPROTO_TCP) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline StreamSocket::StreamSocket(unsigned int port) : Socket(IPPROTO_TCP) {
	bind(port);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline StreamSocket::StreamSocket(const Address& localAdr, unsigned int port) : Socket(IPPROTO_TCP) {
	bind(localAdr, port);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline StreamSocket::StreamSocket(const String& localAdr, unsigned int port) : Socket(IPPROTO_TCP) {
	bind(localAdr, port);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	StreamSocket::getKeepAlive() const {
	bool b;
	int len = sizeof(b);
	getsockopt(m_Socket, SOL_SOCKET, SO_KEEPALIVE, (char *)&b, &len);
	return (b == TRUE);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	StreamSocket::setKeepAlive(bool val) {
	bool b = val;
	setsockopt(m_Socket, SOL_SOCKET, SO_KEEPALIVE, (char *)&b, sizeof(b));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool StreamSocket::getNoDelay() const {
	bool b;
	int len = sizeof(b);
	getsockopt(m_Socket, IPPROTO_TCP, TCP_NODELAY, (char *)&b, &len);
	return (b == TRUE);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	StreamSocket::setNoDelay(bool val) {
	bool b = val;
	setsockopt(m_Socket, IPPROTO_TCP, TCP_NODELAY, (char *)&b, sizeof(b));
}

}; };
#endif
