/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __OBJECT_AUTOPOINTER_H
#define __OBJECT_AUTOPOINTER_H

#include "base.h"

namespace magnum { namespace object {
template<class T> class Pointer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class AutoPointer {
private:
	T*			m_Pointer;

public:
	inline AutoPointer();
	inline AutoPointer(T* ptr);
	inline AutoPointer(const Pointer<T>& );
	inline AutoPointer(const AutoPointer<T>& );
	inline ~AutoPointer();

	inline T*			operator->();
	inline const T*		operator->() const;
	inline				operator T*() const;

	inline bool			isNull() const;
	inline void			setNull();
	inline void			release();

	inline bool			operator==(const AutoPointer<T>& lhs) const;
	inline bool			operator!=(const AutoPointer<T>& lhs) const;
	inline bool			operator<(const AutoPointer<T>& lhs) const;
	inline bool			operator>(const AutoPointer<T>& lhs) const;
	inline bool			operator<=(const AutoPointer<T>& lhs) const;
	inline bool			operator>=(const AutoPointer<T>& lhs) const;
	inline bool			operator==(const T* lhs) const;
	inline bool			operator==(T* lhs) const;
	inline bool			operator==(intptr_t lhs) const;
	inline bool			operator!=(const T* lhs) const;
	inline bool			operator!=(T* lhs) const;
	inline bool			operator!=(intptr_t lhs) const;
};

}; };

#endif
