/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_ACTIVATORNODE_H
#define __SCENE3D_ACTIVATORNODE_H

#include "scene3d.behaviour.h"

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class ActivatorNode : public Behaviour {
DeclareClass(ActivatorNode, Behaviour)
private:
	Transform3<float>	m_WorldTransform;
	Transform3<float>	m_Transform;
	Frustum3<float>		m_Frustum;

public:
	inline void			setTransform(const Transform3<float>& );
	inline const Transform3<float>& getTransform() const;

	inline const Frustum3<float>& getFrustum() const;
	inline const Transform3<float>& getWorldTransform() const;

protected:
	virtual void		onAttachLocale(Locale* );
	virtual void		onDetachLocale(Locale* );
	virtual void		onEnable();
	virtual void		onDisable();
	virtual void		onTransform(const Transform3<float>& );
};

}; };

#endif
