/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_AUDIOQUEUE_H
#define __SCENE3D_AUDIOQUEUE_H

#include "object.h"
#include "container.chain.h"

namespace magnum { namespace scene3d {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Chain;

class SoundNode;
class Observer;
class Universe;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class AudioQueue : public Object {
DeclareClass(AudioQueue, Object);
private:
	Observer*			m_Observer;
	Universe*			m_Universe;
	Chain<SoundNode>	m_ActiveSounds;
	
public:
	AudioQueue(Observer* );
	~AudioQueue();

	inline void			insert(SoundNode* );
	inline void			remove(SoundNode* );
	inline bool			contains(const SoundNode* ) const;

	void				clear();

	void				listen();
};

}; };

#endif
