/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_BEHAVIOUR_H
#define __SCENE3D_BEHAVIOUR_H

#include "scene3d.leaf.h"
#include "scene3d.observer.h"
#include "container.scheduler.h"

namespace magnum { namespace scene3d {
using magnum::container::Scheduler;
using magnum::container::Task;

class Timer;
class BehaviourScheduler;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Behaviour : public Leaf<Behaviour>, public Task<Behaviour> {
DeclareClass(Behaviour, Leaf<Behaviour>);
friend class BehaviourScheduler;
public:
	enum Type {
		ControllerType	= 0x02000000,
		AllBehaviours	= 0xff000000
	};

	typedef magnum::container::Task<Behaviour>::Priority Priority;

protected:
	inline explicit Behaviour(Type t);

public:
	inline Behaviour();

protected:
	virtual void		onProcess(const Timer& );
	virtual void		onAttachLocale(Locale* );
	virtual void		onDetachLocale(Locale* );
	virtual void		onEnable();
	virtual void		onDisable();
};

}; };

#endif
