/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_CAMERANODE_INL
#define __SCENE3D_CAMERANODE_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline CameraNode::CameraNode() {
	m_Transform = Transform3<float>::Identity;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void CameraNode::setTransform(const Transform3<float>& t) {
	m_Transform = t;
	if(hasParentTransform())
		applyParentTransform();
	else
		m_WorldTransform = t;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& CameraNode::getTransform() const {
	return m_Transform;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& CameraNode::getWorldTransform() const {
	return m_WorldTransform;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Frustum3<float>& CameraNode::getFrustum() const {
	return m_Frustum;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	CameraNode::setViewWindow(const Rectangle<float>& w) {
	m_Camera.setViewWindow(w);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	CameraNode::setNearPlane(float f) {
	m_Camera.setNearPlane(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float CameraNode::getNearPlane() const {
	return m_Camera.getNearPlane();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void CameraNode::setFarPlane(float f) {
	m_Camera.setFarPlane(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float CameraNode::getFarPlane() const {
	return m_Camera.getFarPlane();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void CameraNode::onSelect() const {
	m_Camera.select();
}


}; };

#endif
