/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_DIRLIGHTNODE_H
#define __SCENE3D_DIRLIGHTNODE_H

#include "scene3d.lightnode.h"
#include "graphics3d.dirlight.h"

namespace magnum { namespace scene3d {
using magnum::graphics3d::DirectionalLight;
using magnum::graphics::Colour;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class DirectionalLightNode : public LightNode {
DeclareClass(DirectionalLightNode, LightNode);
private:
	DirectionalLight			m_Light;
	Vector3<float>				m_Direction;

public:
	inline DirectionalLightNode();
	inline ~DirectionalLightNode();

	inline const Colour<float>& getAmbient() const;
	inline void 				setAmbient(const Colour<float>& );
	inline const Colour<float>&	getDiffuse() const;
	inline void					setDiffuse(const Colour<float>& );
	inline const Colour<float>&	getSpecular() const;
	inline void					setSpecular(const Colour<float>& );

	inline const Vector3<float>& getDirection() const;
	inline void					setDirection(const Vector3<float>& );

protected:
	virtual void				onTransform(const Transform3<float>& parent);
};

}; };

#endif
