/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_LINK_H
#define __SCENE3D_LINK_H

#include "object.pointer.h"
#include "container.chain.h"
#include "geometry.transform.h"
#include "scene3d.leaf.h"

namespace magnum { namespace scene3d {
using magnum::object::Pointer;
using magnum::container::Chain;
using magnum::container::Chainable;
using magnum::geometry::Transform3;

class SharedGroup;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Link : public Leaf<Link>, private Chainable<Link> {
DeclareClass(Link, Leaf<Link>);
private:
	Pointer<SharedGroup>	m_Target;
	Transform3<float>		m_Transform;

public:
	inline Link();
	inline explicit Link(SharedGroup* );

	inline void				setTransform(const Transform3<float>& );
	inline const Transform3<float>& getTransform() const;

	inline SharedGroup*		getTarget() const;
	inline void				setTarget(SharedGroup* );

protected:
	virtual void			onAttachLocale(Locale* );
	virtual void			onDetachLocale(Locale* );
};

typedef Chain<Link>		LinkList;

}; };

#endif
