/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_LINK_INL
#define __SCENE3D_LINK_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Link::Link() : Leaf<Link>(Node::LinkType) {
	m_Transform.identity();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Link::Link(SharedGroup* g) : Leaf<Link>(Node::LinkType) {
	ASSERT(g != NULL);
	m_Transform.identity();
	m_Target = g;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline SharedGroup* Link::getTarget() const {
	return m_Target;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Link::setTarget(SharedGroup* g) {
	ASSERT(g != NULL);
	m_Target = g;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Link::setTransform(const Transform3<float>& mtx) {
	m_Transform = mtx;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& Link::getTransform() const {
	return m_Transform;
}


}; };

#endif
