/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_LISTENERNODE_INL
#define __SCENE3D_LISTENERNODE_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ListenerNode::ListenerNode() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Vector3<float> ListenerNode::getPosition() const {
	return m_Position;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ListenerNode::setPosition(const Vector3<float>& v) {
	m_Position = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Vector3<float> ListenerNode::getVelocity() const {
	return m_Listener.getVelocity();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ListenerNode::setVelocity(const Vector3<float>& v) {
	m_Listener.setVelocity(v);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& ListenerNode::getWorldTransform() const {
	return m_WorldTransform;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& ListenerNode::getWorldPosition() const {
	return m_WorldPosition;
}


}; };

#endif
