/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_MESHGROUP_H
#define __SCENE3D_MESHGROUP_H

#include "graphics3d.meshgroup.h"
#include "object.pointer.h"
#include "scene3d.geometry.h"

namespace magnum { namespace scene3d {
using magnum::graphics3d::Mesh;
using magnum::object::Pointer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MeshGroup : public Geometry {
DeclareClass(MeshGroup, Geometry);
private:
	magnum::graphics3d::MeshGroup	m_Meshes;
							
public:						
	inline MeshGroup();		
							
	inline void				insertMesh(Mesh* );
	inline void				removeMesh(Mesh* );
	inline Mesh*			getMesh(unsigned int ) const;

protected:
	virtual void			onSchedule(RenderQueue* ,const Transform3<float>& );
	virtual void			onRender() const;
};

}; };

#endif
