/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_MESHNODE_H
#define __SCENE3D_MESHNODE_H

#include "graphics3d.mesh.h"
#include "object.pointer.h"
#include "scene3d.geometry.h"

namespace magnum { namespace scene3d {
using magnum::object::Pointer;
using magnum::graphics3d::Mesh;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MeshNode : public Geometry {
DeclareClass(MeshNode, Geometry);
private:
	Pointer<Mesh>			m_Mesh;
							
public:						
	inline MeshNode();		
	inline explicit MeshNode(Mesh* );		
							
	inline void				attachMesh(Mesh* );
	inline void				detachMesh();
	inline Mesh*			getMesh() const;

protected:
	virtual void			onSchedule(RenderQueue* ,const Transform3<float>& );
	virtual void			onRender() const;
};


}; };

#endif
