/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_MODIFIER_H
#define __SCENE3D_MODIFIER_H

#include "container.chain.h"
#include "geometry.bounds.h"
#include "scene3d.graphics.h"

namespace magnum { namespace scene3d {
using magnum::container::Chainable;
using magnum::geometry::Bounds3;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Modifier : public Graphics, private Chainable<Modifier> {
DeclareClass(Modifier, Graphics);
friend class RenderQueue;
private:
	Bounds3<float>				m_GlobalRange;	

protected:
	inline explicit Modifier(Type t);

protected:
	virtual void				onAttachLocale(Locale* );
	virtual void				onDetachLocale(Locale* );
	virtual void				onEnable();
	virtual void				onDisable();
	virtual void				onSelect() const;
	virtual void				onDeselect() const;
	virtual void				onSchedule(RenderQueue* ,const Transform3<float>& );
	
	inline void					setGlobalRange(const Bounds3<float>& );
	inline const Bounds3<float>& getGlobalRange() const;
};

}; };

#endif
