/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_OBSERVER_INL
#define __SCENE3D_OBSERVER_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Universe* Observer::getUniverse() const {
	return m_Universe;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline CameraNode* Observer::getCamera() const {
	return m_Camera;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Observer::attachCamera(CameraNode* cam) {
	ASSERT(cam != NULL);
	m_Camera = cam;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Observer::detachCamera() {
	m_Camera = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ListenerNode* Observer::getListener() const {
	return m_Listener;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Observer::attachListener(ListenerNode* l) {
	ASSERT(l != NULL);
	m_Listener = l;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Observer::detachListener() {
	m_Listener = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ActivatorNode* Observer::getActivator() const {
	return m_Activator;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Observer::attachActivator(ActivatorNode* l) {
	ASSERT(l != NULL);
	m_Activator = l;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Observer::detachActivator() {
	m_Activator = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Observer::GraphicsTraverser::onVisit(Graphics* leaf) const {
	leaf->onSchedule(m_RenderQueue, getTransform());
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Observer::BehaviourTraverser::onVisit(Behaviour* leaf) const {
	m_Scheduler->insert(leaf);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Observer::AudioTraverser::onVisit(Audio* leaf) const {
	m_AudioQueue->insert((SoundNode*)leaf);
}

}; };

#endif
