/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_POINTLIGHTNODE_INL
#define __SCENE3D_POINTLIGHTNODE_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline PointLightNode::PointLightNode() {
	attachLight(&m_Light);
	m_Position = Vector3<float>::Null;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline PointLightNode::~PointLightNode() {
	detachLight();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& PointLightNode::getAmbient() const {
	return m_Light.getAmbient();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void PointLightNode::setAmbient(const Colour<float>& c) {
	m_Light.setAmbient(c);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& PointLightNode::getDiffuse() const {
	return m_Light.getDiffuse();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void PointLightNode::setDiffuse(const Colour<float>& c) {
	m_Light.setDiffuse(c);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& PointLightNode::getSpecular() const {
	return m_Light.getSpecular();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void PointLightNode::setSpecular(const Colour<float>& c) {
	m_Light.setSpecular(c);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& PointLightNode::getPosition() const {
	return m_Position;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	PointLightNode::setPosition(const Vector3<float>& p) {
	m_Position = p;
	applyParentTransform();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& PointLightNode::getAttenuation() const {
	return m_Light.getAttenuation();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	PointLightNode::setAttenuation(const Vector3<float>& a) {
	m_Light.setAttenuation(a);
}

}; };

#endif
