/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_POSITIONCONTROLLER_H
#define __SCENE3D_POSITIONCONTROLLER_H

#include "math.vector3.h"
#include "scene3d.controller.h"

namespace magnum { namespace scene3d {
using magnum::math::Vector3;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class PositionController : public Controller<T> {
DeclareClass(PositionController, Controller);
private:
	Vector3<float>		m_Velocity;

public:
	inline PositionController();
	inline explicit PositionController(T* );

	inline void				setPosition(const Vector3<float>& );
	inline Vector3<float>	getPosition() const;

	inline void				setVelocity(const Vector3<float>& );
	inline Vector3<float>	getVelocity() const;

protected:
	void					onProcess(const Timer& );
};

}; };

#endif
