/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_REFERENCE_INL
#define __SCENE3D_REFERENCE_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Reference::Reference() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Reference::Reference(Node* node) {
	m_Node = node;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Reference::Reference(Node* n,const Transform3<float>& t) {
	m_Node = n;
	m_Transform = t;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Node* Reference::operator->() const {
	return m_Node;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Node& Reference::operator*() const {
	return *m_Node;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Reference::operator Node*() const {
	return m_Node;
}
					

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Node* Reference::getNode() const {
	return m_Node;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& Reference::getTransform() const {
	return m_Transform;
}


}; };

#endif
