/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_RENDERQUEUE_INL
#define __SCENE3D_RENDERQUEUE_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void RenderQueue::insert(Modifier* node) {
	node->setFlag(Node::ActiveModifier);
	if (node->getChain() != NULL)
		return;
	m_ActiveModifiers.insert(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	RenderQueue::remove(Modifier* node) {
	node->clearFlag(Node::ActiveModifier);
	m_ActiveModifiers.remove(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	RenderQueue::contains(const Modifier* m) const {
	return m_ActiveModifiers.contains(m);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	RenderQueue::insert(Geometry* node) {
	node->setFlag(Node::ActiveGeometry);
	if (node->getChain() != NULL)
		return;
	m_ActiveGeometries.insert(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	RenderQueue::remove(Geometry* node) {
	node->clearFlag(Node::ActiveGeometry);
	m_ActiveGeometries.remove(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	RenderQueue::contains(const Geometry* g) const {
	return m_ActiveGeometries.contains(g);
}
	
}; };

#endif
