/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_SCHEDULER_INL
#define __SCENE3D_SCHEDULER_INL

namespace magnum { namespace scene3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BehaviourScheduler::insert(Behaviour* node) {
	node->setFlag(Node::ActiveBehaviour);
	if (node->getScheduler() != NULL)
		return;
	m_ActiveBehaviours.insert(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	BehaviourScheduler::remove(Behaviour* node) {
	node->clearFlag(Node::ActiveBehaviour);
	m_ActiveBehaviours.remove(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	BehaviourScheduler::contains(const Behaviour* m) const {
	return m_ActiveBehaviours.contains(m);
}

}; };

#endif
