/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_SOUNDNODE_H
#define __SCENE3D_SOUNDNODE_H

#include "container.chain.h"
#include "scene3d.audio.h"
#include "audio3d.source.h"

namespace magnum { namespace scene3d {
using magnum::container::Chainable;
using magnum::audio3d::Source;

class AudioQueue;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SoundNode : public Audio, private Chainable<SoundNode> {
DeclareClass(SoundNode, Audio);
friend class AudioQueue;
private:
	Vector3<float>		m_Position;
	Vector3<float>		m_Velocity;
	Source				m_Source;
	
public:
	inline const Vector3<float>& getPosition() const;
	inline void			setPosition(const Vector3<float>& );

	inline const Vector3<float>& getVelocity() const;
	inline void			setVelocity(const Vector3<float>& );

protected:
	virtual void		onAttachLocale(Locale* );
	virtual void		onDetachLocale(Locale* );
	virtual void		onEnable();
	virtual void		onDisable();
	virtual void		onTransform(const Transform3<float>& );

	virtual void		onStart() const;
	virtual void		onStop() const;
};

}; };

#endif
