/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_TRANSFORMCONTROLLER_INL
#define __SCENE3D_TRANSFORMCONTROLLER_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline TransformController<T>::TransformController() : Controller() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline TransformController<T>::TransformController(T* m) : Controller(m) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void TransformController<T>::setPosition(const Vector3<float>& v) {
	ASSERT(m_Target != NULL);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline Vector3<float> TransformController<T>::getPosition() const {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void TransformController<T>::setLinearVelocity(const Vector3<float>& v) {
	m_LinVelocity = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline Vector3<float> TransformController<T>::getLinearVelocity() const {
	return m_LinVelocity;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void TransformController<T>::setRotation(const Vector3<float>& v) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline Vector3<float> TransformController<T>::getRotation() const {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void TransformController<T>::setAngularVelocity(const Vector3<float>& v) {
	m_AngVelocity = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline Vector3<float> TransformController<T>::getAngularVelocity() const {
	return m_AngVelocity;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> void TransformController<T>::onProcess(const Timer& ) {
	ASSERT(m_Target != NULL);
	Transform<float> t;
	m_Target->setTransform(t);
}

}; };

#endif
