/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_TRANSFORMGROUP_H
#define __SCENE3D_TRANSFORMGROUP_H

#include "scene3d.group.h"
#include "geometry.transform.h"

namespace magnum { namespace scene3d {
using magnum::geometry::Transform3;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class TransformGroup : public Group {
DeclareClass(TransformGroup, Group);
private:
	Transform3<float>		m_Transform;

public:
	inline TransformGroup();
	inline explicit TransformGroup(const Transform3<float>& );

	inline void						setTransform(const Transform3<float>& );
	inline const Transform3<float>&	getTransform() const;

protected:
	virtual void					onTransform(const Transform3<float>& );
};


}; };

#endif
