/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_UNIVERSE_H
#define __SCENE3D_UNIVERSE_H

#include "object.h"
#include "container.chain.h"
#include "scene3d.timer.h"
#include "scene3d.node.h"

namespace magnum { namespace scene3d {
using magnum::container::Chainable;
using magnum::container::Chain;

class Locale;
class Observer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Universe : public Object {
DeclareClass(Universe, Object);
friend class Observer;
friend class Locale;
friend class Node;
private:
	class DirtyNode : public Node {
	public:
		inline DirtyNode() : Node(Node::Unknown) {};
	};

	Chain<Locale>				m_Locales;
	Timer						m_Timer;
	DirtyNode					m_DirtyNodes;

public:
	typedef magnum::container::Chain<Locale>::Iterator Iterator;

public:
	Universe();
	~Universe();

	void					clear();
							
	inline bool				isEmpty() const;

	inline Iterator			begin() const;
	inline Iterator			end() const;
	Iterator				at(const char* ) const;

	inline const Timer*		getTimer() const;
	inline Timer*			getTimer();

	void					flushDirtyNodes();
};

}; };

#endif
