/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __STATS_BERNOULLI_H
#define __STATS_BERNOULLI_H

#include "stats.random.h"

namespace magnum { namespace stats {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Bernoulli : public Random {
DeclareClass(Bernoulli, Random);
private:
	float				m_Probability;
	
public:
	inline Bernoulli();
	inline explicit Bernoulli(float );
	
	inline void			setProbability(float );
	inline float		getProbability() const;
	
	inline bool			operator()();
};


}; };

#endif
