/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __STATS_UNIFORM_INL
#define __STATS_UNIFORM_INL

namespace magnum { namespace stats {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Uniform::Uniform() : m_Range(0.0f, 1.0f) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Uniform::Uniform(const Range<float>& r) {
	m_Range = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Uniform::Uniform(float s, float e) : m_Range(s,e) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Uniform::setRange(const Range<float>& r) {
	m_Range = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Uniform::setRange(float s, float e) {
	m_Range.setStart(s);
	m_Range.setEnd(e);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Range<float>& Uniform::getRange() const {
	return m_Range;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Uniform::operator()() {
	return randf()*m_Range.getSize() + m_Range.getStart();
}

}; };

#endif
