/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SYSTEM_SYSTEM_H
#define __SYSTEM_SYSTEM_H

#include "object.h"
#include "io.inputstream.h"
#include "io.outputstream.h"

namespace magnum { namespace system {
using magnum::object::Object;
using magnum::types::String;
using magnum::io::InputStream;
using magnum::io::OutputStream;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class System : public Object {
DeclareClass(System, Object);
private:
	class StandardInputStream : public InputStream {
	public:
		unsigned long read(void *buffer, unsigned long size);
		unsigned long skip(unsigned long size);
		unsigned long available();
		bool	close();
	};

	class StandardOutputStream : public OutputStream {
	public:
		unsigned long write(const void *buffer, unsigned long size);
		bool	flush();
		bool	close();
	};

	class StandardErrorStream : public OutputStream {
	public:
		unsigned long write(const void *buffer, unsigned long size);
		bool	flush();
		bool	close();
	};


public:
	static StandardInputStream		In;
	static StandardOutputStream		Out;
	static StandardErrorStream		Err;

#ifdef __FORWINDOWS__
	static HINSTANCE				WindowInstance;
#endif
};

}; };
#endif
