/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SYSTEM_MUTEX_H
#define __SYSTEM_MUTEX_H

#include "object.h"

namespace magnum { namespace system {
using magnum::object::Object;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Mutex : public Object {
DeclareClass(Mutex, Object);
private:
	bool			m_Locked;

#if defined(__FORWINDOWS__)
	CRITICAL_SECTION m_Mutex;
#elif defined(__FORUNIX__)
	pthread_mutex_t m_MutexHandle;
#endif

public:
	inline Mutex();
	inline ~Mutex();

	inline bool		lock();
	inline bool		unlock();
	inline bool		isLocked() const;
};

}; };
#endif
