/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SYSTEM_PROGRAM_H
#define __SYSTEM_PROGRAM_H

#include "container.array.h"
#include <stddef.h>

namespace magnum {namespace system {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Array;
using magnum::types::byte;
using magnum::types::word;
using magnum::types::dword;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Program : public Object {
DeclareClass(Program, Object);
private:
	class LocationT {};

public:
	typedef const LocationT*	Location;

private:
	struct Label {
		char			m_Name[64];
		Location		m_Location;
	};
	Array<byte>			m_Program;
	Array<Label>		m_Labels;

public:
	inline int			execute() const;
	inline int			execute(Location ) const;

	void				clear();
	void				finish();

	inline void			addByte(byte );
	inline void			addWord(word );
	inline void			addDword(dword );
	inline void			addFloat(float );
	inline void			addDouble(double );
	void				addLabel(const char* );

	Location			getLocation(const char* ) const;
	inline const Array<Label>& getLabels() const;
};

}; };

#endif
