/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "system.mutex.h"
#include "system.signal.h"
#include "system.thread.h"
#include "application.message.h"
#include "application.looper.h"
#include "application.handler.h"

#include "object.inl"
#include "system.thread.inl"
#include "system.mutex.inl"
#include "system.signal.inl"
#include "application.looper.inl"
#include "application.handler.inl"
#include "application.message.inl"
#include "application.messenger.inl"
#include "container.chain.inl"


# if !defined(__FORWINDOWS__)
#	error "This file is only for Windows"
# endif

namespace magnum { namespace application {
using namespace magnum::system;

#define	MSG_SYS_MESSAGE		WM_USER+100
#define	MSG_SYS_WAIT		WM_USER+101


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Looper::sysLoop() {
	Thread* thread = Thread::getCurrent();

	// Post some messages until the message queue is active
	while(PostThreadMessage((DWORD)thread->getThreadId(),MSG_SYS_WAIT,NULL, NULL) == 0) {
		Sleep(5);
	}

	// Notify all waiting threads
	m_Signal.raise();

	MSG wmsg;
	Message* msg;
	Handler* hnd;
	while (::GetMessage(&wmsg, NULL, 0, 0)) {
		// Check if this is a window message
		if (wmsg.hwnd != NULL) {
			TranslateMessage(&wmsg);
			DispatchMessage(&wmsg);
		} else if (wmsg.message == MSG_SYS_MESSAGE) {
			msg = (Message*)wmsg.wParam;
			hnd = msg->getTarget();
			hnd->handleMessage(*msg);
			delete msg;
		}
	}

	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Looper::sysStop() {
	PostThreadMessage((DWORD)getThread()->getThreadId(),WM_QUIT,NULL, NULL);
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Looper::onPostMessage(Message* msg) {
	PostThreadMessage((DWORD)getThread()->getThreadId(),MSG_SYS_MESSAGE,(DWORD)(intptr_t)msg, NULL);
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Looper::onSendMessage(Message* msg) {
	PostThreadMessage((DWORD)getThread()->getThreadId(),MSG_SYS_MESSAGE,(DWORD)(intptr_t)msg, NULL);
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Looper::onSynchronize() {
	return true;
}

}; };
