/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "base.number.h"
#include "base.number.inl"

namespace magnum { namespace types {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned char Byte::byteValue() const {
	return (unsigned char)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
short Byte::shortValue() const {
	return (short)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Byte::intValue() const {
	return (int)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
long Byte::longValue() const {
	return (long)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
float Byte::floatValue() const {
	return (float)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
double Byte::doubleValue() const {
	return (double)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Byte::boolValue() const {
	return (bool)(m_Value != 0);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned char Short::byteValue() const {
	return (unsigned char)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
short Short::shortValue() const {
	return (short)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Short::intValue() const {
	return (int)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
long Short::longValue() const {
	return (long)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
float Short::floatValue() const {
	return (float)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
double Short::doubleValue() const {
	return (double)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Short::boolValue() const {
	return (bool)(m_Value != 0);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned char Long::byteValue() const {
	return (unsigned char)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
short Long::shortValue() const {
	return (short)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Long::intValue() const {
	return (int)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
long Long::longValue() const {
	return (long)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
float Long::floatValue() const {
	return (float)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
double Long::doubleValue() const {
	return (double)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Long::boolValue() const {
	return (bool)(m_Value != 0);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned char Integer::byteValue() const {
	return (unsigned char)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
short Integer::shortValue() const {
	return (short)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Integer::intValue() const {
	return (int)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
long Integer::longValue() const {
	return (long)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
float Integer::floatValue() const {
	return (float)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
double Integer::doubleValue() const {
	return (double)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Integer::boolValue() const {
	return (bool)(m_Value != 0);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned char Double::byteValue() const {
	return (unsigned char)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
short Double::shortValue() const {
	return (short)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Double::intValue() const {
	return (int)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
long Double::longValue() const {
	return (long)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
float Double::floatValue() const {
	return (float)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
double Double::doubleValue() const {
	return (double)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Double::boolValue() const {
	return (bool)(m_Value != double(0.0));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned char Float::byteValue() const {
	return (unsigned char)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
short Float::shortValue() const {
	return (short)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Float::intValue() const {
	return (int)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
long Float::longValue() const {
	return (long)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
float Float::floatValue() const {
	return (float)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
double Float::doubleValue() const {
	return (double)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Float::boolValue() const {
	return (bool)(m_Value != float(0.0));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned char Bool::byteValue() const {
	return (unsigned char)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
short Bool::shortValue() const {
	return (short)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int Bool::intValue() const {
	return (int)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
long Bool::longValue() const {
	return (long)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
float Bool::floatValue() const {
	return (float)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
double Bool::doubleValue() const {
	return (double)m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Bool::boolValue() const {
	return (bool)m_Value;
}

}; };
