/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "graphics3d.context.h"
#include "graphics3d.camera.h"

#include "math.matrix.inl"
#include "system.thread.inl"
#include "graphics.rectangle.inl"
#include "graphics3d.camera.inl"
#include "graphics3d.resource.inl"


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Camera::onSelect() const {
	// Calculate Projection Matrix;
	Matrix4<float> mat;
	mat[0][0] = 2*m_NearPlane/(m_ViewWindow.getWidth());
	mat[0][1] = 0.0f;
	mat[0][2] = (2*m_ViewWindow.getX() + m_ViewWindow.getWidth()) / m_ViewWindow.getWidth();
	mat[0][3] = 0.0f;
	mat[1][0] = 0.0f;
	mat[1][1] = 2*m_NearPlane/(m_ViewWindow.getHeight());
	mat[1][2] = (2*m_ViewWindow.getY() + m_ViewWindow.getHeight()) / m_ViewWindow.getHeight();
	mat[1][3] = 0.0f;
	mat[2][0] = 0.0f;
	mat[2][1] = 0.0f;
	mat[2][2] = - (m_FarPlane + m_NearPlane) / (m_FarPlane - m_NearPlane);
	mat[2][3] = - 2* m_FarPlane * m_NearPlane / (m_FarPlane - m_NearPlane);
	mat[3][0] = 0.0f;
	mat[3][1] = 0.0f;
	mat[3][2] = -1.0f;
	mat[3][3] = 0.0f;

	mat = m_Matrix*mat;

	// Now set OpenGL Matrix
	int mm;
	glGetIntegerv(GL_MATRIX_MODE, &mm);
	glMatrixMode(GL_PROJECTION);
#if __FOROPENGL__ >= 13
	glLoadTransposeMatrixfARB(&mat[0][0]);
#else
	if (glLoadTransposeMatrixfARB)
		glLoadTransposeMatrixfARB(&mat[0][0]);
	else
		glLoadMatrixf(&mat.transpose()[0][0]);
#endif
	glMatrixMode(mm);
}

}; };
