/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "graphics3d.extensions.h"

#include "object.inl"
#include "base.string.inl"
#include "graphics3d.extensions.inl"


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/

#ifdef GL_ARB_multitexture
PFNGLACTIVETEXTUREARBPROC			glActiveTextureARB = NULL;
PFNGLCLIENTACTIVETEXTUREARBPROC		glClientActiveTextureARB = NULL;
									
PFNGLMULTITEXCOORD1DARBPROC			glMultiTexCoord1dARB = NULL;
PFNGLMULTITEXCOORD1DVARBPROC		glMultiTexCoord1dvARB = NULL;
PFNGLMULTITEXCOORD1FARBPROC			glMultiTexCoord1fARB = NULL;
PFNGLMULTITEXCOORD1FVARBPROC		glMultiTexCoord1fvARB = NULL;
PFNGLMULTITEXCOORD1IARBPROC			glMultiTexCoord1iARB = NULL;
PFNGLMULTITEXCOORD1IVARBPROC		glMultiTexCoord1ivARB = NULL;
PFNGLMULTITEXCOORD1SARBPROC			glMultiTexCoord1sARB = NULL;
PFNGLMULTITEXCOORD1SVARBPROC		glMultiTexCoord1svARB = NULL;
									
PFNGLMULTITEXCOORD2DARBPROC			glMultiTexCoord2dARB = NULL;
PFNGLMULTITEXCOORD2DVARBPROC		glMultiTexCoord2dvARB = NULL;
PFNGLMULTITEXCOORD2FARBPROC			glMultiTexCoord2fARB = NULL;
PFNGLMULTITEXCOORD2FVARBPROC		glMultiTexCoord2fvARB = NULL;
PFNGLMULTITEXCOORD2IARBPROC			glMultiTexCoord2iARB = NULL;
PFNGLMULTITEXCOORD2IVARBPROC		glMultiTexCoord2ivARB = NULL;
PFNGLMULTITEXCOORD2SARBPROC			glMultiTexCoord2sARB = NULL;
PFNGLMULTITEXCOORD2SVARBPROC		glMultiTexCoord2svARB = NULL;
									
PFNGLMULTITEXCOORD3DARBPROC			glMultiTexCoord3dARB = NULL;
PFNGLMULTITEXCOORD3DVARBPROC		glMultiTexCoord3dvARB = NULL;
PFNGLMULTITEXCOORD3FARBPROC			glMultiTexCoord3fARB = NULL;
PFNGLMULTITEXCOORD3FVARBPROC		glMultiTexCoord3fvARB = NULL;
PFNGLMULTITEXCOORD3IARBPROC			glMultiTexCoord3iARB = NULL;
PFNGLMULTITEXCOORD3IVARBPROC		glMultiTexCoord3ivARB = NULL;
PFNGLMULTITEXCOORD3SARBPROC			glMultiTexCoord3sARB = NULL;
PFNGLMULTITEXCOORD3SVARBPROC		glMultiTexCoord3svARB = NULL;
									
PFNGLMULTITEXCOORD4DARBPROC			glMultiTexCoord4dARB = NULL;
PFNGLMULTITEXCOORD4DVARBPROC		glMultiTexCoord4dvARB = NULL;
PFNGLMULTITEXCOORD4FARBPROC			glMultiTexCoord4fARB = NULL;
PFNGLMULTITEXCOORD4FVARBPROC		glMultiTexCoord4fvARB = NULL;
PFNGLMULTITEXCOORD4IARBPROC			glMultiTexCoord4iARB = NULL;
PFNGLMULTITEXCOORD4IVARBPROC		glMultiTexCoord4ivARB = NULL;
PFNGLMULTITEXCOORD4SARBPROC			glMultiTexCoord4sARB = NULL;
PFNGLMULTITEXCOORD4SVARBPROC		glMultiTexCoord4svARB = NULL;
#endif								
									
									
#ifdef GL_ARB_occlusion_query		
PFNGLGENQUERIESARBPROC				glGenQueriesARB = NULL;
PFNGLDELETEQUERIESARBPROC			glDeleteQueriesARB = NULL;
PFNGLISQUERYARBPROC					glIsQueryARB = NULL;
PFNGLBEGINQUERYARBPROC				glBeginQueryARB = NULL;
PFNGLENDQUERYARBPROC				glEndQueryARB = NULL;
PFNGLGETQUERYIVARBPROC				glGetQueryivARB = NULL;
PFNGLGETQUERYOBJECTIVARBPROC		glGetQueryObjectivARB = NULL;
PFNGLGETQUERYOBJECTUIVARBPROC		glGetQueryObjectuivARB = NULL;
#endif


#ifdef GL_ARB_shader_objects
PFNGLDELETEOBJECTARBPROC			glDeleteObjectARB = NULL;
PFNGLGETHANDLEARBPROC				glGetHandleARB = NULL;
PFNGLDETACHOBJECTARBPROC			glDetachObjectARB = NULL;
PFNGLCREATESHADEROBJECTARBPROC		glCreateShaderObjectARB = NULL;
PFNGLSHADERSOURCEARBPROC			glShaderSourceARB = NULL;
PFNGLCOMPILESHADERARBPROC			glCompileShaderARB = NULL;
PFNGLCREATEPROGRAMOBJECTARBPROC		glCreateProgramObjectARB = NULL;
PFNGLATTACHOBJECTARBPROC			glAttachObjectARB = NULL;
PFNGLLINKPROGRAMARBPROC				glLinkProgramARB = NULL;
PFNGLUSEPROGRAMOBJECTARBPROC		glUseProgramObjectARB = NULL;
PFNGLVALIDATEPROGRAMARBPROC			glValidateProgramARB = NULL;
									
PFNGLUNIFORM1FARBPROC				glUniform1fARB = NULL;
PFNGLUNIFORM2FARBPROC				glUniform2fARB = NULL;
PFNGLUNIFORM3FARBPROC				glUniform3fARB = NULL;
PFNGLUNIFORM4FARBPROC				glUniform4fARB = NULL;
									
PFNGLUNIFORM1IARBPROC				glUniform1iARB = NULL;
PFNGLUNIFORM2IARBPROC				glUniform2iARB = NULL;
PFNGLUNIFORM3IARBPROC				glUniform3iARB = NULL;
PFNGLUNIFORM4IARBPROC				glUniform4iARB = NULL;
									
PFNGLUNIFORM1FVARBPROC				glUniform1fvARB = NULL;
PFNGLUNIFORM2FVARBPROC				glUniform2fvARB = NULL;
PFNGLUNIFORM3FVARBPROC				glUniform3fvARB = NULL;
PFNGLUNIFORM4FVARBPROC				glUniform4fvARB = NULL;
									
PFNGLUNIFORM1IVARBPROC				glUniform1ivARB = NULL;
PFNGLUNIFORM2IVARBPROC				glUniform2ivARB = NULL;
PFNGLUNIFORM3IVARBPROC				glUniform3ivARB = NULL;
PFNGLUNIFORM4IVARBPROC				glUniform4ivARB = NULL;
									
PFNGLUNIFORMMATRIX2FVARBPROC		glUniformMatrix2fvARB = NULL;
PFNGLUNIFORMMATRIX3FVARBPROC		glUniformMatrix3fvARB = NULL;
PFNGLUNIFORMMATRIX4FVARBPROC		glUniformMatrix4fvARB = NULL;

PFNGLGETOBJECTPARAMETERFVARBPROC	glGetObjectParameterfvARB = NULL;
PFNGLGETOBJECTPARAMETERIVARBPROC	glGetObjectParameterivARB = NULL;
PFNGLGETINFOLOGARBPROC				glGetInfoLogARB = NULL;
PFNGLGETATTACHEDOBJECTSARBPROC		glGetAttachedObjectsARB = NULL;
PFNGLGETUNIFORMLOCATIONARBPROC		glGetUniformLocationARB = NULL;
PFNGLGETACTIVEUNIFORMARBPROC		glGetActiveUniformARB = NULL;
PFNGLGETUNIFORMFVARBPROC			glGetUniformfvARB = NULL;
PFNGLGETUNIFORMIVARBPROC			glGetUniformivARB = NULL;
PFNGLGETSHADERSOURCEARBPROC			glGetShaderSourceARB = NULL;
#endif


#ifdef GL_ARB_texture_compression
PFNGLCOMPRESSEDTEXIMAGE1DARBPROC	glCompressedTexImage1DARB = NULL;
PFNGLCOMPRESSEDTEXIMAGE2DARBPROC	glCompressedTexImage2DARB = NULL;
PFNGLCOMPRESSEDTEXIMAGE3DARBPROC	glCompressedTexImage3DARB = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC	glCompressedTexSubImage1DARB = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC	glCompressedTexSubImage2DARB = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC	glCompressedTexSubImage3DARB = NULL;
PFNGLGETCOMPRESSEDTEXIMAGEARBPROC	glGetCompressedTexImageARB = NULL;
#endif


#ifdef GL_ARB_transpose_matrix
PFNGLLOADTRANSPOSEMATRIXFARBPROC	glLoadTransposeMatrixfARB = NULL;
PFNGLLOADTRANSPOSEMATRIXDARBPROC	glLoadTransposeMatrixdARB = NULL;
PFNGLMULTTRANSPOSEMATRIXFARBPROC	glMultTransposeMatrixfARB = NULL;
PFNGLMULTTRANSPOSEMATRIXDARBPROC	glMultTransposeMatrixdARB = NULL;
#endif


#ifdef GL_ARB_vertex_blend
PFNGLWEIGHTBVARBPROC				glWeightbvARB = NULL;
PFNGLWEIGHTSVARBPROC				glWeightsvARB = NULL;
PFNGLWEIGHTIVARBPROC				glWeightivARB = NULL;
PFNGLWEIGHTFVARBPROC				glWeightfvARB = NULL;
PFNGLWEIGHTDVARBPROC				glWeightdvARB = NULL;
PFNGLWEIGHTUBVARBPROC				glWeightubvARB = NULL;
PFNGLWEIGHTUSVARBPROC				glWeightusvARB = NULL;
PFNGLWEIGHTUIVARBPROC				glWeightuivARB = NULL;
									
PFNGLWEIGHTPOINTERARBPROC			glWeightPointerARB = NULL;
PFNGLVERTEXBLENDARBPROC				glVertexBlendARB = NULL;
#endif


#ifdef GL_ARB_vertex_buffer_object
PFNGLBINDBUFFERARBPROC				glBindBufferARB = NULL;
PFNGLDELETEBUFFERSARBPROC			glDeleteBuffersARB = NULL;
PFNGLGENBUFFERSARBPROC				glGenBuffersARB = NULL;
PFNGLISBUFFERARBPROC				glIsBufferARB = NULL;
									
PFNGLBUFFERDATAARBPROC				glBufferDataARB = NULL;
PFNGLBUFFERSUBDATAARBPROC			glBufferSubDataARB = NULL;
PFNGLGETBUFFERSUBDATAARBPROC		glGetBufferSubDataARB = NULL;
									
PFNGLMAPBUFFERARBPROC				glMapBufferARB = NULL;
PFNGLUNMAPBUFFERARBPROC				glUnmapBufferARB = NULL;

PFNGLGETBUFFERPARAMETERIVARBPROC	glGetBufferParameterivARB = NULL;
PFNGLGETBUFFERPOINTERVARBPROC		glGetBufferPointervARB = NULL;
#endif


#ifdef GL_ARB_vertex_program
PFNGLVERTEXATTRIB1SARBPROC			glVertexAttrib1sARB = NULL;
PFNGLVERTEXATTRIB1FARBPROC			glVertexAttrib1fARB = NULL;
PFNGLVERTEXATTRIB1DARBPROC			glVertexAttrib1dARB = NULL;
PFNGLVERTEXATTRIB2SARBPROC			glVertexAttrib2sARB = NULL;
PFNGLVERTEXATTRIB2FARBPROC			glVertexAttrib2fARB = NULL;
PFNGLVERTEXATTRIB2DARBPROC			glVertexAttrib2dARB = NULL;
PFNGLVERTEXATTRIB3SARBPROC			glVertexAttrib3sARB = NULL;
PFNGLVERTEXATTRIB3FARBPROC			glVertexAttrib3fARB = NULL;
PFNGLVERTEXATTRIB3DARBPROC			glVertexAttrib3dARB = NULL;
PFNGLVERTEXATTRIB4SARBPROC			glVertexAttrib4sARB = NULL;
PFNGLVERTEXATTRIB4FARBPROC			glVertexAttrib4fARB = NULL;
PFNGLVERTEXATTRIB4DARBPROC			glVertexAttrib4dARB = NULL;
PFNGLVERTEXATTRIB4NUBARBPROC		glVertexAttrib4NubARB = NULL;
PFNGLVERTEXATTRIB1SVARBPROC			glVertexAttrib1svARB = NULL;
PFNGLVERTEXATTRIB1FVARBPROC			glVertexAttrib1fvARB = NULL;
PFNGLVERTEXATTRIB1DVARBPROC			glVertexAttrib1dvARB = NULL;
PFNGLVERTEXATTRIB2SVARBPROC			glVertexAttrib2svARB = NULL;
PFNGLVERTEXATTRIB2FVARBPROC			glVertexAttrib2fvARB = NULL;
PFNGLVERTEXATTRIB2DVARBPROC			glVertexAttrib2dvARB = NULL;
PFNGLVERTEXATTRIB3SVARBPROC			glVertexAttrib3svARB = NULL;
PFNGLVERTEXATTRIB3FVARBPROC			glVertexAttrib3fvARB = NULL;
PFNGLVERTEXATTRIB3DVARBPROC			glVertexAttrib3dvARB = NULL;
PFNGLVERTEXATTRIB4BVARBPROC			glVertexAttrib4bvARB = NULL;
PFNGLVERTEXATTRIB4SVARBPROC			glVertexAttrib4svARB = NULL;
PFNGLVERTEXATTRIB4IVARBPROC			glVertexAttrib4ivARB = NULL;
PFNGLVERTEXATTRIB4UBVARBPROC		glVertexAttrib4ubvARB = NULL;
PFNGLVERTEXATTRIB4USVARBPROC		glVertexAttrib4usvARB = NULL;
PFNGLVERTEXATTRIB4UIVARBPROC		glVertexAttrib4uivARB = NULL;
PFNGLVERTEXATTRIB4FVARBPROC			glVertexAttrib4fvARB = NULL;
PFNGLVERTEXATTRIB4DVARBPROC			glVertexAttrib4dvARB = NULL;
PFNGLVERTEXATTRIB4NBVARBPROC		glVertexAttrib4NbvARB = NULL;
PFNGLVERTEXATTRIB4NSVARBPROC		glVertexAttrib4NsvARB = NULL;
PFNGLVERTEXATTRIB4NIVARBPROC		glVertexAttrib4NivARB = NULL;
PFNGLVERTEXATTRIB4NUBVARBPROC		glVertexAttrib4NubvARB = NULL;
PFNGLVERTEXATTRIB4NUSVARBPROC		glVertexAttrib4NusvARB = NULL;
PFNGLVERTEXATTRIB4NUIVARBPROC		glVertexAttrib4NuivARB = NULL;
PFNGLVERTEXATTRIBPOINTERARBPROC		glVertexAttribPointerARB = NULL;
PFNGLENABLEVERTEXATTRIBARRAYARBPROC	glEnableVertexAttribArrayARB = NULL;
PFNGLDISABLEVERTEXATTRIBARRAYARBPROC glDisableVertexAttribArrayARB = NULL;
PFNGLPROGRAMSTRINGARBPROC			glProgramStringARB = NULL;
PFNGLBINDPROGRAMARBPROC				glBindProgramARB = NULL;
PFNGLDELETEPROGRAMSARBPROC			glDeleteProgramsARB = NULL;
PFNGLGENPROGRAMSARBPROC				glGenProgramsARB = NULL;
PFNGLPROGRAMENVPARAMETER4DARBPROC	glProgramEnvParameter4dARB = NULL;
PFNGLPROGRAMENVPARAMETER4DVARBPROC	glProgramEnvParameter4dvARB = NULL;
PFNGLPROGRAMENVPARAMETER4FARBPROC	glProgramEnvParameter4fARB = NULL;
PFNGLPROGRAMENVPARAMETER4FVARBPROC	glProgramEnvParameter4fvARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4DARBPROC	glProgramLocalParameter4dARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4DVARBPROC glProgramLocalParameter4dvARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4FARBPROC	glProgramLocalParameter4fARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4FVARBPROC glProgramLocalParameter4fvARB = NULL;
PFNGLGETPROGRAMENVPARAMETERDVARBPROC glGetProgramEnvParameterdvARB = NULL;
PFNGLGETPROGRAMENVPARAMETERFVARBPROC glGetProgramEnvParameterfvARB = NULL;
PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC glGetProgramLocalParameterdvARB = NULL;
PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC glGetProgramLocalParameterfvARB = NULL;
PFNGLGETPROGRAMIVARBPROC			glGetProgramivARB = NULL;
PFNGLGETPROGRAMSTRINGARBPROC		glGetProgramStringARB = NULL;
PFNGLGETVERTEXATTRIBDVARBPROC		glGetVertexAttribdvARB = NULL;
PFNGLGETVERTEXATTRIBFVARBPROC		glGetVertexAttribfvARB = NULL;
PFNGLGETVERTEXATTRIBIVARBPROC		glGetVertexAttribivARB = NULL;
PFNGLGETVERTEXATTRIBPOINTERVARBPROC	glGetVertexAttribPointervARB = NULL;
PFNGLISPROGRAMARBPROC				glIsProgramARB = NULL;
#endif


#ifdef GL_ARB_vertex_shader
PFNGLBINDATTRIBLOCATIONARBPROC		glBindAttribLocationARB = NULL;
PFNGLGETACTIVEATTRIBARBPROC			glGetActiveAttribARB = NULL;
PFNGLGETATTRIBLOCATIONARBPROC		glGetAttribLocationARB = NULL;
#endif


#ifdef GL_ATI_element_array
PFNGLELEMENTPOINTERATIPROC			glElementPointerATI = NULL;
PFNGLDRAWELEMENTARRAYATIPROC		glDrawElementArrayATI = NULL;
PFNGLDRAWRANGEELEMENTARRAYATIPROC	glDrawRangeElementArrayATI = NULL;
#endif


#ifdef GL_ATI_envmap_bumpmap
PFNGLTEXBUMPPARAMETERIVATIPROC		glTexBumpParameterivATI = NULL;
PFNGLTEXBUMPPARAMETERFVATIPROC		glTexBumpParameterfvATI = NULL;
PFNGLGETTEXBUMPPARAMETERIVATIPROC	glGetTexBumpParameterivATI = NULL;
PFNGLGETTEXBUMPPARAMETERFVATIPROC	glGetTexBumpParameterfvATI = NULL;
#endif


#ifdef GL_ATI_fragment_shader
PFNGLGENFRAGMENTSHADERSATIPROC		glGenFragmentShadersATI = NULL;
PFNGLBINDFRAGMENTSHADERATIPROC		glBindFragmentShaderATI = NULL;
PFNGLDELETEFRAGMENTSHADERATIPROC	glDeleteFragmentShaderATI = NULL;
PFNGLBEGINFRAGMENTSHADERATIPROC		glBeginFragmentShaderATI = NULL;
PFNGLENDFRAGMENTSHADERATIPROC		glEndFragmentShaderATI = NULL;
PFNGLPASSTEXCOORDATIPROC			glPassTexCoordATI = NULL;
PFNGLSAMPLEMAPATIPROC				glSampleMapATI = NULL;

PFNGLCOLORFRAGMENTOP1ATIPROC		glColorFragmentOp1ATI = NULL;
PFNGLCOLORFRAGMENTOP2ATIPROC		glColorFragmentOp2ATI = NULL;
PFNGLCOLORFRAGMENTOP3ATIPROC		glColorFragmentOp3ATI = NULL;
											
PFNGLALPHAFRAGMENTOP1ATIPROC		glAlphaFragmentOp1ATI = NULL;
PFNGLALPHAFRAGMENTOP2ATIPROC		glAlphaFragmentOp2ATI = NULL;
PFNGLALPHAFRAGMENTOP3ATIPROC		glAlphaFragmentOp3ATI = NULL;

PFNGLSETFRAGMENTSHADERCONSTANTATIPROC glSetFragmentShaderConstantATI = NULL;
#endif


#ifdef GL_ATI_map_object_buffer
PFNGLMAPOBJECTBUFFERATIPROC			glMapObjectBufferATI = NULL;
PFNGLUNMAPOBJECTBUFFERATIPROC		glUnmapObjectBufferATI = NULL;
#endif


#ifdef GL_ATI_pn_triangles
PFNGLPNTRIANGLESIATIPROC			glPNTrianglesiATI = NULL;
PFNGLPNTRIANGLESFATIPROC			glPNTrianglesfATI = NULL;
#endif



#ifdef GL_ATI_vertex_array_object
PFNGLNEWOBJECTBUFFERATIPROC			glNewObjectBufferATI = NULL;
PFNGLISOBJECTBUFFERATIPROC			glIsObjectBufferATI = NULL;
PFNGLUPDATEOBJECTBUFFERATIPROC		glUpdateObjectBufferATI = NULL;
PFNGLGETOBJECTBUFFERFVATIPROC		glGetObjectBufferfvATI = NULL;
PFNGLGETOBJECTBUFFERIVATIPROC		glGetObjectBufferivATI = NULL;
PFNGLFREEOBJECTBUFFERATIPROC		glFreeObjectBufferATI = NULL;
									
PFNGLARRAYOBJECTATIPROC				glArrayObjectATI = NULL;
PFNGLGETARRAYOBJECTFVATIPROC		glGetArrayObjectfvATI = NULL;
PFNGLGETARRAYOBJECTIVATIPROC		glGetArrayObjectivATI = NULL;
PFNGLVARIANTARRAYOBJECTATIPROC		glVariantArrayObjectATI = NULL;

PFNGLGETVARIANTARRAYOBJECTFVATIPROC	glGetVariantArrayObjectfvATI = NULL;
PFNGLGETVARIANTARRAYOBJECTIVATIPROC	glGetVariantArrayObjectivATI = NULL;
#endif


#ifdef GL_ATI_vertex_attrib_array_object
PFNGLVERTEXATTRIBARRAYOBJECTATIPROC	glVertexAttribArrayObjectATI = NULL;
#endif


#ifdef GL_ATI_vertex_streams
PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC glClientActiveVertexStreamATI = NULL;
PFNGLVERTEXBLENDENVIATIPROC			glVertexBlendEnviATI = NULL;
PFNGLVERTEXBLENDENVFATIPROC			glVertexBlendEnvfATI = NULL;
									
PFNGLVERTEXSTREAM2SATIPROC			glVertexStream2sATI = NULL;
PFNGLVERTEXSTREAM2SVATIPROC			glVertexStream2svATI = NULL;
PFNGLVERTEXSTREAM2IATIPROC			glVertexStream2iATI = NULL;
PFNGLVERTEXSTREAM2IVATIPROC			glVertexStream2ivATI = NULL;
PFNGLVERTEXSTREAM2FATIPROC			glVertexStream2fATI = NULL;
PFNGLVERTEXSTREAM2FVATIPROC			glVertexStream2fvATI = NULL;
PFNGLVERTEXSTREAM2DATIPROC			glVertexStream2dATI = NULL;
PFNGLVERTEXSTREAM2DVATIPROC			glVertexStream2dvATI = NULL;
									
PFNGLVERTEXSTREAM3SATIPROC			glVertexStream3sATI = NULL;
PFNGLVERTEXSTREAM3SVATIPROC			glVertexStream3svATI = NULL;
PFNGLVERTEXSTREAM3IATIPROC			glVertexStream3iATI = NULL;
PFNGLVERTEXSTREAM3IVATIPROC			glVertexStream3ivATI = NULL;
PFNGLVERTEXSTREAM3FATIPROC			glVertexStream3fATI = NULL;
PFNGLVERTEXSTREAM3FVATIPROC			glVertexStream3fvATI = NULL;
PFNGLVERTEXSTREAM3DATIPROC			glVertexStream3dATI = NULL;
PFNGLVERTEXSTREAM3DVATIPROC			glVertexStream3dvATI = NULL;
									
PFNGLVERTEXSTREAM4SATIPROC			glVertexStream4sATI = NULL;
PFNGLVERTEXSTREAM4SVATIPROC			glVertexStream4svATI = NULL;
PFNGLVERTEXSTREAM4IATIPROC			glVertexStream4iATI = NULL;
PFNGLVERTEXSTREAM4IVATIPROC			glVertexStream4ivATI = NULL;
PFNGLVERTEXSTREAM4FATIPROC			glVertexStream4fATI = NULL;
PFNGLVERTEXSTREAM4FVATIPROC			glVertexStream4fvATI = NULL;
PFNGLVERTEXSTREAM4DATIPROC			glVertexStream4dATI = NULL;
PFNGLVERTEXSTREAM4DVATIPROC			glVertexStream4dvATI = NULL;
									
PFNGLNORMALSTREAM3BATIPROC			glNormalStream3bATI = NULL;
PFNGLNORMALSTREAM3BVATIPROC			glNormalStream3bvATI = NULL;
PFNGLNORMALSTREAM3SATIPROC			glNormalStream3sATI = NULL;
PFNGLNORMALSTREAM3SVATIPROC			glNormalStream3svATI = NULL;
PFNGLNORMALSTREAM3IATIPROC			glNormalStream3iATI = NULL;
PFNGLNORMALSTREAM3IVATIPROC			glNormalStream3ivATI = NULL;
PFNGLNORMALSTREAM3FATIPROC			glNormalStream3fATI = NULL;
PFNGLNORMALSTREAM3FVATIPROC			glNormalStream3fvATI = NULL;
PFNGLNORMALSTREAM3DATIPROC			glNormalStream3dATI = NULL;
PFNGLNORMALSTREAM3DVATIPROC			glNormalStream3dvATI = NULL;
#endif


#ifdef GL_EXT_blend_color
PFNGLBLENDCOLOREXTPROC				glBlendColorEXT = NULL;
#endif


#ifdef GL_EXT_blend_func_separate
PFNGLBLENDFUNCSEPARATEEXTPROC		glBlendFuncSeparateEXT = NULL;
#endif


#ifdef GL_EXT_blend_minmax
PFNGLBLENDEQUATIONEXTPROC			glBlendEquationEXT = NULL;
#endif


#ifdef GL_EXT_draw_range_elements
PFNGLDRAWRANGEELEMENTSEXTPROC		glDrawRangeElementsEXT = NULL;
#endif


#ifdef GL_EXT_fog_coord
PFNGLFOGCOORDFEXTPROC				glFogCoordfEXT = NULL;
PFNGLFOGCOORDDEXTPROC				glFogCoorddEXT = NULL;
PFNGLFOGCOORDFVEXTPROC				glFogCoordfvEXT = NULL;
PFNGLFOGCOORDDVEXTPROC				glFogCoorddvEXT = NULL;
PFNGLFOGCOORDPOINTEREXTPROC			glFogCoordPointerEXT = NULL;
#endif


#ifdef GL_EXT_polygon_offset
PFNGLPOLYGONOFFSETEXTPROC			glPolygonOffsetEXT = NULL;
#endif


#ifdef GL_EXT_texture3D
PFNGLTEXIMAGE3DEXTPROC				glTexImage3DEXT = NULL;
#endif


#ifdef GL_NV_occlusion_query
PFNGLGENOCCLUSIONQUERIESNVPROC		glGenOcclusionQueriesNV = NULL;
PFNGLDELETEOCCLUSIONQUERIESNVPROC	glDeleteOcclusionQueriesNV = NULL;
PFNGLISOCCLUSIONQUERYNVPROC			glIsOcclusionQueryNV = NULL;
PFNGLBEGINOCCLUSIONQUERYNVPROC		glBeginOcclusionQueryNV = NULL;
PFNGLENDOCCLUSIONQUERYNVPROC		glEndOcclusionQueryNV = NULL;
PFNGLGETOCCLUSIONQUERYIVNVPROC		glGetOcclusionQueryivNV = NULL;
PFNGLGETOCCLUSIONQUERYUIVNVPROC		glGetOcclusionQueryuivNV = NULL;
#endif


#ifdef GL_NV_register_combiners
PFNGLCOMBINERPARAMETERFVNVPROC		glCombinerParameterfvNV = NULL;
PFNGLCOMBINERPARAMETERFNVPROC		glCombinerParameterfNV = NULL;
PFNGLCOMBINERPARAMETERIVNVPROC		glCombinerParameterivNV = NULL;
PFNGLCOMBINERPARAMETERINVPROC		glCombinerParameteriNV = NULL;
									
PFNGLCOMBINERINPUTNVPROC			glCombinerInputNV = NULL;
PFNGLCOMBINEROUTPUTNVPROC			glCombinerOutputNV = NULL;
PFNGLFINALCOMBINERINPUTNVPROC		glFinalCombinerInputNV = NULL;

PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC  glGetCombinerInputParameterfvNV = NULL;
PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC  glGetCombinerInputParameterivNV = NULL;
PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC glGetCombinerOutputParameterfvNV = NULL;
PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC glGetCombinerOutputParameterivNV = NULL;

PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC glGetFinalCombinerInputParameterfvNV = NULL;
PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC glGetFinalCombinerInputParameterivNV = NULL;
#endif


#ifdef WGL_ARB_pbuffer
PFNWGLCREATEPBUFFERARBPROC			wglCreatePbufferARB = NULL;
PFNWGLGETPBUFFERDCARBPROC			wglGetPbufferDCARB = NULL;
PFNWGLRELEASEPBUFFERDCARBPROC		wglReleasePbufferDCARB = NULL;
PFNWGLDESTROYPBUFFERARBPROC			wglDestroyPbufferARB = NULL;
PFNWGLQUERYPBUFFERARBPROC			wglQueryPbufferARB = NULL;
#endif


#ifdef WGL_ARB_render_texture
PFNWGLBINDTEXIMAGEARBPROC			wglBindTexImageARB = NULL;
PFNWGLRELEASETEXIMAGEARBPROC		wglReleaseTexImageARB = NULL;
PFNWGLSETPBUFFERATTRIBARBPROC		wglSetPbufferAttribARB = NULL;
#endif

namespace magnum {namespace graphics3d {

bool Extensions::g_GlobalInit = false;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Extensions::Extensions() {
	m_Extensions = (const char *)glGetString(GL_EXTENSIONS);
	getExtensions();
	if (!g_GlobalInit) {
		select();
		g_GlobalInit = true;
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Extensions::isSupported(const char* extension) {
	ASSERT(extension != NULL);
	if (m_Extensions == NULL)
		return false;

	const char *str = m_Extensions;
	int len = (int)strlen(extension);
	
	while ((str = strstr(str, extension)) != NULL){
		str += len;
		if (*str == ' ' || *str == '\0') return true;
	}

	return false;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Extensions::select() {
#ifdef GL_ARB_multitexture
	::glActiveTextureARB = glActiveTextureARB;
	::glClientActiveTextureARB = glClientActiveTextureARB;
		
	::glMultiTexCoord1dARB = glMultiTexCoord1dARB;
	::glMultiTexCoord1dvARB = glMultiTexCoord1dvARB;
	::glMultiTexCoord1fARB = glMultiTexCoord1fARB;
	::glMultiTexCoord1fvARB = glMultiTexCoord1fvARB;
	::glMultiTexCoord1iARB = glMultiTexCoord1iARB;
	::glMultiTexCoord1ivARB = glMultiTexCoord1ivARB;
	::glMultiTexCoord1sARB = glMultiTexCoord1sARB;
	::glMultiTexCoord1svARB = glMultiTexCoord1svARB;
		
	::glMultiTexCoord2dARB = glMultiTexCoord2dARB;
	::glMultiTexCoord2dvARB = glMultiTexCoord2dvARB;
	::glMultiTexCoord2fARB = glMultiTexCoord2fARB;
	::glMultiTexCoord2fvARB = glMultiTexCoord2fvARB;
	::glMultiTexCoord2iARB = glMultiTexCoord2iARB;
	::glMultiTexCoord2ivARB = glMultiTexCoord2ivARB;
	::glMultiTexCoord2sARB = glMultiTexCoord2sARB;
	::glMultiTexCoord2svARB = glMultiTexCoord2svARB;
		
	::glMultiTexCoord3dARB = glMultiTexCoord3dARB;
	::glMultiTexCoord3dvARB = glMultiTexCoord3dvARB;
	::glMultiTexCoord3fARB = glMultiTexCoord3fARB;
	::glMultiTexCoord3fvARB = glMultiTexCoord3fvARB;
	::glMultiTexCoord3iARB = glMultiTexCoord3iARB;
	::glMultiTexCoord3ivARB = glMultiTexCoord3ivARB;
	::glMultiTexCoord3sARB = glMultiTexCoord3sARB;
	::glMultiTexCoord3svARB = glMultiTexCoord3svARB;
		
	::glMultiTexCoord4dARB = glMultiTexCoord4dARB;
	::glMultiTexCoord4dvARB = glMultiTexCoord4dvARB;
	::glMultiTexCoord4fARB = glMultiTexCoord4fARB;
	::glMultiTexCoord4fvARB = glMultiTexCoord4fvARB;
	::glMultiTexCoord4iARB = glMultiTexCoord4iARB;
	::glMultiTexCoord4ivARB = glMultiTexCoord4ivARB;
	::glMultiTexCoord4sARB = glMultiTexCoord4sARB;
	::glMultiTexCoord4svARB = glMultiTexCoord4svARB;
#endif								
									
#ifdef GL_ARB_occlusion_query		
	::glGenQueriesARB = glGenQueriesARB;
	::glDeleteQueriesARB = glDeleteQueriesARB;
	::glIsQueryARB = glIsQueryARB;
	::glBeginQueryARB = glBeginQueryARB;
	::glEndQueryARB = glEndQueryARB;
	::glGetQueryivARB = glGetQueryivARB;
	::glGetQueryObjectivARB = glGetQueryObjectivARB;
	::glGetQueryObjectuivARB = glGetQueryObjectuivARB;
#endif

#ifdef GL_ARB_shader_objects
	::glDeleteObjectARB = glDeleteObjectARB;
	::glGetHandleARB = glGetHandleARB;
	::glDetachObjectARB = glDetachObjectARB;
	::glCreateShaderObjectARB = glCreateShaderObjectARB;
	::glShaderSourceARB = glShaderSourceARB;
	::glCompileShaderARB = glCompileShaderARB;
	::glCreateProgramObjectARB = glCreateProgramObjectARB;
	::glAttachObjectARB = glAttachObjectARB;
	::glLinkProgramARB = glLinkProgramARB;
	::glUseProgramObjectARB = glUseProgramObjectARB;
	::glValidateProgramARB = glValidateProgramARB;
		
	::glUniform1fARB = glUniform1fARB;
	::glUniform2fARB = glUniform2fARB;
	::glUniform3fARB = glUniform3fARB;
	::glUniform4fARB = glUniform4fARB;
		
	::glUniform1iARB = glUniform1iARB;
	::glUniform2iARB = glUniform2iARB;
	::glUniform3iARB = glUniform3iARB;
	::glUniform4iARB = glUniform4iARB;
		
	::glUniform1fvARB = glUniform1fvARB;
	::glUniform2fvARB = glUniform2fvARB;
	::glUniform3fvARB = glUniform3fvARB;
	::glUniform4fvARB = glUniform4fvARB;
		
	::glUniform1ivARB = glUniform1ivARB;
	::glUniform2ivARB = glUniform2ivARB;
	::glUniform3ivARB = glUniform3ivARB;
	::glUniform4ivARB = glUniform4ivARB;
		
	::glUniformMatrix2fvARB = glUniformMatrix2fvARB;
	::glUniformMatrix3fvARB = glUniformMatrix3fvARB;
	::glUniformMatrix4fvARB = glUniformMatrix4fvARB;

	::glGetObjectParameterfvARB = glGetObjectParameterfvARB;
	::glGetObjectParameterivARB = glGetObjectParameterivARB;
	::glGetInfoLogARB = glGetInfoLogARB;
	::glGetAttachedObjectsARB = glGetAttachedObjectsARB;
	::glGetUniformLocationARB = glGetUniformLocationARB;
	::glGetActiveUniformARB = glGetActiveUniformARB;
	::glGetUniformfvARB = glGetUniformfvARB;
	::glGetUniformivARB = glGetUniformivARB;
	::glGetShaderSourceARB = glGetShaderSourceARB;
#endif

#ifdef GL_ARB_texture_compression
	::glCompressedTexImage1DARB = glCompressedTexImage1DARB;
	::glCompressedTexImage2DARB = glCompressedTexImage2DARB;
	::glCompressedTexImage3DARB = glCompressedTexImage3DARB;
	::glCompressedTexSubImage1DARB = glCompressedTexSubImage1DARB;
	::glCompressedTexSubImage2DARB = glCompressedTexSubImage2DARB;
	::glCompressedTexSubImage3DARB = glCompressedTexSubImage3DARB;
	::glGetCompressedTexImageARB = glGetCompressedTexImageARB;
#endif

#ifdef GL_ARB_transpose_matrix
	::glLoadTransposeMatrixfARB = glLoadTransposeMatrixfARB;
	::glLoadTransposeMatrixdARB = glLoadTransposeMatrixdARB;
	::glMultTransposeMatrixfARB = glMultTransposeMatrixfARB;
	::glMultTransposeMatrixdARB = glMultTransposeMatrixdARB;
#endif

#ifdef GL_ARB_vertex_blend
	::glWeightbvARB = glWeightbvARB;
	::glWeightsvARB = glWeightsvARB;
	::glWeightivARB = glWeightivARB;
	::glWeightfvARB = glWeightfvARB;
	::glWeightdvARB = glWeightdvARB;
	::glWeightubvARB = glWeightubvARB;
	::glWeightusvARB = glWeightusvARB;
	::glWeightuivARB = glWeightuivARB;
		
	::glWeightPointerARB = glWeightPointerARB;
	::glVertexBlendARB = glVertexBlendARB;
#endif

#ifdef GL_ARB_vertex_buffer_object
	::glBindBufferARB = glBindBufferARB;
	::glDeleteBuffersARB = glDeleteBuffersARB;
	::glGenBuffersARB = glGenBuffersARB;
	::glIsBufferARB = glIsBufferARB;
		
	::glBufferDataARB = glBufferDataARB;
	::glBufferSubDataARB = glBufferSubDataARB;
	::glGetBufferSubDataARB = glGetBufferSubDataARB;
		
	::glMapBufferARB = glMapBufferARB;
	::glUnmapBufferARB = glUnmapBufferARB;

	::glGetBufferParameterivARB = glGetBufferParameterivARB;
	::glGetBufferPointervARB = glGetBufferPointervARB;
#endif

#ifdef GL_ARB_vertex_program
	::glVertexAttrib1sARB = glVertexAttrib1sARB;
	::glVertexAttrib1fARB = glVertexAttrib1fARB;
	::glVertexAttrib1dARB = glVertexAttrib1dARB;
	::glVertexAttrib2sARB = glVertexAttrib2sARB;
	::glVertexAttrib2fARB = glVertexAttrib2fARB;
	::glVertexAttrib2dARB = glVertexAttrib2dARB;
	::glVertexAttrib3sARB = glVertexAttrib3sARB;
	::glVertexAttrib3fARB = glVertexAttrib3fARB;
	::glVertexAttrib3dARB = glVertexAttrib3dARB;
	::glVertexAttrib4sARB = glVertexAttrib4sARB;
	::glVertexAttrib4fARB = glVertexAttrib4fARB;
	::glVertexAttrib4dARB = glVertexAttrib4dARB;
	::glVertexAttrib4NubARB = glVertexAttrib4NubARB;
	::glVertexAttrib1svARB = glVertexAttrib1svARB;
	::glVertexAttrib1fvARB = glVertexAttrib1fvARB;
	::glVertexAttrib1dvARB = glVertexAttrib1dvARB;
	::glVertexAttrib2svARB = glVertexAttrib2svARB;
	::glVertexAttrib2fvARB = glVertexAttrib2fvARB;
	::glVertexAttrib2dvARB = glVertexAttrib2dvARB;
	::glVertexAttrib3svARB = glVertexAttrib3svARB;
	::glVertexAttrib3fvARB = glVertexAttrib3fvARB;
	::glVertexAttrib3dvARB = glVertexAttrib3dvARB;
	::glVertexAttrib4bvARB = glVertexAttrib4bvARB;
	::glVertexAttrib4svARB = glVertexAttrib4svARB;
	::glVertexAttrib4ivARB = glVertexAttrib4ivARB;
	::glVertexAttrib4ubvARB = glVertexAttrib4ubvARB;
	::glVertexAttrib4usvARB = glVertexAttrib4usvARB;
	::glVertexAttrib4uivARB = glVertexAttrib4uivARB;
	::glVertexAttrib4fvARB = glVertexAttrib4fvARB;
	::glVertexAttrib4dvARB = glVertexAttrib4dvARB;
	::glVertexAttrib4NbvARB = glVertexAttrib4NbvARB;
	::glVertexAttrib4NsvARB = glVertexAttrib4NsvARB;
	::glVertexAttrib4NivARB = glVertexAttrib4NivARB;
	::glVertexAttrib4NubvARB = glVertexAttrib4NubvARB;
	::glVertexAttrib4NusvARB = glVertexAttrib4NusvARB;
	::glVertexAttrib4NuivARB = glVertexAttrib4NuivARB;
	::glVertexAttribPointerARB = glVertexAttribPointerARB;
	::glEnableVertexAttribArrayARB = glEnableVertexAttribArrayARB;
	::glDisableVertexAttribArrayARB = glDisableVertexAttribArrayARB;
	::glProgramStringARB = glProgramStringARB;
	::glBindProgramARB = glBindProgramARB;
	::glDeleteProgramsARB = glDeleteProgramsARB;
	::glGenProgramsARB = glGenProgramsARB;
	::glProgramEnvParameter4dARB = glProgramEnvParameter4dARB;
	::glProgramEnvParameter4dvARB = glProgramEnvParameter4dvARB;
	::glProgramEnvParameter4fARB = glProgramEnvParameter4fARB;
	::glProgramEnvParameter4fvARB = glProgramEnvParameter4fvARB;
	::glProgramLocalParameter4dARB = glProgramLocalParameter4dARB;
	::glProgramLocalParameter4dvARB = glProgramLocalParameter4dvARB;
	::glProgramLocalParameter4fARB = glProgramLocalParameter4fARB;
	::glProgramLocalParameter4fvARB = glProgramLocalParameter4fvARB;
	::glGetProgramEnvParameterdvARB = glGetProgramEnvParameterdvARB;
	::glGetProgramEnvParameterfvARB = glGetProgramEnvParameterfvARB;
	::glGetProgramLocalParameterdvARB = glGetProgramLocalParameterdvARB;
	::glGetProgramLocalParameterfvARB = glGetProgramLocalParameterfvARB;
	::glGetProgramivARB = glGetProgramivARB;
	::glGetProgramStringARB = glGetProgramStringARB;
	::glGetVertexAttribdvARB = glGetVertexAttribdvARB;
	::glGetVertexAttribfvARB = glGetVertexAttribfvARB;
	::glGetVertexAttribivARB = glGetVertexAttribivARB;
	::glGetVertexAttribPointervARB = glGetVertexAttribPointervARB;
	::glIsProgramARB = glIsProgramARB;
#endif

#ifdef GL_ARB_vertex_shader
	::glBindAttribLocationARB = glBindAttribLocationARB;
	::glGetActiveAttribARB = glGetActiveAttribARB;
	::glGetAttribLocationARB = glGetAttribLocationARB;
#endif

#ifdef GL_ATI_element_array
	::glElementPointerATI = glElementPointerATI;
	::glDrawElementArrayATI = glDrawElementArrayATI;
	::glDrawRangeElementArrayATI = glDrawRangeElementArrayATI;
#endif

#ifdef GL_ATI_envmap_bumpmap
	::glTexBumpParameterivATI = glTexBumpParameterivATI;
	::glTexBumpParameterfvATI = glTexBumpParameterfvATI;
	::glGetTexBumpParameterivATI = glGetTexBumpParameterivATI;
	::glGetTexBumpParameterfvATI = glGetTexBumpParameterfvATI;
#endif

#ifdef GL_ATI_fragment_shader
	::glGenFragmentShadersATI = glGenFragmentShadersATI;
	::glBindFragmentShaderATI = glBindFragmentShaderATI;
	::glDeleteFragmentShaderATI = glDeleteFragmentShaderATI;
	::glBeginFragmentShaderATI = glBeginFragmentShaderATI;
	::glEndFragmentShaderATI = glEndFragmentShaderATI;
	::glPassTexCoordATI = glPassTexCoordATI;
	::glSampleMapATI = glSampleMapATI;

	::glColorFragmentOp1ATI = glColorFragmentOp1ATI;
	::glColorFragmentOp2ATI = glColorFragmentOp2ATI;
	::glColorFragmentOp3ATI = glColorFragmentOp3ATI;
				
	::glAlphaFragmentOp1ATI = glAlphaFragmentOp1ATI;
	::glAlphaFragmentOp2ATI = glAlphaFragmentOp2ATI;
	::glAlphaFragmentOp3ATI = glAlphaFragmentOp3ATI;

	::glSetFragmentShaderConstantATI = glSetFragmentShaderConstantATI;
#endif

#ifdef GL_ATI_map_object_buffer
	::glMapObjectBufferATI = glMapObjectBufferATI;
	::glUnmapObjectBufferATI = glUnmapObjectBufferATI;
#endif

#ifdef GL_ATI_pn_triangles
	::glPNTrianglesiATI = glPNTrianglesiATI;
	::glPNTrianglesfATI = glPNTrianglesfATI;
#endif

#ifdef GL_ATI_vertex_array_object
	::glNewObjectBufferATI = glNewObjectBufferATI;
	::glIsObjectBufferATI = glIsObjectBufferATI;
	::glUpdateObjectBufferATI = glUpdateObjectBufferATI;
	::glGetObjectBufferfvATI = glGetObjectBufferfvATI;
	::glGetObjectBufferivATI = glGetObjectBufferivATI;
	::glFreeObjectBufferATI = glFreeObjectBufferATI;
		
	::glArrayObjectATI = glArrayObjectATI;
	::glGetArrayObjectfvATI = glGetArrayObjectfvATI;
	::glGetArrayObjectivATI = glGetArrayObjectivATI;
	::glVariantArrayObjectATI = glVariantArrayObjectATI;

	::glGetVariantArrayObjectfvATI = glGetVariantArrayObjectfvATI;
	::glGetVariantArrayObjectivATI = glGetVariantArrayObjectivATI;
#endif

#ifdef GL_ATI_vertex_attrib_array_object
	::glVertexAttribArrayObjectATI = glVertexAttribArrayObjectATI;
#endif

#ifdef GL_ATI_vertex_streams
	::glClientActiveVertexStreamATI = glClientActiveVertexStreamATI;
	::glVertexBlendEnviATI = glVertexBlendEnviATI;
	::glVertexBlendEnvfATI = glVertexBlendEnvfATI;
		
	::glVertexStream2sATI = glVertexStream2sATI;
	::glVertexStream2svATI = glVertexStream2svATI;
	::glVertexStream2iATI = glVertexStream2iATI;
	::glVertexStream2ivATI = glVertexStream2ivATI;
	::glVertexStream2fATI = glVertexStream2fATI;
	::glVertexStream2fvATI = glVertexStream2fvATI;
	::glVertexStream2dATI = glVertexStream2dATI;
	::glVertexStream2dvATI = glVertexStream2dvATI;
		
	::glVertexStream3sATI = glVertexStream3sATI;
	::glVertexStream3svATI = glVertexStream3svATI;
	::glVertexStream3iATI = glVertexStream3iATI;
	::glVertexStream3ivATI = glVertexStream3ivATI;
	::glVertexStream3fATI = glVertexStream3fATI;
	::glVertexStream3fvATI = glVertexStream3fvATI;
	::glVertexStream3dATI = glVertexStream3dATI;
	::glVertexStream3dvATI = glVertexStream3dvATI;
		
	::glVertexStream4sATI = glVertexStream4sATI;
	::glVertexStream4svATI = glVertexStream4svATI;
	::glVertexStream4iATI = glVertexStream4iATI;
	::glVertexStream4ivATI = glVertexStream4ivATI;
	::glVertexStream4fATI = glVertexStream4fATI;
	::glVertexStream4fvATI = glVertexStream4fvATI;
	::glVertexStream4dATI = glVertexStream4dATI;
	::glVertexStream4dvATI = glVertexStream4dvATI;
		
	::glNormalStream3bATI = glNormalStream3bATI;
	::glNormalStream3bvATI = glNormalStream3bvATI;
	::glNormalStream3sATI = glNormalStream3sATI;
	::glNormalStream3svATI = glNormalStream3svATI;
	::glNormalStream3iATI = glNormalStream3iATI;
	::glNormalStream3ivATI = glNormalStream3ivATI;
	::glNormalStream3fATI = glNormalStream3fATI;
	::glNormalStream3fvATI = glNormalStream3fvATI;
	::glNormalStream3dATI = glNormalStream3dATI;
	::glNormalStream3dvATI = glNormalStream3dvATI;
#endif

#ifdef GL_EXT_blend_color
	::glBlendColorEXT = glBlendColorEXT;
#endif

#ifdef GL_EXT_blend_func_separate
	::glBlendFuncSeparateEXT = glBlendFuncSeparateEXT;
#endif

#ifdef GL_EXT_blend_minmax
	::glBlendEquationEXT = glBlendEquationEXT;
#endif

#ifdef GL_EXT_draw_range_elements
	::glDrawRangeElementsEXT = glDrawRangeElementsEXT;
#endif

#ifdef GL_EXT_fog_coord
	::glFogCoordfEXT = glFogCoordfEXT;
	::glFogCoorddEXT = glFogCoorddEXT;
	::glFogCoordfvEXT = glFogCoordfvEXT;
	::glFogCoorddvEXT = glFogCoorddvEXT;
	::glFogCoordPointerEXT = glFogCoordPointerEXT;
#endif

#ifdef GL_EXT_polygon_offset
	::glPolygonOffsetEXT = glPolygonOffsetEXT;
#endif

#ifdef GL_EXT_texture3D
	::glTexImage3DEXT = glTexImage3DEXT;
#endif

#ifdef GL_NV_occlusion_query
	::glGenOcclusionQueriesNV = glGenOcclusionQueriesNV;
	::glDeleteOcclusionQueriesNV = glDeleteOcclusionQueriesNV;
	::glIsOcclusionQueryNV = glIsOcclusionQueryNV;
	::glBeginOcclusionQueryNV = glBeginOcclusionQueryNV;
	::glEndOcclusionQueryNV = glEndOcclusionQueryNV;
	::glGetOcclusionQueryivNV = glGetOcclusionQueryivNV;
	::glGetOcclusionQueryuivNV = glGetOcclusionQueryuivNV;
#endif

#ifdef GL_NV_register_combiners
	::glCombinerParameterfvNV = glCombinerParameterfvNV;
	::glCombinerParameterfNV = glCombinerParameterfNV;
	::glCombinerParameterivNV = glCombinerParameterivNV;
	::glCombinerParameteriNV = glCombinerParameteriNV;
		
	::glCombinerInputNV = glCombinerInputNV;
	::glCombinerOutputNV = glCombinerOutputNV;
	::glFinalCombinerInputNV = glFinalCombinerInputNV;

	::glGetCombinerInputParameterfvNV = glGetCombinerInputParameterfvNV;
	::glGetCombinerInputParameterivNV = glGetCombinerInputParameterivNV;
	::glGetCombinerOutputParameterfvNV = glGetCombinerOutputParameterfvNV;
	::glGetCombinerOutputParameterivNV = glGetCombinerOutputParameterivNV;

	::glGetFinalCombinerInputParameterfvNV = glGetFinalCombinerInputParameterfvNV;
	::glGetFinalCombinerInputParameterivNV = glGetFinalCombinerInputParameterivNV;
#endif

#ifdef WGL_ARB_pbuffer
	::wglCreatePbufferARB = wglCreatePbufferARB;
	::wglGetPbufferDCARB = wglGetPbufferDCARB;
	::wglReleasePbufferDCARB = wglReleasePbufferDCARB;
	::wglDestroyPbufferARB = wglDestroyPbufferARB;
	::wglQueryPbufferARB = wglQueryPbufferARB;
#endif

#ifdef WGL_ARB_render_texture
	::wglBindTexImageARB = wglBindTexImageARB;
	::wglReleaseTexImageARB = wglReleaseTexImageARB;
	::wglSetPbufferAttribARB = wglSetPbufferAttribARB;
#endif
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Extensions::getExtensions() {
	#ifdef GL_ARB_multitexture
	glActiveTextureARB = (PFNGLACTIVETEXTUREARBPROC)wglGetProcAddress("glActiveTextureARB");
	glClientActiveTextureARB = (PFNGLCLIENTACTIVETEXTUREARBPROC)wglGetProcAddress("glClientActiveTextureARB");
	
	glMultiTexCoord1dARB = (PFNGLMULTITEXCOORD1DARBPROC)wglGetProcAddress("glMultiTexCoord1dARB");
	glMultiTexCoord1dvARB = (PFNGLMULTITEXCOORD1DVARBPROC)wglGetProcAddress("glMultiTexCoord1dvARB");
	glMultiTexCoord1fARB = (PFNGLMULTITEXCOORD1FARBPROC)wglGetProcAddress("glMultiTexCoord1fARB");
	glMultiTexCoord1fvARB = (PFNGLMULTITEXCOORD1FVARBPROC)wglGetProcAddress("glMultiTexCoord1fvARB");
	glMultiTexCoord1iARB = (PFNGLMULTITEXCOORD1IARBPROC)wglGetProcAddress("glMultiTexCoord1iARB");
	glMultiTexCoord1ivARB = (PFNGLMULTITEXCOORD1IVARBPROC)wglGetProcAddress("glMultiTexCoord1ivARB");
	glMultiTexCoord1sARB = (PFNGLMULTITEXCOORD1SARBPROC)wglGetProcAddress("glMultiTexCoord1sARB");
	glMultiTexCoord1svARB = (PFNGLMULTITEXCOORD1SVARBPROC)wglGetProcAddress("glMultiTexCoord1svARB");
	
	glMultiTexCoord2dARB = (PFNGLMULTITEXCOORD2DARBPROC)wglGetProcAddress("glMultiTexCoord2dARB");
	glMultiTexCoord2dvARB = (PFNGLMULTITEXCOORD2DVARBPROC)wglGetProcAddress("glMultiTexCoord2dvARB");
	glMultiTexCoord2fARB = (PFNGLMULTITEXCOORD2FARBPROC)wglGetProcAddress("glMultiTexCoord2fARB");
	glMultiTexCoord2fvARB = (PFNGLMULTITEXCOORD2FVARBPROC)wglGetProcAddress("glMultiTexCoord2fvARB");
	glMultiTexCoord2iARB = (PFNGLMULTITEXCOORD2IARBPROC)wglGetProcAddress("glMultiTexCoord2iARB");
	glMultiTexCoord2ivARB = (PFNGLMULTITEXCOORD2IVARBPROC)wglGetProcAddress("glMultiTexCoord2ivARB");
	glMultiTexCoord2sARB = (PFNGLMULTITEXCOORD2SARBPROC)wglGetProcAddress("glMultiTexCoord2sARB");
	glMultiTexCoord2svARB = (PFNGLMULTITEXCOORD2SVARBPROC)wglGetProcAddress("glMultiTexCoord2svARB");
	
	glMultiTexCoord3dARB = (PFNGLMULTITEXCOORD3DARBPROC)wglGetProcAddress("glMultiTexCoord3dARB");
	glMultiTexCoord3dvARB = (PFNGLMULTITEXCOORD3DVARBPROC)wglGetProcAddress("glMultiTexCoord3dvARB");
	glMultiTexCoord3fARB = (PFNGLMULTITEXCOORD3FARBPROC)wglGetProcAddress("glMultiTexCoord3fARB");
	glMultiTexCoord3fvARB = (PFNGLMULTITEXCOORD3FVARBPROC)wglGetProcAddress("glMultiTexCoord3fvARB");
	glMultiTexCoord3iARB = (PFNGLMULTITEXCOORD3IARBPROC)wglGetProcAddress("glMultiTexCoord3iARB");
	glMultiTexCoord3ivARB = (PFNGLMULTITEXCOORD3IVARBPROC)wglGetProcAddress("glMultiTexCoord3ivARB");
	glMultiTexCoord3sARB = (PFNGLMULTITEXCOORD3SARBPROC)wglGetProcAddress("glMultiTexCoord3sARB");
	glMultiTexCoord3svARB = (PFNGLMULTITEXCOORD3SVARBPROC)wglGetProcAddress("glMultiTexCoord3svARB");
	
	glMultiTexCoord4dARB = (PFNGLMULTITEXCOORD4DARBPROC)wglGetProcAddress("glMultiTexCoord4dARB");
	glMultiTexCoord4dvARB = (PFNGLMULTITEXCOORD4DVARBPROC)wglGetProcAddress("glMultiTexCoord4dvARB");
	glMultiTexCoord4fARB = (PFNGLMULTITEXCOORD4FARBPROC)wglGetProcAddress("glMultiTexCoord4fARB");
	glMultiTexCoord4fvARB = (PFNGLMULTITEXCOORD4FVARBPROC)wglGetProcAddress("glMultiTexCoord4fvARB");
	glMultiTexCoord4iARB = (PFNGLMULTITEXCOORD4IARBPROC)wglGetProcAddress("glMultiTexCoord4iARB");
	glMultiTexCoord4ivARB = (PFNGLMULTITEXCOORD4IVARBPROC)wglGetProcAddress("glMultiTexCoord4ivARB");
	glMultiTexCoord4sARB = (PFNGLMULTITEXCOORD4SARBPROC)wglGetProcAddress("glMultiTexCoord4sARB");
	glMultiTexCoord4svARB = (PFNGLMULTITEXCOORD4SVARBPROC)wglGetProcAddress("glMultiTexCoord4svARB");
	#endif								
										
										
	#ifdef GL_ARB_occlusion_query		
	glGenQueriesARB = (PFNGLGENQUERIESARBPROC)wglGetProcAddress("glGenQueriesARB");
	glDeleteQueriesARB = (PFNGLDELETEQUERIESARBPROC)wglGetProcAddress("glDeleteQueriesARB");
	glIsQueryARB = (PFNGLISQUERYARBPROC)wglGetProcAddress("glIsQueryARB");
	glBeginQueryARB = (PFNGLBEGINQUERYARBPROC)wglGetProcAddress("glBeginQueryARB");
	glEndQueryARB = (PFNGLENDQUERYARBPROC)wglGetProcAddress("glEndQueryARB");
	glGetQueryivARB = (PFNGLGETQUERYIVARBPROC)wglGetProcAddress("glGetQueryivARB");
	glGetQueryObjectivARB = (PFNGLGETQUERYOBJECTIVARBPROC)wglGetProcAddress("glGetQueryObjectivARB");
	glGetQueryObjectuivARB = (PFNGLGETQUERYOBJECTUIVARBPROC)wglGetProcAddress("glGetQueryObjectuivARB");
	#endif


	#ifdef GL_ARB_shader_objects
	glDeleteObjectARB = (PFNGLDELETEOBJECTARBPROC)wglGetProcAddress("glDeleteObjectARB");
	glGetHandleARB = (PFNGLGETHANDLEARBPROC)wglGetProcAddress("glGetHandleARB");
	glDetachObjectARB = (PFNGLDETACHOBJECTARBPROC)wglGetProcAddress("glDetachObjectARB");
	glCreateShaderObjectARB = (PFNGLCREATESHADEROBJECTARBPROC)wglGetProcAddress("glCreateShaderObjectARB");
	glShaderSourceARB = (PFNGLSHADERSOURCEARBPROC)wglGetProcAddress("glShaderSourceARB");
	glCompileShaderARB = (PFNGLCOMPILESHADERARBPROC)wglGetProcAddress("glCompileShaderARB");
	glCreateProgramObjectARB = (PFNGLCREATEPROGRAMOBJECTARBPROC)wglGetProcAddress("glCreateProgramObjectARB");
	glAttachObjectARB = (PFNGLATTACHOBJECTARBPROC)wglGetProcAddress("glAttachObjectARB");
	glLinkProgramARB = (PFNGLLINKPROGRAMARBPROC)wglGetProcAddress("glLinkProgramARB");
	glUseProgramObjectARB = (PFNGLUSEPROGRAMOBJECTARBPROC)wglGetProcAddress("glUseProgramObjectARB");
	glValidateProgramARB = (PFNGLVALIDATEPROGRAMARBPROC)wglGetProcAddress("glValidateProgramARB");
	
	glUniform1fARB = (PFNGLUNIFORM1FARBPROC)wglGetProcAddress("glUniform1fARB");
	glUniform2fARB = (PFNGLUNIFORM2FARBPROC)wglGetProcAddress("glUniform2fARB");
	glUniform3fARB = (PFNGLUNIFORM3FARBPROC)wglGetProcAddress("glUniform3fARB");
	glUniform4fARB = (PFNGLUNIFORM4FARBPROC)wglGetProcAddress("glUniform4fARB");
	
	glUniform1iARB = (PFNGLUNIFORM1IARBPROC)wglGetProcAddress("glUniform1iARB");
	glUniform2iARB = (PFNGLUNIFORM2IARBPROC)wglGetProcAddress("glUniform2iARB");
	glUniform3iARB = (PFNGLUNIFORM3IARBPROC)wglGetProcAddress("glUniform3iARB");
	glUniform4iARB = (PFNGLUNIFORM4IARBPROC)wglGetProcAddress("glUniform4iARB");
	
	glUniform1fvARB = (PFNGLUNIFORM1FVARBPROC)wglGetProcAddress("glUniform1fvARB");
	glUniform2fvARB = (PFNGLUNIFORM2FVARBPROC)wglGetProcAddress("glUniform2fvARB");
	glUniform3fvARB = (PFNGLUNIFORM3FVARBPROC)wglGetProcAddress("glUniform3fvARB");
	glUniform4fvARB = (PFNGLUNIFORM4FVARBPROC)wglGetProcAddress("glUniform4fvARB");
	
	glUniform1ivARB = (PFNGLUNIFORM1IVARBPROC)wglGetProcAddress("glUniform1ivARB");
	glUniform2ivARB = (PFNGLUNIFORM2IVARBPROC)wglGetProcAddress("glUniform2ivARB");
	glUniform3ivARB = (PFNGLUNIFORM3IVARBPROC)wglGetProcAddress("glUniform3ivARB");
	glUniform4ivARB = (PFNGLUNIFORM4IVARBPROC)wglGetProcAddress("glUniform4ivARB");
	
	glUniformMatrix2fvARB = (PFNGLUNIFORMMATRIX2FVARBPROC)wglGetProcAddress("glUniformMatrix2fvARB");
	glUniformMatrix3fvARB = (PFNGLUNIFORMMATRIX3FVARBPROC)wglGetProcAddress("glUniformMatrix3fvARB");
	glUniformMatrix4fvARB = (PFNGLUNIFORMMATRIX4FVARBPROC)wglGetProcAddress("glUniformMatrix4fvARB");

	glGetObjectParameterfvARB = (PFNGLGETOBJECTPARAMETERFVARBPROC)wglGetProcAddress("glGetObjectParameterfvARB");
	glGetObjectParameterivARB = (PFNGLGETOBJECTPARAMETERIVARBPROC)wglGetProcAddress("glGetObjectParameterivARB");
	glGetInfoLogARB = (PFNGLGETINFOLOGARBPROC)wglGetProcAddress("glGetInfoLogARB");
	glGetAttachedObjectsARB = (PFNGLGETATTACHEDOBJECTSARBPROC)wglGetProcAddress("glGetAttachedObjectsARB");
	glGetUniformLocationARB = (PFNGLGETUNIFORMLOCATIONARBPROC)wglGetProcAddress("glGetUniformLocationARB");
	glGetActiveUniformARB = (PFNGLGETACTIVEUNIFORMARBPROC)wglGetProcAddress("glGetActiveUniformARB");
	glGetUniformfvARB = (PFNGLGETUNIFORMFVARBPROC)wglGetProcAddress("glGetUniformfvARB");
	glGetUniformivARB = (PFNGLGETUNIFORMIVARBPROC)wglGetProcAddress("glGetUniformivARB");
	glGetShaderSourceARB = (PFNGLGETSHADERSOURCEARBPROC)wglGetProcAddress("glGetShaderSourceARB");
	#endif


	#ifdef GL_ARB_texture_compression
	glCompressedTexImage1DARB = (PFNGLCOMPRESSEDTEXIMAGE1DARBPROC)wglGetProcAddress("glCompressedTexImage1DARB");
	glCompressedTexImage2DARB = (PFNGLCOMPRESSEDTEXIMAGE2DARBPROC)wglGetProcAddress("glCompressedTexImage2DARB");
	glCompressedTexImage3DARB = (PFNGLCOMPRESSEDTEXIMAGE3DARBPROC)wglGetProcAddress("glCompressedTexImage3DARB");
	glCompressedTexSubImage1DARB = (PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC)wglGetProcAddress("glCompressedTexSubImage1DARB");
	glCompressedTexSubImage2DARB = (PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC)wglGetProcAddress("glCompressedTexSubImage2DARB");
	glCompressedTexSubImage3DARB = (PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC)wglGetProcAddress("glCompressedTexSubImage3DARB");
	glGetCompressedTexImageARB = (PFNGLGETCOMPRESSEDTEXIMAGEARBPROC)wglGetProcAddress("glGetCompressedTexImageARB");
	#endif


	#ifdef GL_ARB_transpose_matrix
	glLoadTransposeMatrixfARB = (PFNGLLOADTRANSPOSEMATRIXFARBPROC)wglGetProcAddress("glLoadTransposeMatrixfARB");
	glLoadTransposeMatrixdARB = (PFNGLLOADTRANSPOSEMATRIXDARBPROC)wglGetProcAddress("glLoadTransposeMatrixdARB");
	glMultTransposeMatrixfARB = (PFNGLMULTTRANSPOSEMATRIXFARBPROC)wglGetProcAddress("glMultTransposeMatrixfARB");
	glMultTransposeMatrixdARB = (PFNGLMULTTRANSPOSEMATRIXDARBPROC)wglGetProcAddress("glMultTransposeMatrixdARB");
	#endif


	#ifdef GL_ARB_vertex_blend
	glWeightbvARB = (PFNGLWEIGHTBVARBPROC)wglGetProcAddress("glWeightbvARB");
	glWeightsvARB = (PFNGLWEIGHTSVARBPROC)wglGetProcAddress("glWeightsvARB");
	glWeightivARB = (PFNGLWEIGHTIVARBPROC)wglGetProcAddress("glWeightivARB");
	glWeightfvARB = (PFNGLWEIGHTFVARBPROC)wglGetProcAddress("glWeightfvARB");
	glWeightdvARB = (PFNGLWEIGHTDVARBPROC)wglGetProcAddress("glWeightdvARB");
	glWeightubvARB = (PFNGLWEIGHTUBVARBPROC)wglGetProcAddress("glWeightubvARB");
	glWeightusvARB = (PFNGLWEIGHTUSVARBPROC)wglGetProcAddress("glWeightusvARB");
	glWeightuivARB = (PFNGLWEIGHTUIVARBPROC)wglGetProcAddress("glWeightuivARB");
	
	glWeightPointerARB = (PFNGLWEIGHTPOINTERARBPROC)wglGetProcAddress("glWeightPointerARB");
	glVertexBlendARB = (PFNGLVERTEXBLENDARBPROC)wglGetProcAddress("glVertexBlendARB");
	#endif


	#ifdef GL_ARB_vertex_buffer_object
	glBindBufferARB = (PFNGLBINDBUFFERARBPROC)wglGetProcAddress("glBindBufferARB");
	glDeleteBuffersARB = (PFNGLDELETEBUFFERSARBPROC)wglGetProcAddress("glDeleteBuffersARB");
	glGenBuffersARB = (PFNGLGENBUFFERSARBPROC)wglGetProcAddress("glGenBuffersARB");
	glIsBufferARB = (PFNGLISBUFFERARBPROC)wglGetProcAddress("glIsBufferARB");
	
	glBufferDataARB = (PFNGLBUFFERDATAARBPROC)wglGetProcAddress("glBufferDataARB");
	glBufferSubDataARB = (PFNGLBUFFERSUBDATAARBPROC)wglGetProcAddress("glBufferSubDataARB");
	glGetBufferSubDataARB = (PFNGLGETBUFFERSUBDATAARBPROC)wglGetProcAddress("glGetBufferSubDataARB");
	
	glMapBufferARB = (PFNGLMAPBUFFERARBPROC)wglGetProcAddress("glMapBufferARB");
	glUnmapBufferARB = (PFNGLUNMAPBUFFERARBPROC)wglGetProcAddress("glUnmapBufferARB");

	glGetBufferParameterivARB = (PFNGLGETBUFFERPARAMETERIVARBPROC)wglGetProcAddress("glGetBufferParameterivARB");
	glGetBufferPointervARB = (PFNGLGETBUFFERPOINTERVARBPROC)wglGetProcAddress("glGetBufferPointervARB");
	#endif


	#ifdef GL_ARB_vertex_program
	glVertexAttrib1sARB = (PFNGLVERTEXATTRIB1SARBPROC)wglGetProcAddress("glVertexAttrib1sARB");
	glVertexAttrib1fARB = (PFNGLVERTEXATTRIB1FARBPROC)wglGetProcAddress("glVertexAttrib1fARB");
	glVertexAttrib1dARB = (PFNGLVERTEXATTRIB1DARBPROC)wglGetProcAddress("glVertexAttrib1dARB");
	glVertexAttrib2sARB = (PFNGLVERTEXATTRIB2SARBPROC)wglGetProcAddress("glVertexAttrib2sARB");
	glVertexAttrib2fARB = (PFNGLVERTEXATTRIB2FARBPROC)wglGetProcAddress("glVertexAttrib2fARB");
	glVertexAttrib2dARB = (PFNGLVERTEXATTRIB2DARBPROC)wglGetProcAddress("glVertexAttrib2dARB");
	glVertexAttrib3sARB = (PFNGLVERTEXATTRIB3SARBPROC)wglGetProcAddress("glVertexAttrib3sARB");
	glVertexAttrib3fARB = (PFNGLVERTEXATTRIB3FARBPROC)wglGetProcAddress("glVertexAttrib3fARB");
	glVertexAttrib3dARB = (PFNGLVERTEXATTRIB3DARBPROC)wglGetProcAddress("glVertexAttrib3dARB");
	glVertexAttrib4sARB = (PFNGLVERTEXATTRIB4SARBPROC)wglGetProcAddress("glVertexAttrib4sARB");
	glVertexAttrib4fARB = (PFNGLVERTEXATTRIB4FARBPROC)wglGetProcAddress("glVertexAttrib4fARB");
	glVertexAttrib4dARB = (PFNGLVERTEXATTRIB4DARBPROC)wglGetProcAddress("glVertexAttrib4dARB");
	glVertexAttrib4NubARB = (PFNGLVERTEXATTRIB4NUBARBPROC)wglGetProcAddress("glVertexAttrib4NubARB");
	glVertexAttrib1svARB = (PFNGLVERTEXATTRIB1SVARBPROC)wglGetProcAddress("glVertexAttrib1svARB");
	glVertexAttrib1fvARB = (PFNGLVERTEXATTRIB1FVARBPROC)wglGetProcAddress("glVertexAttrib1fvARB");
	glVertexAttrib1dvARB = (PFNGLVERTEXATTRIB1DVARBPROC)wglGetProcAddress("glVertexAttrib1dvARB");
	glVertexAttrib2svARB = (PFNGLVERTEXATTRIB2SVARBPROC)wglGetProcAddress("glVertexAttrib2svARB");
	glVertexAttrib2fvARB = (PFNGLVERTEXATTRIB2FVARBPROC)wglGetProcAddress("glVertexAttrib2fvARB");
	glVertexAttrib2dvARB = (PFNGLVERTEXATTRIB2DVARBPROC)wglGetProcAddress("glVertexAttrib2dvARB");
	glVertexAttrib3svARB = (PFNGLVERTEXATTRIB3SVARBPROC)wglGetProcAddress("glVertexAttrib3svARB");
	glVertexAttrib3fvARB = (PFNGLVERTEXATTRIB3FVARBPROC)wglGetProcAddress("glVertexAttrib3fvARB");
	glVertexAttrib3dvARB = (PFNGLVERTEXATTRIB3DVARBPROC)wglGetProcAddress("glVertexAttrib3dvARB");
	glVertexAttrib4bvARB = (PFNGLVERTEXATTRIB4BVARBPROC)wglGetProcAddress("glVertexAttrib4bvARB");
	glVertexAttrib4svARB = (PFNGLVERTEXATTRIB4SVARBPROC)wglGetProcAddress("glVertexAttrib4svARB");
	glVertexAttrib4ivARB = (PFNGLVERTEXATTRIB4IVARBPROC)wglGetProcAddress("glVertexAttrib4ivARB");
	glVertexAttrib4ubvARB = (PFNGLVERTEXATTRIB4UBVARBPROC)wglGetProcAddress("glVertexAttrib4ubvARB");
	glVertexAttrib4usvARB = (PFNGLVERTEXATTRIB4USVARBPROC)wglGetProcAddress("glVertexAttrib4usvARB");
	glVertexAttrib4uivARB = (PFNGLVERTEXATTRIB4UIVARBPROC)wglGetProcAddress("glVertexAttrib4uivARB");
	glVertexAttrib4fvARB = (PFNGLVERTEXATTRIB4FVARBPROC)wglGetProcAddress("glVertexAttrib4fvARB");
	glVertexAttrib4dvARB = (PFNGLVERTEXATTRIB4DVARBPROC)wglGetProcAddress("glVertexAttrib4dvARB");
	glVertexAttrib4NbvARB = (PFNGLVERTEXATTRIB4NBVARBPROC)wglGetProcAddress("glVertexAttrib4NbvARB");
	glVertexAttrib4NsvARB = (PFNGLVERTEXATTRIB4NSVARBPROC)wglGetProcAddress("glVertexAttrib4NsvARB");
	glVertexAttrib4NivARB = (PFNGLVERTEXATTRIB4NIVARBPROC)wglGetProcAddress("glVertexAttrib4NivARB");
	glVertexAttrib4NubvARB = (PFNGLVERTEXATTRIB4NUBVARBPROC)wglGetProcAddress("glVertexAttrib4NubvARB");
	glVertexAttrib4NusvARB = (PFNGLVERTEXATTRIB4NUSVARBPROC)wglGetProcAddress("glVertexAttrib4NusvARB");
	glVertexAttrib4NuivARB = (PFNGLVERTEXATTRIB4NUIVARBPROC)wglGetProcAddress("glVertexAttrib4NuivARB");
	glVertexAttribPointerARB = (PFNGLVERTEXATTRIBPOINTERARBPROC)wglGetProcAddress("glVertexAttribPointerARB");
	glEnableVertexAttribArrayARB = (PFNGLENABLEVERTEXATTRIBARRAYARBPROC)wglGetProcAddress("glEnableVertexAttribArrayARB");
	glDisableVertexAttribArrayARB = (PFNGLDISABLEVERTEXATTRIBARRAYARBPROC)wglGetProcAddress("glDisableVertexAttribArrayARB");
	glProgramStringARB = (PFNGLPROGRAMSTRINGARBPROC)wglGetProcAddress("glProgramStringARB");
	glBindProgramARB = (PFNGLBINDPROGRAMARBPROC)wglGetProcAddress("glBindProgramARB");
	glDeleteProgramsARB = (PFNGLDELETEPROGRAMSARBPROC)wglGetProcAddress("glDeleteProgramsARB");
	glGenProgramsARB = (PFNGLGENPROGRAMSARBPROC)wglGetProcAddress("glGenProgramsARB");
	glProgramEnvParameter4dARB = (PFNGLPROGRAMENVPARAMETER4DARBPROC)wglGetProcAddress("glProgramEnvParameter4dARB");
	glProgramEnvParameter4dvARB = (PFNGLPROGRAMENVPARAMETER4DVARBPROC)wglGetProcAddress("glProgramEnvParameter4dvARB");
	glProgramEnvParameter4fARB = (PFNGLPROGRAMENVPARAMETER4FARBPROC)wglGetProcAddress("glProgramEnvParameter4fARB");
	glProgramEnvParameter4fvARB = (PFNGLPROGRAMENVPARAMETER4FVARBPROC)wglGetProcAddress("glProgramEnvParameter4fvARB");
	glProgramLocalParameter4dARB = (PFNGLPROGRAMLOCALPARAMETER4DARBPROC)wglGetProcAddress("glProgramLocalParameter4dARB");
	glProgramLocalParameter4dvARB = (PFNGLPROGRAMLOCALPARAMETER4DVARBPROC)wglGetProcAddress("glProgramLocalParameter4dvARB");
	glProgramLocalParameter4fARB = (PFNGLPROGRAMLOCALPARAMETER4FARBPROC)wglGetProcAddress("glProgramLocalParameter4fARB");
	glProgramLocalParameter4fvARB = (PFNGLPROGRAMLOCALPARAMETER4FVARBPROC)wglGetProcAddress("glProgramLocalParameter4fvARB");
	glGetProgramEnvParameterdvARB = (PFNGLGETPROGRAMENVPARAMETERDVARBPROC)wglGetProcAddress("glGetProgramEnvParameterdvARB");
	glGetProgramEnvParameterfvARB = (PFNGLGETPROGRAMENVPARAMETERFVARBPROC)wglGetProcAddress("glGetProgramEnvParameterfvARB");
	glGetProgramLocalParameterdvARB = (PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC)wglGetProcAddress("glGetProgramLocalParameterdvARB");
	glGetProgramLocalParameterfvARB = (PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC)wglGetProcAddress("glGetProgramLocalParameterfvARB");
	glGetProgramivARB = (PFNGLGETPROGRAMIVARBPROC)wglGetProcAddress("glGetProgramivARB");
	glGetProgramStringARB = (PFNGLGETPROGRAMSTRINGARBPROC)wglGetProcAddress("glGetProgramStringARB");
	glGetVertexAttribdvARB = (PFNGLGETVERTEXATTRIBDVARBPROC)wglGetProcAddress("glGetVertexAttribdvARB");
	glGetVertexAttribfvARB = (PFNGLGETVERTEXATTRIBFVARBPROC)wglGetProcAddress("glGetVertexAttribfvARB");
	glGetVertexAttribivARB = (PFNGLGETVERTEXATTRIBIVARBPROC)wglGetProcAddress("glGetVertexAttribivARB");
	glGetVertexAttribPointervARB = (PFNGLGETVERTEXATTRIBPOINTERVARBPROC)wglGetProcAddress("glGetVertexAttribPointervARB");
	glIsProgramARB = (PFNGLISPROGRAMARBPROC)wglGetProcAddress("glIsProgramARB");
	#endif


	#ifdef GL_ARB_vertex_shader
	glBindAttribLocationARB = (PFNGLBINDATTRIBLOCATIONARBPROC)wglGetProcAddress("glBindAttribLocationARB");
	glGetActiveAttribARB = (PFNGLGETACTIVEATTRIBARBPROC)wglGetProcAddress("glGetActiveAttribARB");
	glGetAttribLocationARB = (PFNGLGETATTRIBLOCATIONARBPROC)wglGetProcAddress("glGetAttribLocationARB");
	#endif


	#ifdef GL_ATI_element_array
	glElementPointerATI = (PFNGLELEMENTPOINTERATIPROC)wglGetProcAddress("glElementPointerATI");
	glDrawElementArrayATI = (PFNGLDRAWELEMENTARRAYATIPROC)wglGetProcAddress("glDrawElementArrayATI");
	glDrawRangeElementArrayATI = (PFNGLDRAWRANGEELEMENTARRAYATIPROC)wglGetProcAddress("glDrawRangeElementArrayATI");
	#endif


	#ifdef GL_ATI_envmap_bumpmap
	glTexBumpParameterivATI = (PFNGLTEXBUMPPARAMETERIVATIPROC)wglGetProcAddress("glTexBumpParameterivATI");
	glTexBumpParameterfvATI = (PFNGLTEXBUMPPARAMETERFVATIPROC)wglGetProcAddress("glTexBumpParameterfvATI");
	glGetTexBumpParameterivATI = (PFNGLGETTEXBUMPPARAMETERIVATIPROC)wglGetProcAddress("glGetTexBumpParameterivATI");
	glGetTexBumpParameterfvATI = (PFNGLGETTEXBUMPPARAMETERFVATIPROC)wglGetProcAddress("glGetTexBumpParameterfvATI");
	#endif


	#ifdef GL_ATI_fragment_shader
	glGenFragmentShadersATI = (PFNGLGENFRAGMENTSHADERSATIPROC)wglGetProcAddress("glGenFragmentShadersATI");
	glBindFragmentShaderATI = (PFNGLBINDFRAGMENTSHADERATIPROC)wglGetProcAddress("glBindFragmentShaderATI");
	glDeleteFragmentShaderATI = (PFNGLDELETEFRAGMENTSHADERATIPROC)wglGetProcAddress("glDeleteFragmentShaderATI");
	glBeginFragmentShaderATI = (PFNGLBEGINFRAGMENTSHADERATIPROC)wglGetProcAddress("glBeginFragmentShaderATI");
	glEndFragmentShaderATI = (PFNGLENDFRAGMENTSHADERATIPROC)wglGetProcAddress("glEndFragmentShaderATI");
	glPassTexCoordATI = (PFNGLPASSTEXCOORDATIPROC)wglGetProcAddress("glPassTexCoordATI");
	glSampleMapATI = (PFNGLSAMPLEMAPATIPROC)wglGetProcAddress("glSampleMapATI");

	glColorFragmentOp1ATI = (PFNGLCOLORFRAGMENTOP1ATIPROC)wglGetProcAddress("glColorFragmentOp1ATI");
	glColorFragmentOp2ATI = (PFNGLCOLORFRAGMENTOP2ATIPROC)wglGetProcAddress("glColorFragmentOp2ATI");
	glColorFragmentOp3ATI = (PFNGLCOLORFRAGMENTOP3ATIPROC)wglGetProcAddress("glColorFragmentOp3ATI");
			
	glAlphaFragmentOp1ATI = (PFNGLALPHAFRAGMENTOP1ATIPROC)wglGetProcAddress("glAlphaFragmentOp1ATI");
	glAlphaFragmentOp2ATI = (PFNGLALPHAFRAGMENTOP2ATIPROC)wglGetProcAddress("glAlphaFragmentOp2ATI");
	glAlphaFragmentOp3ATI = (PFNGLALPHAFRAGMENTOP3ATIPROC)wglGetProcAddress("glAlphaFragmentOp3ATI");

	glSetFragmentShaderConstantATI = (PFNGLSETFRAGMENTSHADERCONSTANTATIPROC)wglGetProcAddress("glSetFragmentShaderConstantATI");
	#endif


	#ifdef GL_ATI_map_object_buffer
	glMapObjectBufferATI = (PFNGLMAPOBJECTBUFFERATIPROC)wglGetProcAddress("glMapObjectBufferATI");
	glUnmapObjectBufferATI = (PFNGLUNMAPOBJECTBUFFERATIPROC)wglGetProcAddress("glUnmapObjectBufferATI");
	#endif


	#ifdef GL_ATI_pn_triangles
	glPNTrianglesiATI = (PFNGLPNTRIANGLESIATIPROC)wglGetProcAddress("glPNTrianglesiATI");
	glPNTrianglesfATI = (PFNGLPNTRIANGLESFATIPROC)wglGetProcAddress("glPNTrianglesfATI");
	#endif



	#ifdef GL_ATI_vertex_array_object
	glNewObjectBufferATI = (PFNGLNEWOBJECTBUFFERATIPROC)wglGetProcAddress("glNewObjectBufferATI");
	glIsObjectBufferATI = (PFNGLISOBJECTBUFFERATIPROC)wglGetProcAddress("glIsObjectBufferATI");
	glUpdateObjectBufferATI = (PFNGLUPDATEOBJECTBUFFERATIPROC)wglGetProcAddress("glUpdateObjectBufferATI");
	glGetObjectBufferfvATI = (PFNGLGETOBJECTBUFFERFVATIPROC)wglGetProcAddress("glGetObjectBufferfvATI");
	glGetObjectBufferivATI = (PFNGLGETOBJECTBUFFERIVATIPROC)wglGetProcAddress("glGetObjectBufferivATI");
	glFreeObjectBufferATI = (PFNGLFREEOBJECTBUFFERATIPROC)wglGetProcAddress("glFreeObjectBufferATI");
	
	glArrayObjectATI = (PFNGLARRAYOBJECTATIPROC)wglGetProcAddress("glArrayObjectATI");
	glGetArrayObjectfvATI = (PFNGLGETARRAYOBJECTFVATIPROC)wglGetProcAddress("glGetArrayObjectfvATI");
	glGetArrayObjectivATI = (PFNGLGETARRAYOBJECTIVATIPROC)wglGetProcAddress("glGetArrayObjectivATI");
	glVariantArrayObjectATI = (PFNGLVARIANTARRAYOBJECTATIPROC)wglGetProcAddress("glVariantArrayObjectATI");

	glGetVariantArrayObjectfvATI = (PFNGLGETVARIANTARRAYOBJECTFVATIPROC)wglGetProcAddress("glGetVariantArrayObjectfvATI");
	glGetVariantArrayObjectivATI = (PFNGLGETVARIANTARRAYOBJECTIVATIPROC)wglGetProcAddress("glGetVariantArrayObjectivATI");
	#endif


	#ifdef GL_ATI_vertex_attrib_array_object
	glVertexAttribArrayObjectATI = (PFNGLVERTEXATTRIBARRAYOBJECTATIPROC)wglGetProcAddress("glVertexAttribArrayObjectATI");
	#endif


	#ifdef GL_ATI_vertex_streams
	glClientActiveVertexStreamATI = (PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC)wglGetProcAddress("glClientActiveVertexStreamATI");
	glVertexBlendEnviATI = (PFNGLVERTEXBLENDENVIATIPROC)wglGetProcAddress("glVertexBlendEnviATI");
	glVertexBlendEnvfATI = (PFNGLVERTEXBLENDENVFATIPROC)wglGetProcAddress("glVertexBlendEnvfATI");
	
	glVertexStream2sATI = (PFNGLVERTEXSTREAM2SATIPROC)wglGetProcAddress("glVertexStream2sATI");
	glVertexStream2svATI = (PFNGLVERTEXSTREAM2SVATIPROC)wglGetProcAddress("glVertexStream2svATI");
	glVertexStream2iATI = (PFNGLVERTEXSTREAM2IATIPROC)wglGetProcAddress("glVertexStream2iATI");
	glVertexStream2ivATI = (PFNGLVERTEXSTREAM2IVATIPROC)wglGetProcAddress("glVertexStream2ivATI");
	glVertexStream2fATI = (PFNGLVERTEXSTREAM2FATIPROC)wglGetProcAddress("glVertexStream2fATI");
	glVertexStream2fvATI = (PFNGLVERTEXSTREAM2FVATIPROC)wglGetProcAddress("glVertexStream2fvATI");
	glVertexStream2dATI = (PFNGLVERTEXSTREAM2DATIPROC)wglGetProcAddress("glVertexStream2dATI");
	glVertexStream2dvATI = (PFNGLVERTEXSTREAM2DVATIPROC)wglGetProcAddress("glVertexStream2dvATI");
	
	glVertexStream3sATI = (PFNGLVERTEXSTREAM3SATIPROC)wglGetProcAddress("glVertexStream3sATI");
	glVertexStream3svATI = (PFNGLVERTEXSTREAM3SVATIPROC)wglGetProcAddress("glVertexStream3svATI");
	glVertexStream3iATI = (PFNGLVERTEXSTREAM3IATIPROC)wglGetProcAddress("glVertexStream3iATI");
	glVertexStream3ivATI = (PFNGLVERTEXSTREAM3IVATIPROC)wglGetProcAddress("glVertexStream3ivATI");
	glVertexStream3fATI = (PFNGLVERTEXSTREAM3FATIPROC)wglGetProcAddress("glVertexStream3fATI");
	glVertexStream3fvATI = (PFNGLVERTEXSTREAM3FVATIPROC)wglGetProcAddress("glVertexStream3fvATI");
	glVertexStream3dATI = (PFNGLVERTEXSTREAM3DATIPROC)wglGetProcAddress("glVertexStream3dATI");
	glVertexStream3dvATI = (PFNGLVERTEXSTREAM3DVATIPROC)wglGetProcAddress("glVertexStream3dvATI");
	
	glVertexStream4sATI = (PFNGLVERTEXSTREAM4SATIPROC)wglGetProcAddress("glVertexStream4sATI");
	glVertexStream4svATI = (PFNGLVERTEXSTREAM4SVATIPROC)wglGetProcAddress("glVertexStream4svATI");
	glVertexStream4iATI = (PFNGLVERTEXSTREAM4IATIPROC)wglGetProcAddress("glVertexStream4iATI");
	glVertexStream4ivATI = (PFNGLVERTEXSTREAM4IVATIPROC)wglGetProcAddress("glVertexStream4ivATI");
	glVertexStream4fATI = (PFNGLVERTEXSTREAM4FATIPROC)wglGetProcAddress("glVertexStream4fATI");
	glVertexStream4fvATI = (PFNGLVERTEXSTREAM4FVATIPROC)wglGetProcAddress("glVertexStream4fvATI");
	glVertexStream4dATI = (PFNGLVERTEXSTREAM4DATIPROC)wglGetProcAddress("glVertexStream4dATI");
	glVertexStream4dvATI = (PFNGLVERTEXSTREAM4DVATIPROC)wglGetProcAddress("glVertexStream4dvATI");
	
	glNormalStream3bATI = (PFNGLNORMALSTREAM3BATIPROC)wglGetProcAddress("glNormalStream3bATI");
	glNormalStream3bvATI = (PFNGLNORMALSTREAM3BVATIPROC)wglGetProcAddress("glNormalStream3bvATI");
	glNormalStream3sATI = (PFNGLNORMALSTREAM3SATIPROC)wglGetProcAddress("glNormalStream3sATI");
	glNormalStream3svATI = (PFNGLNORMALSTREAM3SVATIPROC)wglGetProcAddress("glNormalStream3svATI");
	glNormalStream3iATI = (PFNGLNORMALSTREAM3IATIPROC)wglGetProcAddress("glNormalStream3iATI");
	glNormalStream3ivATI = (PFNGLNORMALSTREAM3IVATIPROC)wglGetProcAddress("glNormalStream3ivATI");
	glNormalStream3fATI = (PFNGLNORMALSTREAM3FATIPROC)wglGetProcAddress("glNormalStream3fATI");
	glNormalStream3fvATI = (PFNGLNORMALSTREAM3FVATIPROC)wglGetProcAddress("glNormalStream3fvATI");
	glNormalStream3dATI = (PFNGLNORMALSTREAM3DATIPROC)wglGetProcAddress("glNormalStream3dATI");
	glNormalStream3dvATI = (PFNGLNORMALSTREAM3DVATIPROC)wglGetProcAddress("glNormalStream3dvATI");
	#endif


	#ifdef GL_EXT_blend_color
	glBlendColorEXT = (PFNGLBLENDCOLOREXTPROC)wglGetProcAddress("glBlendColorEXT");
	#endif


	#ifdef GL_EXT_blend_func_separate
	glBlendFuncSeparateEXT = (PFNGLBLENDFUNCSEPARATEEXTPROC)wglGetProcAddress("glBlendFuncSeparateEXT");
	#endif


	#ifdef GL_EXT_blend_minmax
	glBlendEquationEXT = (PFNGLBLENDEQUATIONEXTPROC)wglGetProcAddress("glBlendEquationEXT");
	#endif


	#ifdef GL_EXT_draw_range_elements
	glDrawRangeElementsEXT = (PFNGLDRAWRANGEELEMENTSEXTPROC)wglGetProcAddress("glDrawRangeElementsEXT");
	#endif


	#ifdef GL_EXT_fog_coord
	glFogCoordfEXT = (PFNGLFOGCOORDFEXTPROC)wglGetProcAddress("glFogCoordfEXT");
	glFogCoorddEXT = (PFNGLFOGCOORDDEXTPROC)wglGetProcAddress("glFogCoorddEXT");
	glFogCoordfvEXT = (PFNGLFOGCOORDFVEXTPROC)wglGetProcAddress("glFogCoordfvEXT");
	glFogCoorddvEXT = (PFNGLFOGCOORDDVEXTPROC)wglGetProcAddress("glFogCoorddvEXT");
	glFogCoordPointerEXT = (PFNGLFOGCOORDPOINTEREXTPROC)wglGetProcAddress("glFogCoordPointerEXT");
	#endif


	#ifdef GL_EXT_polygon_offset
	glPolygonOffsetEXT = (PFNGLPOLYGONOFFSETEXTPROC)wglGetProcAddress("glPolygonOffsetEXT");
	#endif


	#ifdef GL_EXT_texture3D
	glTexImage3DEXT = (PFNGLTEXIMAGE3DEXTPROC)wglGetProcAddress("glTexImage3DEXT");
	#endif


	#ifdef GL_NV_occlusion_query
	glGenOcclusionQueriesNV = (PFNGLGENOCCLUSIONQUERIESNVPROC)wglGetProcAddress("glGenOcclusionQueriesNV");
	glDeleteOcclusionQueriesNV = (PFNGLDELETEOCCLUSIONQUERIESNVPROC)wglGetProcAddress("glDeleteOcclusionQueriesNV");
	glIsOcclusionQueryNV = (PFNGLISOCCLUSIONQUERYNVPROC)wglGetProcAddress("glIsOcclusionQueryNV");
	glBeginOcclusionQueryNV = (PFNGLBEGINOCCLUSIONQUERYNVPROC)wglGetProcAddress("glBeginOcclusionQueryNV");
	glEndOcclusionQueryNV = (PFNGLENDOCCLUSIONQUERYNVPROC)wglGetProcAddress("glEndOcclusionQueryNV");
	glGetOcclusionQueryivNV = (PFNGLGETOCCLUSIONQUERYIVNVPROC)wglGetProcAddress("glGetOcclusionQueryivNV");
	glGetOcclusionQueryuivNV = (PFNGLGETOCCLUSIONQUERYUIVNVPROC)wglGetProcAddress("glGetOcclusionQueryuivNV");
	#endif


	#ifdef GL_NV_register_combiners
	glCombinerParameterfvNV = (PFNGLCOMBINERPARAMETERFVNVPROC)wglGetProcAddress("glCombinerParameterfvNV");
	glCombinerParameterfNV = (PFNGLCOMBINERPARAMETERFNVPROC)wglGetProcAddress("glCombinerParameterfNV");
	glCombinerParameterivNV = (PFNGLCOMBINERPARAMETERIVNVPROC)wglGetProcAddress("glCombinerParameterivNV");
	glCombinerParameteriNV = (PFNGLCOMBINERPARAMETERINVPROC)wglGetProcAddress("glCombinerParameteriNV");
	
	glCombinerInputNV = (PFNGLCOMBINERINPUTNVPROC)wglGetProcAddress("glCombinerInputNV");
	glCombinerOutputNV = (PFNGLCOMBINEROUTPUTNVPROC)wglGetProcAddress("glCombinerOutputNV");
	glFinalCombinerInputNV = (PFNGLFINALCOMBINERINPUTNVPROC)wglGetProcAddress("glFinalCombinerInputNV");

	glGetCombinerInputParameterfvNV = (PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC)wglGetProcAddress("glGetCombinerInputParameterfvNV");
	glGetCombinerInputParameterivNV = (PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC)wglGetProcAddress("glGetCombinerInputParameterivNV");
	glGetCombinerOutputParameterfvNV = (PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC)wglGetProcAddress("glGetCombinerOutputParameterfvNV");
	glGetCombinerOutputParameterivNV = (PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC)wglGetProcAddress("glGetCombinerOutputParameterivNV");

	glGetFinalCombinerInputParameterfvNV = (PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC)wglGetProcAddress("glGetFinalCombinerInputParameterfvNV");
	glGetFinalCombinerInputParameterivNV = (PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC)wglGetProcAddress("glGetFinalCombinerInputParameterivNV");
	#endif


	#ifdef WGL_ARB_pbuffer
	wglCreatePbufferARB = (PFNWGLCREATEPBUFFERARBPROC)wglGetProcAddress("wglCreatePbufferARB");
	wglGetPbufferDCARB = (PFNWGLGETPBUFFERDCARBPROC)wglGetProcAddress("wglGetPbufferDCARB");
	wglReleasePbufferDCARB = (PFNWGLRELEASEPBUFFERDCARBPROC)wglGetProcAddress("wglReleasePbufferDCARB");
	wglDestroyPbufferARB = (PFNWGLDESTROYPBUFFERARBPROC)wglGetProcAddress("wglDestroyPbufferARB");
	wglQueryPbufferARB = (PFNWGLQUERYPBUFFERARBPROC)wglGetProcAddress("wglQueryPbufferARB");
	#endif


	#ifdef WGL_ARB_render_texture
	wglBindTexImageARB = (PFNWGLBINDTEXIMAGEARBPROC)wglGetProcAddress("wglBindTexImageARB");
	wglReleaseTexImageARB = (PFNWGLRELEASETEXIMAGEARBPROC)wglGetProcAddress("wglReleaseTexImageARB");
	wglSetPbufferAttribARB = (PFNWGLSETPBUFFERATTRIBARBPROC)wglGetProcAddress("wglSetPbufferAttribARB");
	#endif

}

}; };

