#include "graphics3d.context.h"
#include "graphics3d.texturematerial.h"
#include "graphics3d.texture.h"
#include "graphics3d.vertexformat.h"

#include "object.inl"
#include "base.string.inl"
#include "system.thread.inl"
#include "graphics.colour.inl"
#include "graphics3d.context.inl"
#include "graphics3d.material.inl"
#include "graphics3d.colourmaterial.inl"
#include "graphics3d.texturematerial.inl"
#include "graphics3d.texture.inl"
#include "graphics3d.texturestack.inl"
#include "graphics3d.ressource.inl"
#include "graphics3d.vertexformat.inl"


namespace magnum { namespace graphics3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
TextureMaterial::~TextureMaterial() {
	for (int i = 0; i < Texture::MaxTextures; i++) {
		if (m_Texture[i] != NULL) {
			m_Texture[i]->release();
			m_Texture[i] = NULL;
		}
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
TextureMaterial* TextureMaterial::create() {
	return new TextureMaterial();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void TextureMaterial::onSelect() const {
	selectAmbient();
	selectDiffuse();
	selectSpecular();
	selectEmission();
	selectShininess();
	if (getTexture(0) != NULL)
		selectTexture(0);
	if (getTexture(1) != NULL)
		selectTexture(1);
	if (getTexture(2) != NULL)
		selectTexture(2);
}


}; };
