/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "media.handler.h"
#include "media.buffer.h"

#include "object.inl"
#include "base.string.inl"
#include "media.handler.inl"
#include "media.buffer.inl"


namespace magnum { namespace media {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::handleMessage(const Message& msg) {
	switch (msg.getCommand()) {
		case Message::Connect:
			return onConnect(msg.getPin());
		case Message::Disconnect:
			return onDisconnect(msg.getPin());
		case Message::ReceiveBuffer:
			return onReceiveBuffer((InputPin *)msg.getPin(), (Buffer *)msg.getPointer());
		case Message::SendBuffer:
			return onSendBuffer((OutputPin *)msg.getPin(), (Buffer *)msg.getPointer());
		case Message::RequestBuffer:
			return onRequestBuffer((OutputPin *)msg.getPin());
		case Message::Start:
			return onStart();
		case Message::Stop:
			return onStop();
		case Message::Pause:
			return onPause();
		case Message::Unpause:
			return onUnpause();
		case Message::SetFormat:
			return onSetFormat(msg.getPin(), (Format *)msg.getPointer());
		default:
			return false;
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onConnect(Pin* ) {
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onDisconnect(Pin* ) {
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onReceiveBuffer(InputPin* ,Buffer* ) {
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onSendBuffer(OutputPin* ,Buffer* ) {
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onRequestBuffer(OutputPin* ) {
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onStart() {
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onStop() {
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onPause() {
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onUnpause() {
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Handler::onSetFormat(Pin* ,const Format* ) {
	return true;
}



}; };
