/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "scene3d.audioqueue.h"
#include "scene3d.geometry.h"
#include "scene3d.modifier.h"
#include "scene3d.soundnode.h"

#include "container.iterator.inl"
#include "container.chain.inl"
#include "scene3d.audioqueue.inl"


namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
AudioQueue::AudioQueue(Observer* o) {
	ASSERT(o != NULL);
	m_Observer = o;
	m_Universe = o->getUniverse();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
AudioQueue::~AudioQueue() {
	clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void AudioQueue::clear() {
	while(!m_ActiveSounds.isEmpty()) {
		SoundNode* n = (SoundNode*)m_ActiveSounds.begin();
		n->clearFlag(Node::ActiveSound);
		m_ActiveSounds.remove(n);
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void AudioQueue::listen() {
	// Process all sound nodes
	magnum::container::Chain<SoundNode>::Iterator iter;
	iter = m_ActiveSounds.begin();
	while(iter != m_ActiveSounds.end()) {
		SoundNode* node = (SoundNode*)iter;
		iter++;
		//
		//
		// DAS HIER WIRD WOHL NICHT GANZ DAS RICHTIGE SEIN
		//
		//
		if (!node->testFlag(Node::ActiveSound)) {
			node->onStop();
			m_ActiveSounds.remove(node);
		} else {
			node->clearFlag(Node::ActiveSound);
		}
	}
}


}; };
